﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Xml;

namespace AlipayStatement
{
    public class AlipayStatementQuery
    {
        public string balance;
        public string buyer_account;
        public string currency;
        public string deposit_bank_no;
        public string goods_title;
        public string income;
        public string iw_account_log_id;
        public string memo;
        public string merchant_out_order_no;
        public string outcome;
        public string partner_id;
        public string rate;
        public string seller_account;
        public string seller_fullname;
        public string service_fee;
        public string service_fee_ratio;
        public string sign_product_name;
        public string sub_trans_code_msg;
        public string total_fee;
        public string trade_no;
        public string trade_refund_amount;
        public string trans_code_msg;
        public string trans_date;

    }

    internal static class AlipayStatementQueryBuilder
    {
        static AlipayStatementQueryBuilder()
        {
            var fields = typeof(AlipayStatementQuery).GetFields();
            foreach (var field in fields)
            {
                fieldmaps.Add(field.Name, field);
            }
        }

        private static Dictionary<string, FieldInfo> fieldmaps = new Dictionary<string, FieldInfo>();
        /// <summary>
        /// construct AlipayStatementQuery from xml node, make sure both have exact same fields.
        /// </summary>
        /// <param name="node"></param>
        /// <returns></returns>
        internal static AlipayStatementQuery FromXmlNode(XmlNode node)
        {
            AlipayStatementQuery result = new AlipayStatementQuery();
            
            var child = node.FirstChild;
            while (child != null)
            {
                if (fieldmaps.ContainsKey(child.Name))
                {
                    fieldmaps[child.Name].SetValue(result, child.InnerText);
                }
                else
                {
                    throw new Exception("AlipayStatementQuery properties and Xml result don't match");
                }
                child = child.NextSibling;
            }

            foreach(var field in fieldmaps)
            {
                if (field.Value.GetValue(result) == null)
                {
                    //throw new Exception("AlipayStatementQuery properties and Xml result don't match");
                }
            }
            return result;
        }
    }
}
