﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Collections.Generic;

namespace AlipayStatementUnitTest
{
    [TestClass]
    public class UnitTest1
    {
        [TestMethod]
        public void TestMethod1()
        {
            AlipayStatement.AlipayStatementDownloader downloader = new AlipayStatement.AlipayStatementDownloader();
            List<AlipayStatement.AlipayStatementQuery> results = new List<AlipayStatement.AlipayStatementQuery>();
            string errorCode = "";
            
            try
            {
                // TODO: need to test multiple pages. currently we don't have enough data points.

                bool isSuccessed = downloader.Download(new DateTime(2015, 12, 24), results, out errorCode);
                Assert.IsTrue(isSuccessed);
                Assert.AreEqual(results.Count, 1);
                Assert.AreEqual(results[0].total_fee, "0.01");
                Assert.AreEqual(results[0].trade_no, "2016030221001004920239415860");

                results.Clear();
                isSuccessed = downloader.Download(new DateTime(2016, 3, 4), results, out errorCode);
                Assert.IsTrue(isSuccessed);
                Assert.AreEqual(results.Count, 0);
            }
            catch(Exception e)
            {
                Assert.Fail(e.Message);
            }
        }
    }
}
