﻿
namespace CCSPrototypeCommon
{

    using System;
    using System.Data.Entity;

    public class ActionsContextFactory : DBEFContextFactoryBase
    {
        private static ActionsContextFactory _singletonInstance;

        protected ActionsContextFactory(string sqlConnString)
            : base(sqlConnString)
        {
            _singletonInstance = null;
        }

        public static DBEFContextFactoryBase GetInstance()
        {
            if (_singletonInstance == null)
            {
                string sqlConnString = ConfigurationMgr.GetSetting("BillDbConnectionString");
                _singletonInstance = new ActionsContextFactory(sqlConnString);
            }
            return (DBEFContextFactoryBase)_singletonInstance;
        }

        public override DbContext GetDBEFContext()
        {
            var actionsContext = new ActionsContext(SQLConnString);
            actionsContext.Database.CreateIfNotExists();
            return actionsContext;
        }
    }
}
