﻿
namespace CCSPrototypeCommon
{

    using System;
    using System.Data.Entity;

    public class AmountDueContextFactory : DBEFContextFactoryBase
    {
        private static AmountDueContextFactory _singletonInstance;

        protected AmountDueContextFactory(string sqlConnString)
            : base(sqlConnString)
        {
            _singletonInstance = null;
        }

        public static DBEFContextFactoryBase GetInstance()
        {
            if (_singletonInstance == null)
            {
                string sqlConnString = ConfigurationMgr.GetSetting("BillDbConnectionString");
                _singletonInstance = new AmountDueContextFactory(sqlConnString);
            }
            return (DBEFContextFactoryBase)_singletonInstance;
        }

        public override DbContext GetDBEFContext()
        {
            var amountDueContext = new AmountDueContext(SQLConnString);
            amountDueContext.Database.CreateIfNotExists();
            return amountDueContext;
        }
    }
}
