﻿
namespace CCSPrototypeCommon
{

    using System;
    using System.Data.Entity;

    public class BillContextFactory : DBEFContextFactoryBase
    {
        private static BillContextFactory _singletonInstance;

        protected BillContextFactory(string sqlConnString)
            : base(sqlConnString)
        {
            _singletonInstance = null;
        }

        public static DBEFContextFactoryBase GetInstance()
        {
            if (_singletonInstance == null)
            {
                string sqlConnString = ConfigurationMgr.GetSetting("BillDbConnectionString");
                _singletonInstance = new BillContextFactory(sqlConnString);
            }
            return (DBEFContextFactoryBase)_singletonInstance;
        }

        public override DbContext GetDBEFContext()
        {
            var billContext = new BillContext(SQLConnString);
            billContext.Database.CreateIfNotExists();
            return billContext;
        }
    }
}
