﻿
namespace CCSPrototypeCommon
{

    using System;
    using System.Data.SqlClient;

    public class SQLConnFactory
    {
        private static SQLConnFactory _singletonInstance;

        public string SQLConnString { get; private set; }

        protected SQLConnFactory(string sqlConnString)
        {
            _singletonInstance = null;
            SQLConnString = sqlConnString;
        }

        public static SQLConnFactory GetInstance()
        {
            if (_singletonInstance == null)
            {
                string sqlConnString = ConfigurationMgr.GetSetting("BillDbConnectionString");
                _singletonInstance = new SQLConnFactory(sqlConnString);
            }
            return (SQLConnFactory)_singletonInstance;
        }

        public SqlConnection GetSqlConnection()
        {
            return new SqlConnection(SQLConnString);
        }
    }
}
