﻿
namespace CCSPrototypeCommon
{

    using System;
    using System.Data.Entity;

    public class ViewsContextFactory : DBEFContextFactoryBase
    {
        private static ViewsContextFactory _singletonInstance;

        protected ViewsContextFactory(string sqlConnString)
            : base(sqlConnString)
        {
            _singletonInstance = null;
        }

        public static DBEFContextFactoryBase GetInstance()
        {
            if (_singletonInstance == null)
            {
                string sqlConnString = ConfigurationMgr.GetSetting("BillDbConnectionString");
                _singletonInstance = new ViewsContextFactory(sqlConnString);
            }
            return (DBEFContextFactoryBase)_singletonInstance;
        }

        public override DbContext GetDBEFContext()
        {
            var viewsContext = new ViewsContext(SQLConnString);
            viewsContext.Database.CreateIfNotExists();
            return viewsContext;
        }
    }
}
