﻿
namespace CCSPrototypeCommon
{

    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;

    public class CCS_Bill_Joined_V1
    {
        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public long BillRecID { get; set; }

        public Guid BillID { get; set; }

        [ForeignKey("BillID")]
        public virtual CCS_Bill_V1 BillTable { get; set; }
        
        public string BillType { get; set; }

        public Guid CustomerID { get; set; }

        [ForeignKey("CustomerID")]
        public virtual CCS_Customer_V1 CustomerTable { get; set; }

        public Guid UserID { get; set; }

        [ForeignKey("UserID")]
        public virtual CCS_User_V1 UserTable { get; set; }

        public double AmountDue { get; set; }

        [DisplayName("账务月份")]
        [DataType(DataType.Date)]
        public DateTime BillPeriod { get; set; }

        [DisplayName("名(不包含姓氏)")]
        public string FirstName { get; set; }

        [DisplayName("姓氏")]
        public string LastName { get; set; }

        [DisplayName("手机号码")]
        public string Cellphone { get; set; }

        [DisplayName("额外电话号码")]
        public string SecondPhone { get; set; }

        [DisplayName("电子邮箱地址")]
        public string Email { get; set; }

        [DisplayName("地址")]
        public string Address { get; set; }

        [DisplayName("身份证号")]
        public string IDNumber { get; set; }

    }
}
