﻿namespace CCSPrototypeCommon
{

    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.ModelConfiguration;
    public class CCS_Daily_Payment_V1
    {
        public long ID { get; set; }
        public String CustomerID { get; set; }

        [DisplayName("日期")]
        [DisplayFormat(DataFormatString = "{0:MM/dd/yyyy}")]
        public DateTime? SnapshotDate { get; set; }

        [DisplayName("缴费角色")]
        public int? PayerRole { get; set; }

        [DisplayName("缴费金额")]
        public double Payment { get; set; }

        [DisplayName("缴费角色")]
        public String PaymentRoleStr { get { return ParseOperationLevel(PayerRole); } }
        public String ParseOperationLevel(int? role)
        {

            switch (role)
            {
                case (int)OperationLevel.Vendor:
                    return OperationLevel.Vendor.ToString();
                case (int)OperationLevel.Staff:
                    return OperationLevel.Staff.ToString();

                case (int)OperationLevel.Gatherer:
                    return OperationLevel.Gatherer.ToString();

                case (int)OperationLevel.MeterReader:
                    return OperationLevel.MeterReader.ToString();

                case (int)OperationLevel.Consumer:
                    return OperationLevel.Consumer.ToString();

                case (int)OperationLevel.Admin:
                    return OperationLevel.Admin.ToString();
                case (int)OperationLevel.SysAdmin:
                    return OperationLevel.SysAdmin.ToString();

            }
            return OperationLevel.Unkown.ToString();
        }



    }
}
