﻿using System;
using System.Web;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace CCSPrototypeCommon
{
    public class CCS_Payment_AliPayNotif_V1
    {
        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public Guid PaymentNotifID { get; set; }

        public Guid PaymentInfoID { get; set; }

        [ForeignKey("PaymentInfoID")]
        public virtual CCS_PaymentInfo_V1 PaymentInfo { get; set; }

        [DisplayName("Payment TradeNo 缴费交易号")]
        public string PaymentTradeNo { get; set; }

        [DisplayName("Payment Buyer_email 缴费者电子邮件")]
        public string PaymentBuyerEmail { get; set; }

        [DisplayName("Payment Subject 缴费项目")]
        public string PaymentSubject { get; set; }

        [DisplayName("Payment Discount 缴费折扣")]
        public double? PaymentDiscount { get; set; }
       
        [DisplayName("Payment Type 缴费种类")]
        public int? PaymentType { get; set; }



        [DisplayName("Payment Notify Type 缴费通知种类")]
        public string PaymentNotifyType { get; set; }

       
        [DisplayName("Payment Quantity")]
        public int? PaymentQuantity { get; set; }

        [DisplayName("Payment Create Time 缴费日期")]
        [DisplayFormat(DataFormatString = "{0:yyyy年MM月dd日}")]
        public DateTime PaymentCreateTime { get; set; }

        [DisplayName("Payment Seller ID 缴费目标ID")]
        public string PaymentSellerID { get; set; }

        [DisplayName("Payment Notify Time 缴费通知日期")]
        [DisplayFormat(DataFormatString = "{0:yyyy年MM月dd日}")]
        public DateTime PaymentNotifyTime { get; set; }

        [DisplayName("Payment Body 缴费说明")]
        public string PaymentBody { get; set; }

        [DisplayName("Payment Trade Status 缴费交易状态")]
        public string PaymentTradeStatus { get; set; }

        [DisplayName("Payment Is Total Fee Adjust 手续费调整")]
        public string PaymentIsTotalFeeAdjust { get; set; }

        [DisplayName("Payment Total Fee 手续费")]
        public double? PaymentTotalFee{ get; set; }

        [DisplayName("Payment GMT Payment Time 缴费时间(格林尼治时间)")]
        [DisplayFormat(DataFormatString = "{0:yyyy年MM月dd日}")]
        public DateTime PaymentGMTPayment { get; set; }
        
        [DisplayName("Payment Seller Email 缴费目标电子邮件")]
        public string PaymentSellerEmail { get; set; }

        [DisplayName("Payment Price 缴费价格")]
        public double? PaymentPrice{ get; set; }

        [DisplayName("Payment NotifyID 通知ID")]
        public string PaymentNotifyID { get; set; }

        [DisplayName("Payment UseCoupon 使用优惠券")]
        public string PaymentUseCoupon { get; set; }

        [DisplayName("Payment SignType 签名类型")]
        public string PaymentSignType { get; set; }

        [DisplayName("Payment Sign 缴费签名")]
        public string PaymentSign { get; set; }

        [DisplayName("Wechat App Id 微信ID")]
        public string WeChatAppId { get; set; }

        [DisplayName("Wechat Bank Type 微信银行ID")]
        public string WeChatBankType { get; set; }

        [DisplayName("Wechat Cash Fee 微信现金手续费")]
        public double WeChatCashFee { get; set; }

        [DisplayName("Wechat Fee Type 微信手续费类型")]
        public string WeChatFeeType { get; set; }

        [DisplayName("Wechat Is Subscribe 微信订阅状态")]
        public string WeChatIsSubscribe { get; set; }

        [DisplayName("Wechat Merchant Id 微信商户ID")]
        public string WeChatMchId { get; set; }

        [DisplayName("Wechat Nonce 微信临时数据")]
        public string WeChatNonce { get; set; }

        [DisplayName("Wechat OpenId 微信调用ID")]
        public string WeChatOpenId { get; set; }

        [DisplayName("Wechat ResultCode 微信调用结果")]
        public string WeChatResultCode { get; set; }

        [DisplayName("Wechat Return Code 微信返回值")]
        public string WeChatReturnCode { get; set; }

        [DisplayName("Wechat Sign 微信签名")]
        public string WeChatSign { get; set; }

        [DisplayName("Wechat Time End 微信结束时间")]
        public string WeChatTimeEnd { get; set; }

        [DisplayName("Wechat Total Fee 微信手续费")]
        public double WeChatTotalFee { get; set; }

        [DisplayName("Wechat Trade Type 微信交易类型")]
        public string WeChatTradeType { get; set; }

        [DisplayName("Wechat Transaction Id 微信交易流水ID")]
        public string WeChatTransactionId { get; set; }
    }
}
