﻿using System;
using System.Web;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace CCSPrototypeCommon
{
    public class CCS_Payment_Statement_Wechat_V1
    {
        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public Guid StatementID { get; set; }
        public string TradeTime { get; set; } //交易时间
        public string WxAppId { get; set; } //公众账号ID
        public string MerchantId { get; set; } //商户号
        public string SubMerchantId { get; set; } //子商户号
        public string DeviceId { get; set; } //设备号
        public string WxOrderId { get; set; } //微信订单号
        public string MerchantOrderId { get; set; } //商户订单号

        public string UserId { get; set; } //用户标识
        public string TransactionType { get; set; } //交易类型
        public string TransactionStatus { get; set; } //交易状态
        public string PayerBank { get; set; } //付款银行
        public string CurrencyType { get; set; } //货币种类
        public double TotalPaymentAmount { get; set; } //总金额
        public double TotalCouponPaymentAmount { get; set; } //代金券或立减优惠金额

        public string ProductName { get; set; } //商品名称
        public string ProductDescription { get; set; } //商户数据包
        public double ProcessingFee { get; set; } //手续费
        public string ProcessingFeeRate { get; set; } //费率


        // CURRENTLY we only support two kinds of Wechat statemnt: SUCCESS and REFUND.
        // below WxRefundId being 0 means SUCCESS, otherwise REFUND.

        public string WxRefundId { get; set; } //微信退款单号
        public string MerchantRefundId { get; set; } //商户退款单号
        public double RefundAmount { get; set; } //退款金额
        public double RefundCouponAmount { get; set; } //代金券或立减优惠退款金额
        public string RefundType { get; set; } //退款类型
        public string RefundStatus { get; set; } //退款状态

    }

    public class CCS_Payment_Statement_Alipay_V1
    {
        [Key]
         [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public Guid StatementID { get; set; }

        public string balance { get; set; }

        public string buyer_account { get; set; }

        public string currency { get; set; }

        public string deposit_bank_no { get; set; }

        public string goods_title { get; set; }

        public string income { get; set; }

        public string iw_account_log_id { get; set; }

        public string memo { get; set; }

        public string merchant_out_order_no { get; set; }

        public string outcome { get; set; }

        public string partner_id { get; set; }

        public string rate { get; set; }

      
        public string seller_account { get; set; }

        public string seller_fullname { get; set; }

        public string service_fee { get; set; }

        public string service_fee_ratio { get; set; }

       
        public string sign_product_name { get; set; }

        public string sub_trans_code_msg { get; set; }

        public string total_fee { get; set; }

        public string trade_no { get; set; }

      
        public string trade_refund_amount { get; set; }

     
        public string trans_code_msg { get; set; }

        public string trans_date { get; set; }
    }

    class CCS_Payment_Statement_V1
    {
        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public Guid StatementID { get; set; }


        [DisplayName("Payment TradeNo 缴费交易号")]
        public string PaymentOutTradeNo { get; set; }

        [DisplayName("支付金额")]
        [DisplayFormat(DataFormatString = "{0:F2}", ApplyFormatInEditMode = true)]
        public double Amount { get; set; }

    }
}
