﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CCSPrototypeCommon
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;


    public class CCS_PhoneData_V1
    {
        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public Guid PhoneID { get; set; }

        [MaxLength(20)]
        [DisplayName("设备编号")]
        public string PhoneUUID { get; set; }

        [DisplayName("密码")]
        public string PhoneAccessCode { get; set; }

        [DisplayName("电话号码")]
        public string PhoneInfo { get; set; }

        [DisplayName("备注")]
        public string Memo { get; set; }

        [DisplayName("注销时间")]
        [DisplayFormat(DataFormatString = "{0:yyyy-MM-dd HH:mm:ss}", ApplyFormatInEditMode = true)]
        public DateTime? DisabledDate { get; set; }

        public Guid CustomerID { get; set; }

        [ForeignKey("CustomerID")]
        public virtual CCS_Customer_V1 CustomerTable { get; set; }

        [DisplayName("更新时间")]
        [DisplayFormat(DataFormatString = "{0:yyyy-MM-dd HH:mm:ss}", ApplyFormatInEditMode = true)]
        public DateTime ModifiedDate { get; set; }
    }

}
