﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CCSPrototypeCommon
{
    public class CCS_SubscriptionPayment_V1
    {
        /// <summary>
        /// Payment ID is the primary key of this table
        /// </summary>
        [Key]
        public Guid PaymentID { get; set; }

        [DisplayName("缴费者类型")]
        public OperationLevel? PayerRole { get; set; }

        [DisplayName("支付手机")]
        public string PaymentCellNumber { get; set; }

        [DisplayName("支付时间")]
        [DisplayFormat(DataFormatString = "{0:yyyy年MM月dd日}", ApplyFormatInEditMode = true)]
        public DateTime PaySubmitTime { get; set; }

        [Required]
        [DisplayName("续费月数")]
        public int ExtendMonth { get; set; }

        [DisplayName("支付金额")]
        [DisplayFormat(DataFormatString = "{0:F2}", ApplyFormatInEditMode = true)]
        public double Amount { get; set; }

        public Guid StaffID { get; set; }

        [ForeignKey("StaffID")]
        public virtual CCS_Staff_V1 SubscriberStaff { get; set; }

    }
}
