﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel.DataAnnotations;
using System.Linq.Expressions;

namespace CCSPrototypeCommon.Query
{
    public enum GuidComparators
    {
        [Display(Name = "==")]
        Equals
    }

    [Serializable]
    public class GuidFilter : AbstractFilter
    {
        public Guid? SearchTerm { get; set; }

        public GuidComparators Comparator { get; set; }

        public GuidFilter()
        {

        }

        public GuidFilter(Guid baseSearchID)
        {
            this.BaseSearchID = baseSearchID;
        }

        protected override Expression BuildFilterExpression(Expression property)
        {
            if (this.SearchTerm == null || this.SearchTerm == Guid.Empty)
            {
                return null;
            }

            Expression searchExpression =  Expression.Equal(property, Expression.Constant(this.SearchTerm.Value));

            return searchExpression;
        }



    }
}
