﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CCSPrototypeCommon.Actions;
namespace CCSPrototypeCommon
{
    public enum ACTIONSTYPE
    {
        ADDTOFAVORITES,
        REMOVEFROMFAVORITES,
        ADDFEEDBACK
    }

    public enum WECHATAPPTYPE
    {
        USER,
        VENDOR
    }

    public static partial class Constants
    {
        public static Dictionary<ACTIONSTYPE, BaseAction> actionTypeToObjectMap = new Dictionary<ACTIONSTYPE, BaseAction> 
        {
            {ACTIONSTYPE.ADDTOFAVORITES, new AddToFavoritesAction()}
        };

        public static Dictionary<ACTIONSTYPE, String> actionTypeToParametersFormatMap = new Dictionary<ACTIONSTYPE, String> 
        {
            {ACTIONSTYPE.ADDTOFAVORITES, "userid={0};staffid={1}"},
            {ACTIONSTYPE.REMOVEFROMFAVORITES, "userid={0};staffid={1}"},
            {ACTIONSTYPE.ADDFEEDBACK, "userid={0};staffid={1}"}
        };

        public const string PushNotifThumbprint = @"6E740E66571B5C4B37843CA70E400FDA73B0F9DD";
        public const string PushNotifThumbprintSandbox = @"926016C0B1C763FB14D53F5E92A508E4E190FC37";
        public const int PushNotifMaxLength = 200;
        public const string OurCompanyName = "云通空间测试";
        public const string BillCsvTemplateTableName = "billcsvcolumnmapping";
        public const string CsvTemplateTableName = "csvcolumnmapping";
        public const string MeterDataTempTable = "#Tmp_MeterDataMerge";
        public const string UploadPaymentDataTempTable = "#Tmp_UploadPaymentDataMerge";
        public const string MeterDataTable = "[dbo].[CCS_MeterData_V1]";
        public const string UploadedPaymentDataTable = "[dbo].[CCS_UploadedPayment_V1]";
        public const string BillDataTable = "[dbo].[CCS_Bill_V1]";
        public const string UserDataTable = "[dbo].[CCS_User_V1]";
        public const string MeterTemplateName = "meterprofile";
        public const string UploadPaymentTemplateName = "uploadpaymentheader";
        public const string FeedbackBlobContainerName = "advertising";
        public const string AdsBlobContainerName = "advertising";
        public const string AdsBlobArchiveContainerName = "advertisingarchive";
        public const string AdsMultimediaBlobContainerName = "advertisingmedia";
        public const string VendorProfilePictureBlobContainerName = "vendorprofilepic";
        public const string BillStorageName = "bill";
        public const string UploadedPaymentsStorageName = "uploadedpayments";
        public const string RawDataStorageName = "rawdata";
        public const string QueryStorageName = "query";
        public const string QueryInitStorageName = "queryinit";
        public const string QueryDownloadStorageName = "querydownload";
        public const string MeterProfileStorageName = "meterprofile";
        public const string PaymentStorageName = "payment";
        public const string NewBillTypeDeclaration = "Create a new bill type";

        public const string AliPayNotifSubject = "subject";
        public const string AliPayNotifTradeNo = "trade_no";
        public const string AliPayNotifBuyerEmail = "buyer_email";

        public const string AliPayNotifDiscount = "discount";
        public const string AliPayNotifType = "payment_type";
        public const string AliPayNotifCreateTime = "gmt_create";
        public const string AliPayNotifNotifyType = "notify_type";
        public const string AliPayNotifQuantity = "quantity";
        public const string AliPayNotifSellerID = "seller_id";
        public const string AliPayNotifNotifyTime = "notify_time";
        public const string AliPayNotifBody = "body";
        public const string AliPayNotifTradeStatus = "trade_status";
        public const string AliPayNotifIsTotalFeeAdjust = "is_total_fee_adjust";
        public const string AliPayNotifTotalFee = "total_fee";
        public const string AliPayNotifGMTPayment = "gmt_payment";
        public const string AliPayNotifSellerEmail = "seller_email";
        public const string AliPayNotifPrice = "price";
        public const string AliPayNotifNotifyID = "notify_id";
        public const string AliPayNotifUseCoupon = "use_coupon";
        public const string AliPayNotifSignType = "sign_type";
        public const string AliPayNotifSign = "sign";
        public const string AliPayNotifPaymentStatusSuccess = "TRADE_SUCCESS";

        public const string WeChatAppId = "appid";
        public const string WeChatBankType = "bank_type";
        public const string WeChatCashFee = "cash_fee";
        public const string WeChatFeeType = "fee_type";
        public const string WeChatIsSubscribe = "is_subscribe";
        public const string WeChatMchId = "mch_id";
        public const string WeChatNonce = "nonce_str";
        public const string WeChatOpenId = "openid";
        public const string WeChatResultCode = "result_code";
        public const string WeChatReturnCode = "return_code";
        public const string WeChatSign = "sign";
        public const string WeChatTimeEnd = "time_end";
        public const string WeChatTotalFee = "total_fee";
        public const string WeChatTradeType = "trade_type";
        public const string WeChatTransactionId = "transaction_id";
        public const string WeChatReturnMsg = "return_msg";
        public const string WeChatOutTradeNo = "out_trade_no";
        public const string WeChatNotifPaymentStatusSuccess = "SUCCESS";
        

        // we don't have a customer ID associated with WaterCompany user, for now use below hardcoded value.
        public const string DefaultWaterCompanyCustomerID = "E1581298-5894-44EE-8FE3-7017D09B206B";
        public const string DefaultPhoneNumberToSendPaymentConfirmation = "13263283480";

        // RawData collection mobile app android build version key name in Meta table
        public const string AndroidRawDataBuildVersion = "android_rawdata_buildversion";

        public const string StatementLastDownloadedDateWechatUser = "statement_last_downloaded_date_wechat_user";
        public const string StatementLastDownloadedDateWechatVender = "statement_last_downloaded_date_wechat_vender";
        public const string StatementLastDownloadedDateAlipay = "statement_last_downloaded_date_alipay";

        public const string StatementWechatVenderAppId = "WechatVenderAppID";
        public const string StatementWechatVenderMerchantID = "WechatVenderMerchantID";
        public const string StatementWechatVenderSecretKey = "WechatVenderSecretKey";
        public const string StatementWechatVenderPaymentKey = "WechatVenderPaymentKey";
        public const string StatementWechatUserAppId = "WechatUserAppID";
        public const string StatementWechatUserMerchantID = "WechatUserMerchantID";
        public const string StatementWechatUserSecretKey = "WechatUserSecretKey";
        public const string StatementWechatUserPaymentKey = "WechatUserPaymentKey";
    }

    // the constants that used as Session keys
    public static partial class SessionConstants
    {
        public const string CustomerID = "CustomerID";
        public const string CustomerName = "CustomerName";
        public const string CompanyLogo = "CompanyLogo";  //To be used in the future.

        public const string UserLoginMobileNumber = "UserMobilePhone";
        public const string UserLoginGuid = "UserLoginGuid";
        public const string UserIsAuthenticatedByPassword = "IsUserAuthenticatedByPassword";
        public const string UserIsAuthenticatedByVerificationCode = "IsUserAuthenticatedByVerificationCode";
    }

    public static partial class ErrorConstants
    {
        public const string NoAssociatedCompany = "Can't find an associated company for this user.";
    }
}
