﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CCSPrototypeCommon
{
    public class SMSManager
    {
        string smsUrl = @"http://222.73.117.158/msg/HttpBatchSendSM?account={0}&pswd={1}&mobile={2}&msg={3}&needstatus=true";
        string[] knownNumbers = new string[] {
 "18610242327",     //耿青涛：   
"13908656023",      //汪涛：     
 "13263283480",     //周湘宇：   
  "13391881975",              
  "18156542375",              
"18163318222",     // 张旻：     
 "13708502407",    // 唐婵婵：   
"15085549872",     // 娄泳：     
"13385190555",      //杨煦：     
 "13984965705",    // 谷红升：   
"18585341874",     // 李俊：     
 "15339501696",    // 梅松俊：   
 "13639255201",    // 余文波：   
"15377908223",     // 牟琳：     
 "18786941006",    // 闫文亮：   
 "13810664125",     //黄彧 
            };

       private static SMSManager smsManagerInstance;

       private SMSManager() { }

       public static SMSManager SmsManagerInstance
       {
          get 
          {
              if (smsManagerInstance == null)
             {
                 smsManagerInstance = new SMSManager();
             }
              return smsManagerInstance;
          }
       }

        public string SendSMSToPhone(string MobilePhone, string msg, Logger logger = null)
        {
            //            短信提交响应分为两行，第一行为响应时间和状态，第二行为服务器给出提交msgid。无论发送的号码是多少，一个发送请求只返回一个msgid，如果响应的状态不是“0”，则没有msgid即第二行数据。（每行以换行符(0x0a,即\n)分割）
            //1.3.2	示例
            //	提交成功

            //20110725160412,0
            //1234567890100

            //响应时间为20110725160412，响应状态为0 表明那个成功提交到服务器；1234567890100为返回的msgid，这个工状态报告匹配时使用。

            var smsUserName = Utility.ReadSetting("SMSUserName");
            var smsPassword = Utility.ReadSetting("SMSPassword");
            string errorMsg = "";
            if (smsUserName == "" || smsPassword == "")
            {
                errorMsg = "短信服务配置错误";
            }
            else if (knownNumbers.Contains(MobilePhone))
            {
                errorMsg = "短信服务返回格式错误";

                string url = string.Format(smsUrl, smsUserName, smsPassword, MobilePhone, msg);
                System.Net.WebRequest request = System.Net.WebRequest.CreateHttp(url);
                request.Method = "GET";
                var response = request.GetResponse();
                using (System.IO.StreamReader sr = new System.IO.StreamReader(response.GetResponseStream()))
                {
                    var content = sr.ReadToEnd();
                    var results = content.Split(new char[] { '\n' });
                    if (results.Count() > 0)
                    {
                        var subResults = results[0].Split(new char[] { ',' });
                        if (subResults.Count() == 2)
                        {
                            if (subResults[1] == "0")
                                errorMsg = "";   // no error.
                            else
                                errorMsg = "短信发送失败，错误代码：" + subResults[1];
                        }
                    }
                }
            }
            else
            {
                errorMsg = "测试阶段，显示验证码";
            }

            if (logger != null)
                logger.Info(string.Format("A new sms {0} was sent to {1} with the resulting error message {2}", msg, MobilePhone, errorMsg));
            return errorMsg;
        }

        public string SendVerificationCodeToPhone(string MobilePhone, string code)
        {
            string msg = "您请求的娄山云短信验证码是：" + code + "。该验证码10分钟内有效。如果您没有请求验证码，请忽略这条短信。";
            return SendSMSToPhone(MobilePhone,  msg);
               
        }


        public string SendPaymentConfirmationToPhone(string MobilePhone, double paymentAmount, Logger logger = null)
        {
            String msg = string.Format("{0:0.00} payment was made.", paymentAmount);
            return SendSMSToPhone(MobilePhone, msg, logger);
        }

    }
}
