﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CCSPrototypeCommon
{
    public static class StringExtensions
    {

        public static string TrimStart(this string input, string prefixToRemove)
        {
            if (input != null && prefixToRemove != null
              && input.StartsWith(prefixToRemove))
            {
                return input.Substring(prefixToRemove.Length, input.Length - prefixToRemove.Length);
            }
            else return input;
        }

        public static string TrimEnd(this string input, string suffixToRemove)
        {
            if (input != null && suffixToRemove != null
              && input.EndsWith(suffixToRemove))
            {
                return input.Substring(0, input.Length - suffixToRemove.Length);
            }
            else return input;
        }

        public static string SplitWithNewLine(this string input)
        {
            string[] lines = input.Split(new string[] { Environment.NewLine }, StringSplitOptions.None);
            string result = "";
            foreach(String line in lines)
            {
                string lineTmp = line;
                lineTmp = lineTmp.Trim().TrimStart("<p>");
                lineTmp = lineTmp.Trim().TrimEnd("</p>");
                result += lineTmp;
                result += Environment.NewLine;
            }
            result.TrimEnd(Environment.NewLine);
            result.TrimEnd();
            return result;
        }

        
    }
}
