﻿using Microsoft.WindowsAzure.Storage.Table;
using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Data.Entity;
using System.Linq;

namespace HomeWeb.Models
{
    public class AlertSettingModel : TableEntity
    {
        public const string AlertPartitionKey = "AlertSetting";
        public const string AlertRowKey = "1";
        public AlertSettingModel()
        {
            this.PartitionKey = AlertPartitionKey;
            this.RowKey = AlertRowKey;

            this.SumAlertUnpaidBalance = 0.0;
            this.SumAlertNotifyList = string.Empty;
            this.SumAlertAutoNotify = false;

            this.PersonAlertUnpaidBalance = 0.0;
            this.PersonAlertUnpaidMonths = 1;
            this.PersonAlertAutoNotify = false;
        
        }
        [DisplayName("总欠费金额")]
        public double SumAlertUnpaidBalance { get; set; }
        [DataType(DataType.MultilineText)]
        [DisplayName("推送目标手机")]
        public string SumAlertNotifyList { get; set; }
        [DisplayName("自动推送")]
        public bool SumAlertAutoNotify { get; set; }


        [DisplayName("个人欠费金额")]
        public double PersonAlertUnpaidBalance { get; set; }
        [DisplayName("欠费月份数")]
        public int PersonAlertUnpaidMonths { get; set; }
        [DisplayName("自动推送")]
        public bool PersonAlertAutoNotify { get; set; }

    }


}