﻿using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Web;
using System.Web.Mvc;
using CCSPrototypeCommon;

namespace HomeWeb.Models
{
    public class CompanyModel
    {
        public virtual CCS_Customer_V1 CustomerTable {get; set;}

        public virtual List<CCS_CustomerInfo_V1> CustomerInfoList { get; set; }

        public CompanyModel()
        {
            CustomerTable = new CCS_Customer_V1();
            CustomerInfoList = new List<CCS_CustomerInfo_V1>();
        }

        public static CompanyModel Current
        {
            get
            {
                var company = HttpContext.Current.Session["CompanayModel"] as CompanyModel;
                if (company == null)
                {
                    company = new CompanyModel();
                    HttpContext.Current.Session["CompanayModel"] = company;
                }
                return company;
            }

            set
            {
                HttpContext.Current.Session["CompanayModel"] = value;
            }
        }
    }

    public class CompanyCodeModel
    {
        [Required]
        [MinLength(3)]
        [MaxLength(255)]
        [DisplayName("公司代码")]
        [Remote("VerifyCompanyCode", "Merchant", HttpMethod = "POST", ErrorMessage = "公司代码无效")]
        public string CompanyCode { get; set; }

    }
}