package my.ccs.projectrawdata;


import android.app.Activity;
import android.app.Dialog;
import android.app.DialogFragment;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.AsyncTask;
import android.os.Bundle;
import android.provider.Settings;
import android.text.LoginFilter;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

import com.baidu.mapapi.SDKInitializer;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.Date;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import javax.net.ssl.HttpsURLConnection;

import my.ccs.projectrawdata.model.MeterProfileModel;
import my.ccs.projectrawdata.model.RawData;
import my.ccs.projectrawdata.sqlite.MySQLiteHelper;
import my.ccs.projectrawdata.model.tasks.*;

public class HomeActivity extends Activity {

    ImageButton meterProfilesMgmBtn;
    ImageButton rawDataCollectBtn;
    ImageButton rawDataUploadBtn;


    TextView meterProfilesMgmTxt;
    TextView rawDataCollectTxt;
    TextView rawDataUploadTxt;

    static boolean isFirstCreate = true;
    String deviceId = null;

    int displayWidth;
    int displayHeight;


    @Override
    public void onCreate(Bundle savedInstanceState) {

        SDKInitializer.initialize(getApplicationContext());
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_home);

        DisplayMetrics metrics = new DisplayMetrics();
        getWindow().getWindowManager().getDefaultDisplay().getMetrics(metrics);

        displayWidth = metrics.widthPixels;
        displayHeight = metrics.heightPixels;

        meterProfilesMgmBtn = (ImageButton)findViewById(R.id.meterProfilesMgmBtn);
        meterProfilesMgmBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {

                meterProfilesMgmAction();

            }
        });

        meterProfilesMgmTxt = (TextView) findViewById(R.id.meterProfilesMgmTxt);
        meterProfilesMgmTxt.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                meterProfilesMgmAction();


            }
        });


        rawDataCollectBtn = (ImageButton)findViewById(R.id.rawDataCollectBtn);
        rawDataCollectBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {


                collectDataAction();

            }
        });

        rawDataCollectTxt = (TextView) findViewById(R.id.rawDataCollectTxt);
        rawDataCollectTxt.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
               collectDataAction();


            }
        });

        rawDataUploadBtn = (ImageButton)findViewById(R.id.rawDataUploadBtn);
        rawDataUploadBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {

                rawDataUploadDataAction();

            }
        });

        rawDataUploadTxt = (TextView) findViewById(R.id.rawDataUploadTxt);
        rawDataUploadTxt.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {

                rawDataUploadDataAction();


            }
        });


        deviceId = Settings.Secure.getString(getContentResolver(),
                Settings.Secure.ANDROID_ID);
        deviceId = "B91937A334ED28ED";

        //Check for database upgrades
        MySQLiteHelper dbHelper = new MySQLiteHelper(HomeActivity.this);
        dbHelper.getWritableDatabase();


    }

    public void meterProfilesMgmAction() {


        // custom dialog
        final Dialog dialog = new Dialog(HomeActivity.this);
        Window window = dialog.getWindow();
        window.requestFeature(Window.FEATURE_NO_TITLE);
        dialog.setContentView(R.layout.choose_projectmgm_action);
        window.setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        dialog.setCancelable(true);


        ImageButton downloadMetersBtn = (ImageButton) dialog.findViewById(R.id.downloadMetersBtn);
        ImageButton metersInventoryBtn = (ImageButton) dialog.findViewById(R.id.metersInventoryBtn);
        ImageButton uploadMetersInfoBtn = (ImageButton) dialog.findViewById(R.id.uploadMeterInfoBtn);
        TextView downloadMetersTxt = (TextView) dialog.findViewById(R.id.downloadMetersTxt);
        TextView metersInventoryTxt = (TextView) dialog.findViewById(R.id.metersInventoryTxt);
        TextView uploadMetersInfoTxt = (TextView) dialog.findViewById(R.id.uploadMeterInfoTxt);


        downloadMetersBtn.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {

                if(dialog != null)
                {
                    dialog.dismiss();
                }
                new DownloadMetersTask(HomeActivity.this, deviceId).run();

            }
        });

        downloadMetersTxt.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {

                if(dialog != null)
                {
                    dialog.dismiss();
                }
                new DownloadMetersTask(HomeActivity.this, deviceId).run();

            }
        });


        metersInventoryBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {

                if(dialog != null)
                {
                    dialog.dismiss();
                }
                Intent nextScreen = new Intent(getApplicationContext(), MetersInventoryActivity.class);
                startActivity(nextScreen);

            }
        });


        metersInventoryTxt.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if(dialog != null)
                {
                    dialog.dismiss();
                }
                Intent nextScreen = new Intent(getApplicationContext(), MetersInventoryActivity.class);
                startActivity(nextScreen);


            }
        });



        uploadMetersInfoBtn.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {

                if(dialog != null)
                {
                    dialog.dismiss();
                }
                Intent nextScreen = new Intent(getApplicationContext(), UploadMeterInfoActivity.class);
                startActivity(nextScreen);

            }
        });

        uploadMetersInfoTxt.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {

                if (dialog != null) {
                    dialog.dismiss();
                }
                Intent nextScreen = new Intent(getApplicationContext(), UploadMeterInfoActivity.class);
                startActivity(nextScreen);

            }
        });

        dialog.show();

        //window.setLayout((int) (displayWidth * 0.5), (int) (displayHeight * 0.5));

    }

    public void collectDataAction()
    {
        // custom dialog
        final Dialog dialog = new Dialog(HomeActivity.this);
        Window window = dialog.getWindow();
        window.requestFeature(Window.FEATURE_NO_TITLE);
        dialog.setContentView(R.layout.choose_meter_type);


        window.setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        dialog.setCancelable(true);

        ImageButton wirelessTypeOption = (ImageButton) dialog.findViewById(R.id.wirelessTypeOption);
        wirelessTypeOption.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                dialog.dismiss();
                Bundle b = new Bundle();
                b.putInt(Constants.ChosenMeterTypeKey, 0);
                Intent nextScreen = new Intent(getApplicationContext(), MapActivity.class);
                nextScreen.putExtras(b); //Put your id to your next Intent
                startActivity(nextScreen);

            }
        });

        TextView wirelessTypeOptionTxt = (TextView) dialog.findViewById(R.id.wirelessTypeOptionTxt);
        wirelessTypeOptionTxt.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                dialog.dismiss();
                Bundle b = new Bundle();
                b.putInt(Constants.ChosenMeterTypeKey, 0);
                Intent nextScreen = new Intent(getApplicationContext(), MapActivity.class);
                nextScreen.putExtras(b); //Put your id to your next Intent
                startActivity(nextScreen);

            }
        });

        ImageButton electronicTypeOption = (ImageButton) dialog.findViewById(R.id.electronicTypeOption);
        electronicTypeOption.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                dialog.dismiss();
                Bundle b = new Bundle();
                b.putInt(Constants.ChosenMeterTypeKey, 1);
                Intent nextScreen = new Intent(getApplicationContext(), MapActivity.class);
                nextScreen.putExtras(b); //Put your id to your next Intent
                startActivity(nextScreen);


            }
        });
        TextView electronicTypeOptionTxt = (TextView) dialog.findViewById(R.id.electronicTypeOptionTxt);
        electronicTypeOptionTxt.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                dialog.dismiss();
                Bundle b = new Bundle();
                b.putInt(Constants.ChosenMeterTypeKey, 1);
                Intent nextScreen = new Intent(getApplicationContext(), MapActivity.class);
                nextScreen.putExtras(b); //Put your id to your next Intent
                startActivity(nextScreen);


            }
        });

        ImageButton cableTypeOption = (ImageButton) dialog.findViewById(R.id.cableTypeOption);
        cableTypeOption.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                dialog.dismiss();
                Bundle b = new Bundle();
                b.putInt(Constants.ChosenMeterTypeKey, 2);
                Intent nextScreen = new Intent(getApplicationContext(), MapActivity.class);
                nextScreen.putExtras(b); //Put your id to your next Intent
                startActivity(nextScreen);


            }
        });
        TextView cableTypeOptionTxt = (TextView) dialog.findViewById(R.id.cableTypeOptionTxt);
        cableTypeOptionTxt.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                dialog.dismiss();
                Bundle b = new Bundle();
                b.putInt(Constants.ChosenMeterTypeKey, 2);
                Intent nextScreen = new Intent(getApplicationContext(), MapActivity.class);
                nextScreen.putExtras(b); //Put your id to your next Intent
                startActivity(nextScreen);


            }
        });


        ImageButton staffTypeOption = (ImageButton) dialog.findViewById(R.id.staffTypeOption);
        staffTypeOption.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {

                dialog.dismiss();
                Bundle b = new Bundle();
                b.putInt(Constants.ChosenMeterTypeKey, 3);
                Intent nextScreen = new Intent(getApplicationContext(), MapActivity.class);
                nextScreen.putExtras(b); //Put your id to your next Intent
                startActivity(nextScreen);


            }
        });
        TextView staffTypeOptionTxt = (TextView) dialog.findViewById(R.id.staffTypeOptionTxt);
        staffTypeOptionTxt.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {

                dialog.dismiss();
                Bundle b = new Bundle();
                b.putInt(Constants.ChosenMeterTypeKey, 3);
                Intent nextScreen = new Intent(getApplicationContext(), MapActivity.class);
                nextScreen.putExtras(b); //Put your id to your next Intent
                startActivity(nextScreen);


            }
        });


        dialog.show();

        window.setLayout((int) (displayWidth * 0.75), (int) (displayHeight * 0.55));

    }

    public void rawDataUploadDataAction() {

        // custom dialog
        final Dialog dialog = new Dialog(HomeActivity.this);
        Window window = dialog.getWindow();
        window.requestFeature(Window.FEATURE_NO_TITLE);
        dialog.setContentView(R.layout.choose_rawdataupload_action);
        window.setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        dialog.setCancelable(true);


        ImageButton uploadToCloudBtn = (ImageButton) dialog.findViewById(R.id.uploadToCloudBtn);
        ImageButton uploadToServerBtn = (ImageButton) dialog.findViewById(R.id.uploadToServerBtn);
        ImageButton configurationBtn = (ImageButton) dialog.findViewById(R.id.configurationBtn);
        TextView uploadToCloudTxt = (TextView) dialog.findViewById(R.id.uploadToCloudTxt);
        TextView uploadToServerTxt = (TextView) dialog.findViewById(R.id.uploadToServerTxt);
        TextView configurationTxt = (TextView) dialog.findViewById(R.id.configurationTxt);


        uploadToCloudBtn.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {

                if(dialog != null)
                {
                    dialog.dismiss();
                }
                new UploadRawDataTask().execute();

            }
        });

        uploadToCloudTxt.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {

                if(dialog != null)
                {
                    dialog.dismiss();
                }
                new UploadRawDataTask().execute();

            }
        });


        uploadToServerBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {

                Utilities.showToastMsg(HomeActivity.this, Constants.StatusMessages.TOBEIMPLEMENTED);

            }
        });


        uploadToServerTxt.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                Utilities.showToastMsg(HomeActivity.this, Constants.StatusMessages.TOBEIMPLEMENTED);


            }
        });



        configurationBtn.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {

                if(dialog != null)
                {
                    dialog.dismiss();
                }
                Intent nextScreen = new Intent(getApplicationContext(), SettingsActivity.class);
                startActivity(nextScreen);

            }
        });

        configurationTxt.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {

                if (dialog != null) {
                    dialog.dismiss();
                }
                Intent nextScreen = new Intent(getApplicationContext(), SettingsActivity.class);
                startActivity(nextScreen);

            }
        });

        dialog.show();
        //window.setLayout((int) (displayWidth * 0.5), (int) (displayHeight * 0.5));
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }

    @Override
    public void onResume(){
        super.onResume();
        //Starting Home Activity
        if(Utilities.isAccessCodeExpired()) {
            Intent nextScreen = new Intent(getApplicationContext(), MainActivity.class);
            startActivity(nextScreen);
        }
        else
        {
            if(isFirstCreate)
            {
                isFirstCreate = false;
            }
            MySharedPref.getInstance().setAccessCodeExpDate();
            MainActivity.selectedCustomerId = MySharedPref.getInstance().getCurrentSelectedCustomerID();
        }

    }

    private class UploadRawDataTask extends AsyncTask<Void, Void, Constants.DataUploadStatus> {

        //ProgressDialog pleaseWaitDialog;
        Constants.DataUploadStatus result;

        String response = null;

        @Override
        protected void onPreExecute() {
            /*pleaseWaitDialog = ProgressDialog.show(HomeActivity.this, Constants.DIALOGTITLE, Constants.UPLOADINGMSG, true, true);
            pleaseWaitDialog.setOnCancelListener(new DialogInterface.OnCancelListener() {

                public void onCancel(DialogInterface dialog) {
                    Log.i(Constants.MyTag, "onCancel");
                    UploadRawDataTask.this.cancel(true);
                }
            });*/
            CShowProgress.getInstance().showProgress(HomeActivity.this);
        }


        @Override
        protected void onPostExecute(final Constants.DataUploadStatus result) {

            Log.i(Constants.MyTag, "onPostExecute");
            CShowProgress.getInstance().hideProgress();
            //pleaseWaitDialog.dismiss();

            String errorMsg = null;
            this.result = result;


            if(this.result != null && this.result.status != Constants.DataUploadStatus.STATUS.SUCCESS)
            {
                errorMsg = this.result.convertCodeToMsg();
            }

            if(errorMsg != null)
            {
                Utilities.showAlertDialog(Constants.ALERTDIALOGTITLE, errorMsg, HomeActivity.this, getWindow(), false);
            }
            else
            {
                //Utilities.showAlertDialog(Constants.ALERTDIALOGTITLE, Constants.StatusMessages.REQUESTSUCCESSMSG, HomeActivity.this, getWindow(), false);


            }

        }
        @Override
        protected void onCancelled() {
            super.onCancelled();
            //Utilities.hideProgressBar(progressBarDownloadMeters, getWindow(), true);
            Log.i(Constants.MyTag, "onCanceled");
            //pleaseWaitDialog.dismiss();
            CShowProgress.getInstance().hideProgress();

        }

        @Override
        protected Constants.DataUploadStatus  doInBackground(Void... params) {


            // add rawdata
            /*dbhelper.addRawData(new RawData("9c6d44eb-4b01-e611-80c8-00155de1e22a", "MeasureType1", "rateschedule", "readtype", 1.2, 1.4, "status", new Date()));
            dbhelper.addRawData(new RawData("9c6d44eb-4b01-e611-80c8-00155de1e22a", "MeasureType2", "rateschedule", "readtype", 1.2, 1.4, "status", new Date()));
            dbhelper.addRawData(new RawData("9c6d44eb-4b01-e611-80c8-00155de1e22a", "MeasureType3", "rateschedule", "readtype", 1.2, 1.4, "status", new Date()));*/


            long dataCount = 0;
            try {

                MySQLiteHelper dbhelper = new MySQLiteHelper(HomeActivity.this);
                File sqliteDB = getDatabasePath(MySQLiteHelper.DATABASE_NAME);
                if(sqliteDB ==null ||  !sqliteDB.exists())
                    return  new Constants.DataUploadStatus(Constants.DataUploadStatus.STATUS.DB_DOESNOTEXIST);

                dataCount = dbhelper.getAllRawData().size();

                final long dataCountForToast = dataCount;
                Utilities.showToastMsg(HomeActivity.this, "上载数据量：" + dataCountForToast);

                if(dataCount == 0)
                {
                    return  new Constants.DataUploadStatus(Constants.DataUploadStatus.STATUS.NO_DATA);
                }

                dbhelper.exportDB();
                File csvDB = getDatabasePath(MySQLiteHelper.ExportCSVName);
                if(csvDB == null || !csvDB.exists())
                    return  new Constants.DataUploadStatus(Constants.DataUploadStatus.STATUS.DB_DOESNOTEXIST);

                Utilities.showToastMsg(HomeActivity.this, "开始上传……");
                HttpURLConnection connection = null;
                DataOutputStream outputStream = null;

                String pathToOurFile = csvDB.getAbsolutePath();
                String urlServer = Constants.ServerURLs.uploadRawDataUrl;
                int bytesRead, bytesAvailable, bufferSize;
                byte[] buffer;
                int maxBufferSize = 1 * 1024;

                FileInputStream fileInputStream = new FileInputStream(new File(
                        pathToOurFile));

                URL url = new URL(urlServer);
                connection = (HttpURLConnection) url.openConnection();

                // Allow Inputs & Outputs
                connection.setDoInput(true);
                connection.setDoOutput(true);
                connection.setUseCaches(false);
                connection.setChunkedStreamingMode(1024);
                // Enable POST method
                connection.setRequestMethod("POST");

                connection.setRequestProperty("Connection", "Keep-Alive");
                connection.setRequestProperty("Content-Type",
                        "multipart/form-data");

                outputStream = new DataOutputStream(connection.getOutputStream());

                bytesAvailable = fileInputStream.available();
                bufferSize = Math.min(bytesAvailable, maxBufferSize);
                buffer = new byte[bufferSize];

                // Read file
                bytesRead = fileInputStream.read(buffer, 0, bufferSize);
                Log.i(Constants.MyTag, bytesAvailable + " bytes available");
                try {
                    while (bytesRead > 0) {
                        try {
                            outputStream.write(buffer, 0, bufferSize);
                        } catch (OutOfMemoryError e) {
                            return  new Constants.DataUploadStatus(Constants.DataUploadStatus.STATUS.OUT_OF_MEMORY);
                        }
                        bytesAvailable = fileInputStream.available();
                        bufferSize = Math.min(bytesAvailable, maxBufferSize);
                        bytesRead = fileInputStream.read(buffer, 0, bufferSize);
                    }
                } catch (Exception e) {
                    return  new Constants.DataUploadStatus(Constants.DataUploadStatus.STATUS.UNKNOWN_ERROR);
                }

                fileInputStream.close();
                outputStream.flush();
                outputStream.close();


                int responseCode=connection.getResponseCode();

                if (responseCode == HttpsURLConnection.HTTP_OK) {

                    response = Constants.EMPTYSTRING;
                    String line;
                    BufferedReader br=new BufferedReader(new InputStreamReader(connection.getInputStream()));
                    while ((line=br.readLine()) != null) {
                        response+=line;
                    }

                    dbhelper.deleteAllRawData();



                    Map<String, MeterProfileModel>  allMeters = MeterProfilesDataHolder.getInstance(HomeActivity.this).getListMeters();

                    for (MeterProfileModel m : allMeters.values()) {
                            m.isCollected = false;
                            m.LastCollected = null;
                            m.LastUploaded = new Date();
                            dbhelper.updateMeterData(m);

                    }

                }
                else {
                    return  new Constants.DataUploadStatus(Constants.DataUploadStatus.STATUS.FAILED_WITH_RESPONSECODE, String.valueOf(responseCode));
                }


            }
            catch (Exception ex) {
                return  new Constants.DataUploadStatus(Constants.DataUploadStatus.STATUS.UNKNOWN_ERROR, ex.getMessage());
            }
            return  new Constants.DataUploadStatus(Constants.DataUploadStatus.STATUS.SUCCESS);

        }
    }

    @Override
    public void onBackPressed() {
        Intent intent = new Intent(HomeActivity.this, MainActivity.class);
        intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
        startActivity(intent);

    }

}