package my.ccs.projectrawdata;


import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.ClipData;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Rect;
import android.os.AsyncTask;
import android.os.Bundle;
import android.provider.Settings;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.view.Window;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.baidu.mapapi.SDKInitializer;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import javax.net.ssl.HttpsURLConnection;

import com.xgg.blesdk.*;
import com.dayang.device.*;

import my.ccs.projectrawdata.model.CustomerModel;
import my.ccs.projectrawdata.model.MeterProfileModel;
import my.ccs.projectrawdata.sqlite.MySQLiteHelper;

public class MainActivity extends Activity {

    Button submitButton;
    EditText accessCodeEditTxt;
    String deviceId = null;
    ProgressBar progressBar;
    TextView deviceIdLabel;
    ImageButton copyDeviceId;
    RelativeLayout mainLayout;
    StringBuilder result = new StringBuilder(); //stores query to be sent to the server
    ArrayList<String> customers;

    private static final int DIALOG_LOADING = 1;

    List<CustomerModel> listCustomers  = new LinkedList<>();
    public static String selectedCustomerId = null;
    Spinner customerSpinner = null;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        //requestWindowFeature(Window.FEATURE_NO_TITLE);

        SDKInitializer.initialize(getApplicationContext());
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_main);

        mainLayout = (RelativeLayout)findViewById(R.id.mainLayout);


        //Initialization
        progressBar = (ProgressBar) findViewById(R.id.progressBar);
        RelativeLayout.LayoutParams progressBarPar = (RelativeLayout.LayoutParams)progressBar.getLayoutParams();
        progressBarPar.width= Utilities.getWidth(this)/4;
        progressBarPar.height= Utilities.getHeight(this)/4;

        deviceIdLabel = (TextView) findViewById(R.id.deviceIdLabel);

        deviceId = Settings.Secure.getString(getContentResolver(),
                Settings.Secure.ANDROID_ID);
        //deviceId = "76ACAEA5BDCA5AC8";
        deviceId = "B91937A334ED28ED";
        if(deviceId != null)
        {
            deviceId = deviceId.toUpperCase();
            deviceIdLabel.setText(Constants.DEVICEIDCHINESE + " " + deviceId);
        }
        else
        {
            deviceIdLabel.setText(Constants.DEVICEIDCHINESE);
        }

        // retrieve customer list
        new GetCustomerListTask().execute();


        accessCodeEditTxt   = (EditText)findViewById(R.id.accessCodeEditTxt);


        submitButton = (Button)findViewById(R.id.btnSubmit);
        submitButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {

                String accessCode = accessCodeEditTxt.getText().toString();
                if(accessCode == null || accessCode.length() == 0)
                {
                    MainActivity.this.runOnUiThread(new Runnable() {
                        public void run() {
                            Utilities.showAlertDialog(Constants.DIALOGTITLE, Constants.ACCESSCODECANNOTBEEMPTY, MainActivity.this, getWindow(), false);
                        }
                    });
                }
                else if(deviceId == null  || deviceId.length() == 0)
                {
                    MainActivity.this.runOnUiThread(new Runnable() {
                        public void run() {
                            Utilities.showAlertDialog(Constants.DIALOGTITLE, Constants.DEVICEIDCANNOTBEEMPTY, MainActivity.this, getWindow(), false);
                        }
                    });
                }
                else{
                    new VerifyAccessCodeTask().execute();
                }



            }
        });

        copyDeviceId = (ImageButton)findViewById(R.id.deviceCopyBtn);
        copyDeviceId.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {

                MainActivity.this.runOnUiThread(new Runnable() {
                    public void run() {

                        String text = deviceId != null ? deviceId.trim() : null;
                        if(text != null && text.length() > 0) {
                            if(android.os.Build.VERSION.SDK_INT < android.os.Build.VERSION_CODES.HONEYCOMB) {
                                android.text.ClipboardManager clipboardMgr = (android.text.ClipboardManager) getSystemService(Context.CLIPBOARD_SERVICE);
                                clipboardMgr.setText(text);
                            } else {
                                // this api requires SDK version 11 and above, so suppress warning for now
                                android.content.ClipboardManager clipboardMgr = (android.content.ClipboardManager) getSystemService(Context.CLIPBOARD_SERVICE);
                                ClipData clip = ClipData.newPlainText(Constants.COPIEDDEVICEID, text);
                                clipboardMgr.setPrimaryClip(clip);

                            }
                            //Utilities.showAlertDialog(Constants.DIALOGTITLE, Constants.DEVICEIDCOPIEDSUCCESS, MainActivity.this, getWindow(), false);
                            Toast.makeText(MainActivity.this, Constants.DEVICEIDCOPIEDSUCCESS, Toast.LENGTH_LONG).show();
                        }
                        else {
                            //Utilities.showAlertDialog(Constants.DIALOGTITLE, Constants.DEVICEIDCOPIEDFAILURE, MainActivity.this, getWindow(), false);
                            Toast.makeText(MainActivity.this, Constants.DEVICEIDCOPIEDFAILURE, Toast.LENGTH_LONG).show();
                        }


                    }
                });

            }
        });

        //android.text.format.DateFormat df = new android.text.format.DateFormat();
        //df.format("yyyyMMddhhmmss", new java.util.Date());

        customerSpinner = (Spinner) findViewById(R.id.spinner_customerid);

        Utilities.versionName =  BuildConfig.VERSION_NAME + "." + BuildConfig.VERSION_CODE;//Utilities.getBuildTime(this);
        TextView versionNumberTxt = (TextView) findViewById(R.id.versionNumberTxtMain);
        versionNumberTxt.setText( Utilities.versionName);

        MySharedPref.getInstance().setAccessCodeExpDateToExpired();
    }

    private class GetCustomerListTask extends AsyncTask<Void, Void, String> {

        String result = Constants.EMPTYSTRING;
        //ProgressDialog spinDialog;

        @Override
        protected void onPreExecute() {
/*
            spinDialog = ProgressDialog.show(MainActivity.this, Constants.DIALOGTITLE, Constants.RETRIEVECUSTOMERSMSG, true, false);
            spinDialog.setOnCancelListener(new DialogInterface.OnCancelListener() {
                public void onCancel(DialogInterface dialog) {
                    Log.d(Constants.MyTag, "onCancel");
                    GetCustomerListTask.this.cancel(true);
                }
            });
*/
//            showDialog(DIALOG_LOADING);

            CShowProgress.getInstance().showProgress(MainActivity.this);
        }

        @Override
        protected String doInBackground(Void... params) {
            String response = null;
            try {
                if (deviceId != null) {
                    URL url = new URL(Constants.ServerURLs.getCustomersUrl);
                    HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                    conn.setRequestMethod("POST");
                    conn.setRequestProperty("User-Agent", Constants.userAgentString);
                    conn.setRequestProperty("Content-Type", "application/json");

                    JSONObject jsonParam = new JSONObject();
                    jsonParam.put(Constants.JSONReqDeviceIDTag, deviceId);

                    OutputStream os = conn.getOutputStream();
                    BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
                    writer.write(jsonParam.toString());
                    writer.flush();
                    writer.close();
                    os.close();

                    //read response from the server
                    int responseCode = conn.getResponseCode();
                    if (responseCode == HttpsURLConnection.HTTP_OK) {

                        String line;
                        BufferedReader br=new BufferedReader(new InputStreamReader(conn.getInputStream()));
                        response = Constants.EMPTYSTRING;

                        while ((line = br.readLine()) != null) {
                            response += line;
                        }
                    }
                    else {
                        response = Constants.StatusMessages.REQUESTFAILEDWITHSTATUSCODEMSG + responseCode;
                    }

                }
            }
            catch (android.os.NetworkOnMainThreadException e) {

            }
            catch (Exception e) {
            }

            return response;

        }

        @Override
        protected void onCancelled() {
            super.onCancelled();
            Log.i(Constants.MyTag, "onCanceled");
            //pleaseWaitDialog.dismiss();
            CShowProgress.getInstance().hideProgress();
        }

        @Override
        protected void onPostExecute(final String result) {

//            spinDialog.dismiss();
//            dismissDialog(DIALOG_LOADING);

            CShowProgress.getInstance().hideProgress();

            String errorMsg = null;
            this.result = result;

            if(this.result == null)
            {
                Utilities.showAlertDialog(Constants.ALERTDIALOGTITLE, Constants.StatusMessages.REQUESTFAILEDNORESPONSEMSG, MainActivity.this, getWindow(), false);
                return;
            }
            customers = new ArrayList<>();
            try {


                JSONObject json = new JSONObject(this.result);
                final String statusCode = json.getString(Constants.JSONRespStatusCodeTag);
                final String statusMsg = json.getString(Constants.JSONRespStatusMsgTag);
                if(statusCode.equals(Constants.StatusCodes.SUCCESS)) {
                    String customerData =  json.has(Constants.JSONRespCustomerIdsTag) ? json.getString(Constants.JSONRespCustomerIdsTag) : null;
                    if(customerData != null)
                    {
                        MySharedPref.getInstance().setCurrentCustomerIDs(customerData);
                        JSONArray data = new JSONArray(customerData);
                        listCustomers  = new LinkedList<>();
                        List<String>  customerNames = new LinkedList<>();
                        if (data != null) {
                            //Utilities.showToastMsg(MainActivity.this, "已下载 " + data.length());
                            for (int ii = 0; ii < data.length(); ii++) {
                                try {
                                    JSONObject jsonItem = data.getJSONObject(ii);
                                    CustomerModel customerModel = Utilities.parseJsonToCustomerModel(jsonItem);
                                    if (customerModel != null) {
                                        customerNames.add(customerModel.CustomerName);
                                        listCustomers.add(customerModel);
                                    }

                                }
                                catch (Exception e)
                                {
                                    //ignore for now
                                }

                            }
                            Spinner spinner = (Spinner)findViewById(R.id.spinner_customerid);
                            ArrayAdapter<String> spinnerAdapter = new ArrayAdapter<String>(MainActivity.this, R.layout.spinner_item, customerNames);
                            spinnerAdapter.setDropDownViewResource(R.layout.spinner_item);
                            spinner.setAdapter(spinnerAdapter);

                        } else {
                            errorMsg = Constants.StatusMessages.JSONFORMATINCORRECTMSG + " " + Constants.JSONRespCustomerIdsTag;
                        }


                    } else {
                        errorMsg = Constants.StatusMessages.JSONTAGNOTBEFOUNDMSG + " " + Constants.JSONRespCustomerIdsTag;
                    }


                }
                else
                {
                    errorMsg = Constants.StatusMessages.REQUESTFAILEDGENERICMSG;
                }

            }
            catch (JSONException e)
            {
                //Log this error
                errorMsg = e.getMessage();
                errorMsg = Constants.StatusMessages.REQUESTFAILEDGENERICMSG;
            }
            catch (Exception e)
            {
                //Log this error
                errorMsg = e.getMessage();
                errorMsg = Constants.StatusMessages.REQUESTFAILEDGENERICMSG;
            }

            if(errorMsg != null)
            {
                Utilities.showAlertDialog(Constants.ALERTDIALOGTITLE, errorMsg, MainActivity.this, getWindow(), false);
            }
            else
            {
                //Utilities.showAlertDialog(Constants.ALERTDIALOGTITLE, Constants.StatusMessages.REQUESTSUCCESSMSG, MainActivity.this, getWindow(), false);


            }

        }
    }

    @Override
    public boolean dispatchTouchEvent(MotionEvent event) {
        if (event.getAction() == MotionEvent.ACTION_DOWN) {
            if (accessCodeEditTxt!=null &&  accessCodeEditTxt.isFocused()) {
                Rect outRect = new Rect();
                accessCodeEditTxt.getGlobalVisibleRect(outRect);
                if (!outRect.contains((int)event.getRawX(), (int)event.getRawY())) {
                    accessCodeEditTxt.clearFocus();
                    //
                    // Hide keyboard
                    //
                    hideKeyboard();
                }
            }
        }
        return super.dispatchTouchEvent(event);
    }

    public void hideKeyboard()
    {
        InputMethodManager inputMethodManager = (InputMethodManager)  this.getSystemService(Activity.INPUT_METHOD_SERVICE);
        inputMethodManager.hideSoftInputFromWindow(this.getCurrentFocus().getWindowToken(), 0);

    }
    @Override
    protected void onPause() {
        super.onPause();

    }

    @Override
    protected void onResume() {
        super.onResume();

    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        //Utilities.hideProgressBar(progressBar, getWindow(), true);
    }

    private String sendVerifyAccessPost() {
        String response = null;
        try {
            String accessCode = accessCodeEditTxt.getText().toString();
            if(accessCode != null && accessCode.length() != 0 && deviceId != null && deviceId.length() != 0) {
                URL url = new URL(Constants.ServerURLs.verifyAccessWithCustomerIdUrl);
                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                conn.setRequestMethod("POST");
                conn.setRequestProperty("User-Agent", "USER_AGENT");
                conn.setRequestProperty("Content-Type", "application/json");

                JSONObject jsonParam = new JSONObject();
                jsonParam.put(Constants.JSONReqAccessCodeTag, accessCode);
                jsonParam.put(Constants.JSONReqDeviceIDTag, deviceId);
                int selectedCustomerIdIndex = customerSpinner.getSelectedItemPosition();

                if(selectedCustomerIdIndex < listCustomers.size())
                {
                    selectedCustomerId = listCustomers.get(selectedCustomerIdIndex).CustomerID;
                }
                jsonParam.put(Constants.JSONReqCustomerIdTag, selectedCustomerId);


                OutputStream os = conn.getOutputStream();
                BufferedWriter writer = new BufferedWriter(
                        new OutputStreamWriter(os, "UTF-8"));

                writer.write(jsonParam.toString());
                writer.flush();
                writer.close();
                os.close();

                int responseCode=conn.getResponseCode();

                //remove this code later
                if (responseCode == HttpsURLConnection.HTTP_OK) {

                    String line;
                    response = "";
                    BufferedReader br=new BufferedReader(new InputStreamReader(conn.getInputStream()));
                    while ((line=br.readLine()) != null) {
                        response+=line;
                    }
                }
                else {
                    response=Constants.StatusMessages.REQUESTFAILEDWITHSTATUSCODEMSG + " " + responseCode;

                }

            }
        }
        catch ( android.os.NetworkOnMainThreadException e)
        {
        }
        catch (Exception e)
        {
        }
        return response;
    }

    private class VerifyAccessCodeTask extends AsyncTask<Void, Void, String> {

        String result= "";
        //ProgressDialog pleaseWaitDialog;

        @Override
        protected void onPreExecute() {
            //Utilities.showProgressBar(progressBar, getWindow(), true);
/*
            pleaseWaitDialog = ProgressDialog.show(MainActivity.this, Constants.DIALOGTITLE, Constants.ACCESSVERIFYMSG, true, true);
            pleaseWaitDialog.setOnCancelListener(new DialogInterface.OnCancelListener() {

                public void onCancel(DialogInterface dialog) {
                    VerifyAccessCodeTask.this.cancel(true);
                }
            });
*/
            CShowProgress.getInstance().showProgress(MainActivity.this);
        }

        @Override
        protected void onPostExecute(final String result) {

//            pleaseWaitDialog.dismiss();
            CShowProgress.getInstance().hideProgress();

            String responseMsg = null;
            String errorMsg = null;
            this.result = result;
            if(this.result == null)
            {
                Utilities.showAlertDialog(Constants.ALERTDIALOGTITLE, Constants.StatusMessages.REQUESTFAILEDNORESPONSEMSG, MainActivity.this, getWindow(), false);
                return;
            }

            JSONObject json = null;
            try {
                json = new JSONObject(this.result);
                final String statusCode = json.getString(Constants.JSONRespStatusCodeTag);
                final String statusMsg = json.getString(Constants.JSONRespStatusMsgTag);

                if(statusCode.equals(Constants.StatusCodes.SUCCESS)) {
                    final String androidRawDataBuildVersion = json.has(Constants.JSONRespAndroidRawDataBuildVersionTag) ? json.getString(Constants.JSONRespAndroidRawDataBuildVersionTag):"Build version is not defined";
                    if(androidRawDataBuildVersion != null && androidRawDataBuildVersion.length() != 0 && !androidRawDataBuildVersion.equals(Utilities.versionName)) {
                        errorMsg = "请更新APP版本：你的版本是" + Utilities.versionName + "，需要更新至" + androidRawDataBuildVersion + "才能继续使用。";
                    }
                    else {
                        MySharedPref.getInstance().setAccessCodeExpDate();
                        MySharedPref.getInstance().setCurrentSelectedCustomerID(selectedCustomerId);
                        new MySQLiteHelper(MainActivity.this).activateMeterDataForCustomerId(selectedCustomerId);
                        MeterProfilesDataHolder.getInstance(MainActivity.this).nullifyListMeters();
                        finish();
                        return;
                    }
                }
                else
                {
                    errorMsg = statusMsg;//Constants.StatusMessages.REQUESTFAILEDGENERICMSG;
                }

            }
            catch (JSONException e)
            {
                //Log this error
                errorMsg = e.getMessage();
                errorMsg = Constants.StatusMessages.REQUESTFAILEDGENERICMSG;
            }
            catch (Exception e)
            {
                //Log this error
                errorMsg = e.getMessage();
                errorMsg = Constants.StatusMessages.REQUESTFAILEDGENERICMSG;
            }

            if(errorMsg != null)
            {
                Utilities.showAlertDialog(Constants.ALERTDIALOGTITLE, errorMsg, MainActivity.this, getWindow(), false);
            }
            else
            {
                //Utilities.showAlertDialog(Constants.ALERTDIALOGTITLE, Constants.StatusMessages.REQUESTSUCCESSMSG, MainActivity.this, getWindow(), false);


            }
        }

        @Override
        protected void onCancelled() {
            super.onCancelled();
            Log.i(Constants.MyTag, "onCanceled");
            //pleaseWaitDialog.dismiss();
            CShowProgress.getInstance().hideProgress();
        }

        @Override
        protected String  doInBackground(Void... params) {

           return sendVerifyAccessPost();
        }
    }

    @Override
    public void onBackPressed() {

        //we need to override this to prevent back button from access code page
        Intent intent = new Intent(Intent.ACTION_MAIN);
        intent.addCategory(Intent.CATEGORY_HOME);
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        startActivity(intent);

    }

    public void showWhatIsNew(View view)
    {
        Intent nextScreen = new Intent(getApplicationContext(), WhatIsNewActivity.class);
        startActivity(nextScreen);

    }


}
