package my.ccs.projectrawdata;

import android.app.AlertDialog;
import android.bluetooth.BluetoothAdapter;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Point;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.Settings;
import android.text.Editable;
import android.text.TextWatcher;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Random;

import android.app.Activity;
import android.app.ProgressDialog;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ExpandableListAdapter;
import android.widget.ExpandableListView;
import android.widget.FrameLayout;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.baidu.location.BDLocation;
import com.baidu.location.BDLocationListener;
import com.baidu.location.LocationClient;
import com.baidu.location.LocationClientOption;
import com.baidu.mapapi.SDKInitializer;
import com.baidu.mapapi.map.BaiduMap;
import com.baidu.mapapi.map.BitmapDescriptor;
import com.baidu.mapapi.map.BitmapDescriptorFactory;
import com.baidu.mapapi.map.InfoWindow;
import com.baidu.mapapi.map.MapPoi;
import com.baidu.mapapi.map.MapStatusUpdate;
import com.baidu.mapapi.map.MapStatusUpdateFactory;
import com.baidu.mapapi.map.MapView;
import com.baidu.mapapi.map.Marker;
import com.baidu.mapapi.map.MarkerOptions;
import com.baidu.mapapi.map.MyLocationConfiguration;
import com.baidu.mapapi.map.MyLocationData;
import com.baidu.mapapi.model.LatLng;
import com.baidu.mapapi.model.LatLngBounds;
import com.baidu.mapapi.search.core.SearchResult;
import com.baidu.mapapi.search.geocode.GeoCodeResult;
import com.baidu.mapapi.search.geocode.GeoCoder;
import com.baidu.mapapi.search.geocode.OnGetGeoCoderResultListener;
import com.baidu.mapapi.search.geocode.ReverseGeoCodeOption;
import com.baidu.mapapi.search.geocode.ReverseGeoCodeResult;
import com.dayang.device.DYBox;
import com.dayang.device.DYDirectMeter;
import com.dayang.device.DYWirelessMeter;
import com.xgg.blesdk.BleState;
import com.xgg.blesdk.Box;
import com.xgg.blesdk.Meter;


import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import my.ccs.projectrawdata.model.MeterListItem;
import my.ccs.projectrawdata.model.MeterProfileModel;
import my.ccs.projectrawdata.model.RawData;
import my.ccs.projectrawdata.sqlite.MySQLiteHelper;


public class MapActivity extends Activity  implements OnGetGeoCoderResultListener {


    List<MeterListItem> listGroupData;
    HashMap<String, List<MeterProfileModel>> listDataChild;

    static DYBox box = new DYBox();

    JSONArray m_meters;

    //private SDKReceiver mReceiver;
    GeoCoder mSearch = null; // 搜索模块，也可去掉地图模块独立使用
    BitmapDescriptor bdred = BitmapDescriptorFactory
            .fromResource(R.drawable.icon_ball_red);
    BitmapDescriptor bdgreen = BitmapDescriptorFactory
            .fromResource(R.drawable.icon_ball_green);
    private InfoWindow mInfoWindow;
    // 定位相关
    LocationClient mLocClient;
    public MyLocationListenner myListener = new MyLocationListenner();
    private MyLocationConfiguration.LocationMode mCurrentMode;


    MapView mMapView;
    BaiduMap mBaiduMap;
    ExpandableListView metersListview;
    private ArrayAdapter<String> metersListAdapter;

    FrameLayout mapFrame;
    FrameLayout listFrame;
    LinearLayout topHeader;

    // UI相关
    boolean isFirstLoc = true; // 是否首次定位
    EditText inputSearchEditText;

    ImageButton switchToListBtn;
    ImageButton collectDataBtn;

    final Map<String, MeterProfileModel> listMeters = new LinkedHashMap<>();
    Map<String, MeterProfileModel> listMetersFiltered = new LinkedHashMap<>();
    //List<MeterProfileModel> listMetersFilteredToList = new LinkedList<>();
    MeterProfileModel.MeterTypes chosenMeterType;
    boolean isMarkerShown = false;
    float initialZoom;
    ProgressDialog connectingPD;



    /*
     * Preparing the list data
     */
    private void prepareListData(Map<String, MeterProfileModel> listMetersFiltered) {

        listGroupData = new ArrayList<MeterListItem>();
        listDataChild = new LinkedHashMap<String, List<MeterProfileModel>>();
        for (MeterProfileModel m : listMetersFiltered.values()) {

            String locCode = m.LocationCode;
            if(m.LocationCode == null || m.LocationCode.isEmpty())
            {
                locCode = "未定位表设备";
            }

            if(!listDataChild.containsKey(locCode))
            {
                listDataChild.put(locCode, new LinkedList<MeterProfileModel>());
            }
            listDataChild.get(locCode).add(m);
        }

        for(String locCode : listDataChild.keySet())
        {
            listGroupData.add(new MeterListItem(locCode));
        }


    }


    @Override
    public void onGetGeoCodeResult(GeoCodeResult result) {
        if (result == null || result.error != SearchResult.ERRORNO.NO_ERROR) {
            Utilities.showToastMsg(MapActivity.this, "抱歉，未能找到结果");
            return;
        }

        String strInfo = String.format("纬度：%f 经度：%f",
                result.getLocation().latitude, result.getLocation().longitude);
        Utilities.showToastMsg(MapActivity.this, strInfo);

    }

    @Override
    public void onGetReverseGeoCodeResult(ReverseGeoCodeResult result) {
        if (result == null || result.error != SearchResult.ERRORNO.NO_ERROR) {
            Utilities.showToastMsg(MapActivity.this, "抱歉，未能找到结果");
            return;
        }
        Utilities.showToastMsg(MapActivity.this, result.getAddress());
        ReverseGeoCodeResult.AddressComponent addressComponent = result.getAddressDetail();
        String detailedAddress = "City: " + addressComponent.city + "\n" +
                "Province: " + addressComponent.province + "\n" +
                "District: " + addressComponent.district + "\n" +
                "Street: " + addressComponent.street + "\n" +
                "StreetNumber: " + addressComponent.streetNumber + "\n";
        Utilities.showToastMsg(MapActivity.this, detailedAddress);
    }


    @Override
    public void onCreate(Bundle savedInstanceState) {

        SDKInitializer.initialize(getApplicationContext());

        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_map);

        Bundle b = getIntent().getExtras();
        chosenMeterType = MeterProfileModel.MeterTypes.fromInteger(b.getInt(Constants.ChosenMeterTypeKey));

        mapFrame = (FrameLayout) findViewById(R.id.mapFrame);
        listFrame = (FrameLayout) findViewById(R.id.listFrame);
        topHeader = (LinearLayout) findViewById(R.id.topHeader);
        topHeader.bringToFront();

        listFrame.bringToFront();

        metersListview = (ExpandableListView) findViewById(R.id.metersListView);

        //获取地图控件引用
        mMapView = (MapView) findViewById(R.id.bmapView);



        mBaiduMap = mMapView.getMap();

        mCurrentMode = MyLocationConfiguration.LocationMode.NORMAL;

        mBaiduMap.setMyLocationConfigeration(new MyLocationConfiguration(
                mCurrentMode, true, null));

        mBaiduMap.setOnMapClickListener(new BaiduMap.OnMapClickListener() {
            @Override
            public void onMapClick(LatLng latLng) {
                hideList();
                hideInfoWindowCCS();
            }

            @Override
            public boolean onMapPoiClick(MapPoi mapPoi) {
                return false;
            }
        });

        mBaiduMap.setOnMapDoubleClickListener(new BaiduMap.OnMapDoubleClickListener() {
            @Override
            public void onMapDoubleClick(LatLng latLng) {

            }

        });

        MapStatusUpdate msu = MapStatusUpdateFactory.zoomTo(mBaiduMap.getMaxZoomLevel());
        mBaiduMap.setMapStatus(msu);

        // 开启定位图层
        mBaiduMap.setMyLocationEnabled(true);
        // 定位初始化
        mLocClient = new LocationClient(this);
        mLocClient.registerLocationListener(myListener);
        LocationClientOption option = new LocationClientOption();
        option.setOpenGps(true); // 打开gps
        option.setCoorType("bd09ll"); // 设置坐标类型
        option.setScanSpan(1000);
        mLocClient.setLocOption(option);
        mLocClient.start();
        switchToListBtn = (ImageButton)findViewById(R.id.switchToListBtn);

        inputSearchEditText = (EditText)findViewById(R.id.inputSearchEditTxt);
        collectDataBtn = (ImageButton)findViewById(R.id.collectDataBtn);

        if (chosenMeterType == MeterProfileModel.MeterTypes.Manual) {
            collectDataBtn.setImageResource(R.drawable.icon_signals_disabled);
        }

        Map<String, MeterProfileModel> allMeters = MeterProfilesDataHolder.getInstance(MapActivity.this).getListMeters();

        Utilities.showToastMsg(MapActivity.this, "收到" + allMeters.size() + "块水表");
        List<MeterProfileModel> meters = new LinkedList<>();
        if(allMeters != null) {
            for (MeterProfileModel m : allMeters.values()) {
                if (m.MeterType == chosenMeterType) {

                    listMeters.put(m.MeterSN, m);
                    meters.add(m);
                }
            }
        }
        listMetersFiltered = listMeters;
        initOverlay(listMeters);

        handleMeterList();

        inputSearchEditText.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence cs, int arg1, int arg2, int arg3) {

                listMetersFiltered = Utilities.filterMeters(listMeters, cs.toString());
                resetOverlay(listMetersFiltered);

                /*List<MeterProfileModel> meters = new LinkedList<>();
                for(MeterProfileModel m : listMetersFiltered.values())
                {
                    meters.add(m);
                }*/

                // get data from the table by the ListAdapter
                //MetersListAdapter customAdapter = new MetersListAdapter(MapActivity.this, R.layout.meter_listview, meters);
                //metersListview.setAdapter(customAdapter);

                handleMeterList();

            }

            @Override
            public void beforeTextChanged(CharSequence arg0, int arg1, int arg2, int arg3) {
                runOnUiThread(new Runnable() {
                    public void run() {
                    }
                });
            }

            @Override
            public void afterTextChanged(Editable arg0) {
                runOnUiThread(new Runnable() {
                    public void run() {
                    }
                });
            }
        });


        mBaiduMap.setOnMapLoadedCallback(new BaiduMap.OnMapLoadedCallback() {
            @Override
            public void onMapLoaded() {
                mMapView.setScaleControlPosition(new Point(-200, -200));
                mMapView.setZoomControlsPosition(new Point(-200, -200));



            }
        });
        mMapView.showZoomControls(false);

        mBaiduMap.setOnMarkerClickListener(new BaiduMap.OnMarkerClickListener() {
            public boolean onMarkerClick(final Marker marker) {


                final LatLng ll = marker.getPosition();

                LatLng ptCenter = new LatLng((ll.latitude), (ll.longitude));
                // 反Geo搜索
                mSearch.reverseGeoCode(new ReverseGeoCodeOption()
                        .location(ptCenter));

                initialZoom = mBaiduMap.getMapStatus().zoom;

                LinearLayout layout = (LinearLayout)LayoutInflater.from(getApplicationContext()).inflate(R.layout.marker_dialog_layout, null);


                TextView markerDialogMeterUserNameId = (TextView)layout.findViewById(R.id.markerDialogMeterUserNameId);
                TextView markerDialogMeterId = (TextView)layout.findViewById(R.id.markerDialogMeterId);
                markerDialogMeterUserNameId.setText( listMetersFiltered.get(marker.getTitle()).UserName);
                markerDialogMeterId.setText(listMetersFiltered.get(marker.getTitle()).MeterID);
                InfoWindow.OnInfoWindowClickListener listener = null;

                listener = new InfoWindow.OnInfoWindowClickListener() {
                    public void onInfoWindowClick() {


                    }
                };
                mInfoWindow = new InfoWindow(BitmapDescriptorFactory.fromView(layout), ll, -47, listener);
                showInfoWindowCCS(mInfoWindow);

                MyLocationData currentLocation = mBaiduMap.getLocationData();
                if(currentLocation != null)
                {
                    LatLngBounds.Builder bounds;
                    bounds = new LatLngBounds.Builder();


                    final LatLng ll2 = new LatLng(currentLocation.latitude,
                            currentLocation.longitude);


                    //final LatLng otherSidePos = new LatLng(2 * ll.latitude - ll2.latitude, 2 * ll.longitude - ll2.longitude);
                    final LatLng centroSymmetric = new LatLng((ll.latitude + ll2.latitude)/2, (ll.longitude + ll2.longitude)/2);
                    final LatLng centroSymmetricLeftBottom = new LatLng(Math.min(ll.latitude, ll2.latitude) - 0.01, Math.min(ll.longitude, ll2.longitude) - 0.01);
                    final LatLng centroSymmetricRightUp = new LatLng(Math.max(ll.latitude, ll2.latitude) + 0.01, Math.max(ll.longitude, ll2.longitude) + 0.01);
                    final LatLng centroSymmetricRightBottom = new LatLng(Math.min(ll.latitude, ll2.latitude) - 0.01, Math.max(ll.longitude, ll2.longitude) - 0.01);
                    final LatLng centroSymmetricLeftUp = new LatLng(Math.max(ll.latitude, ll2.latitude) + 0.01, Math.min(ll.longitude, ll2.longitude) + 0.01);

                    bounds.include(ll);
                    bounds.include(ll2);
                    bounds.include(centroSymmetric);
                    bounds.include(centroSymmetricLeftBottom).include(centroSymmetricRightUp).include(centroSymmetricRightBottom).include(centroSymmetricLeftUp);


                    MapStatusUpdate u = MapStatusUpdateFactory.newLatLngBounds(bounds.build());

                    mBaiduMap.animateMapStatus(u);
                }


                return true;
            }
        });

        // 初始化搜索模块，注册事件监听
        mSearch = GeoCoder.newInstance();
        mSearch.setOnGetGeoCodeResultListener(this);
        /*
        if(chosenMeterType == MeterProfileModel.MeterTypes.Bluetooth)
        {

        }*/

    }

    private void handleMeterList() {
        prepareListData(listMetersFiltered);
        ExpandableListAdapter customAdapter = new ExpandableMetersListAdapter(this, listGroupData, listDataChild);//new ExpandableListAdapter(this, R.layout.meter_listview, meters);
        metersListview.setAdapter(customAdapter);
        metersListview.setOnChildClickListener(new ExpandableListView.OnChildClickListener() {
            @Override
            public boolean onChildClick(ExpandableListView parent, View v,
                                        int groupPosition, int childPosition, long id) {

                MeterProfileModel meter = (MeterProfileModel) listDataChild.get(listGroupData.get(groupPosition).getLocationCode()).get(childPosition);

                if (meter == null) {
                    return false;
                }

                // Center the meter icon on the map
                if (meter.Latitude != null && meter.Longitude != null) {
                    centerCurrentLocation(meter.Latitude, meter.Longitude);
                }

                // Open meter collection activity
                Bundle b = new Bundle();
                b.putString(Constants.MeterDataIDKey, meter.MeterDataID);
                b.putString(Constants.MeterSNKey, meter.MeterSN);
                b.putString(Constants.MeterAddressKey, meter.Address);
                b.putString(Constants.MeterBuildingNumKey, "");
                b.putString(Constants.MeterCustomerIDKey, meter.CustomerId);
                b.putString(Constants.MeterCustomerNameKey, meter.UserName);
                Intent searchDialog = new Intent(getApplicationContext(), MeterCollectDialogActivity.class);
                searchDialog.putExtras(b);
                startActivity(searchDialog);

                return true;
            }
        });
    }



    public void showInfoWindowCCS(InfoWindow mInfoWindow)
    {

        mBaiduMap.showInfoWindow(mInfoWindow);
        isMarkerShown = true;
    }

    public void hideInfoWindowCCS()
    {

        if(isMarkerShown) {
            mBaiduMap.hideInfoWindow();
            isMarkerShown = false;
            centerCurrentLocationAndZoomOut();

        }

    }
    public void centerCurrentLocationAndZoomOut()
    {

        if(mBaiduMap != null)
        {
            MyLocationData currentLocation = mBaiduMap.getLocationData();
            if(currentLocation != null)
            {
                mBaiduMap.setMyLocationData(currentLocation);
                LatLng ll = new LatLng(currentLocation.latitude,
                        currentLocation.longitude);

                MapStatusUpdate u = MapStatusUpdateFactory.newLatLngZoom(ll, initialZoom != 0 ? initialZoom : (mBaiduMap.getMaxZoomLevel() - mBaiduMap.getMinZoomLevel()) * 0.75f);
                mBaiduMap.animateMapStatus(u);



            }
        }

    }

    public void centerCurrentLocation()
    {
        if(mBaiduMap != null)
        {
            MyLocationData currentLocation = mBaiduMap.getLocationData();
            if(currentLocation != null)
            {
                mBaiduMap.setMyLocationData(currentLocation);
                LatLng ll = new LatLng(currentLocation.latitude,
                        currentLocation.longitude);
                MapStatusUpdate u = MapStatusUpdateFactory.newLatLng(ll);
                mBaiduMap.animateMapStatus(u);

            }
        }

    }

    public void centerCurrentLocation(double lat, double log) {
        if (mBaiduMap != null) {
            LatLng centerLoc = new LatLng(lat, log);
            MapStatusUpdate update = MapStatusUpdateFactory.newLatLng(centerLoc);
            mBaiduMap.animateMapStatus(update);
        }
    }


    public void collectData(View view) {

        if (chosenMeterType == MeterProfileModel.MeterTypes.Manual) {
            return;
        }

        /*final Meter meter ;
        if (chosenMeterType == MeterProfileModel.MeterTypes.WiFi || chosenMeterType == MeterProfileModel.MeterTypes.Bluetooth )
            meter = new DYWirelessMeter();
        else if (chosenMeterType == MeterProfileModel.MeterTypes.Manual)
            meter = new DYDirectMeter();
        else
            meter = new DYDirectMeter();		//光电直读没有做
        box.getSingleData(20, this,meter.getQueryBytes("1".toString()), new Box.OnGetSingleDataListener(){

            @Override
            public void onCommSuccess(byte result[])
            {
                JSONObject json = meter.getQueryObject(result);
                if (json != null)
                {
                    AlertDialog.Builder dialog = new AlertDialog.Builder(MapActivity.this);
                    dialog.setTitle("读取结果");
                    dialog.setMessage(json.toString());
                    dialog.setNegativeButton("确定", null);
                    dialog.create().show();
                }
            }

            @Override
            public void onCommTimeOut() {
                // TODO Auto-generated method stub
                Toast.makeText(MapActivity.this, "连接超时", Toast.LENGTH_LONG).show();
            }

            @Override
            public void onCommFail(int rtcode) {
                // TODO Auto-generated method stub
                Toast.makeText(MapActivity.this, "连接异常,错误码"+rtcode, Toast.LENGTH_LONG).show();

            }});*/
        //new CollectDataPostTask().execute();

        /*
        m_meters = new JSONArray();
        final DYWirelessMeter meter = new DYWirelessMeter();
        box.getMultiData(60, this, meter.FindMetersBytes(), new Box.OnGetMultiDataListener(){

            @Override
            public void onCommSuccess(byte[] result) {
                JSONObject json = meter.FindMeter(result);
                if (json != null)
                {
                    Log.d("blesdk", json.toString());


                    int rt;
                    try {
                        rt = json.getInt("rtcode");
                        if (rt ==  -1)	//收到了结束命令，应当把查询停掉
                            box.stop();
                        else
                        {
                            int uid = json.getInt("表号");
                            Toast.makeText(MapActivity.this, "找到表"+uid, Toast.LENGTH_LONG).show();
                            m_meters.put(uid);
                            Toast.makeText(MapActivity.this, m_meters.toString(), Toast.LENGTH_LONG).show();


                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

                }


            }

            @Override
            public void onCommTimeOut() {
                Toast.makeText(MapActivity.this, "查找结束", Toast.LENGTH_LONG).show();
            }

            @Override
            public void onCommEnd() {
                Toast.makeText(MapActivity.this, "Found." +  m_meters.toString(), Toast.LENGTH_LONG).show();
                Toast.makeText(MapActivity.this, "Reading the data.", Toast.LENGTH_LONG).show();

                if (m_meters == null)
                {
                    Toast.makeText(MapActivity.this, "必须先找表", Toast.LENGTH_LONG).show();
                    return;
                }
                if (m_meters.length() == 0)
                {
                    Toast.makeText(MapActivity.this, "必须先找表", Toast.LENGTH_LONG).show();
                    return;
                }

                Message msg = handler.obtainMessage();
                msg.what = 1;
                msg.arg1 = 0;
                msg.sendToTarget();
            }

            @Override
            public void onCommFail(int rtcode) {
                Toast.makeText(MapActivity.this, "连接异常,错误码"+rtcode, Toast.LENGTH_LONG).show();
            }

        });

        */

        //new CollectDataAsyncTask().execute();


        MapActivity.this.runOnUiThread(new Runnable() {


            public void run() {
                Utilities.showToastMsg(MapActivity.this, "连接到 BT05");
            }
        });

        BleState state  = BleState.getInstance();
        state.setLogEnabled(true);
        if(!state.IsBleEnabled(this))
        {
            Utilities.showAlertDialog("数据采集完毕.", "尚未打开蓝牙通信.", MapActivity.this, getWindow(), false);
        }
        else
        {
            final BluetoothAdapter mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
            if(mBluetoothAdapter == null) {
                Utilities.showAlertDialog("数据采集完毕.", "本设备不支持蓝牙", MapActivity.this, getWindow(), false);
            }
            else {
                if (mBluetoothAdapter != null && !mBluetoothAdapter.isEnabled()) {
                    // Bluetooth is not enable :)
                    AlertDialog.Builder adb = new AlertDialog.Builder(this);




                    adb.setTitle("点通网抄表");


                    // set dialog message
                    adb
                            .setMessage(String.format("系统检测到蓝牙未打开，抄表应用需要蓝牙功能才能进行，是否允许本应用为你打开蓝牙？"))
                            .setCancelable(true);


                    adb.setPositiveButton("是", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {

                            mBluetoothAdapter.enable();

                            MapActivity.this.runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                                    Utilities.showToastMsg(MapActivity.this, "蓝牙已经打开");

                                }
                            });

                            try {

                                connectingPD = ProgressDialog.show(MapActivity.this, "请稍候 ...", "正在连接中 ...", true, false);
                                connectToDevice();

                            } catch (Exception e)
                            {
                            }


                        } });


                    adb.setNegativeButton("否", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {

                        } });
                    adb.show();

                }
                else
                {
                    try {

                        connectingPD = ProgressDialog.show(MapActivity.this, "请稍候 ...", "正在连接中 ...", true, false);
                        connectToDevice();

                    } catch (Exception e)
                    {
                    }
                }
            }
        }
    }

  /*  private class ConnectThread extends Thread {
        @Override
        public void run() {
            connectToDevice();
        }

        private Handler handler = new Handler() {
            @Override
            public void handleMessage(Message msg) {

            }
        }
    }*/

    public void connectToDevice() {

        box.m_name = "BT05";
        //Disable ProgressDialog
        BleState.getInstance().setShowProgress(false);

        if(box.getState() == box.BLE_STATE_READY)
        {
            Utilities.showToastMsg(MapActivity.this,  "抄表盒子已经是连接状态，将跳过连接步骤");

            m_meters = new JSONArray();
            if (listMetersFiltered != null) {
                //listMetersFilteredToList = new LinkedList<>();
                for (MeterProfileModel m : listMetersFiltered.values()) {
                    //listMetersFilteredToList.add(m);
                    m_meters.put(m.MeterSN);
                }

                Utilities.showToastMsg(MapActivity.this, String.format("开始采集%d块水表", listMetersFiltered.size()));

                Message newmsg = handlerSingleMeterCollection.obtainMessage();
                newmsg.what = 1;
                newmsg.arg1 = 0;
                newmsg.sendToTarget();
            } else {
                Utilities.showToastMsg(MapActivity.this, "未找到水表");
                connectingPD.dismiss();
            }

        }
        else {

            Utilities.showToastMsg(MapActivity.this, "抄表盒子尚未连接，现在开始连接");

            box.Connect(Constants.BLECONNECTTIMEOUT, this, new Box.OnConnectListener() {

                @Override
                public void onConnectSuccess() {

                    Utilities.showToastMsg(MapActivity.this, "连接成功");


                    m_meters = new JSONArray();
                    if (listMetersFiltered != null) {
                        //listMetersFilteredToList = new LinkedList<>();
                        for (MeterProfileModel m : listMetersFiltered.values()) {
                            //listMetersFilteredToList.add(m);
                            m_meters.put(m.MeterSN);
                        }

                        Utilities.showToastMsg(MapActivity.this, String.format("开始采集%d块水表", listMetersFiltered.size()));

                        Message newmsg = handlerSingleMeterCollection.obtainMessage();
                        newmsg.what = 1;
                        newmsg.arg1 = 0;
                        newmsg.sendToTarget();
                    } else {
                        Utilities.showToastMsg(MapActivity.this, "未找到水表");
                        connectingPD.dismiss();
                    }
                }

                @Override
                public void onConnectTimeOut() {
                    Utilities.showToastMsg(MapActivity.this, "连接超时");
                    connectingPD.dismiss();
                }


                @Override
                public void onConnectFail(int rtcode) {
                    Utilities.showToastMsg(MapActivity.this, "连接异常");
                    connectingPD.dismiss();
                }

                @Override
                public void onDisconnect() {
                    Utilities.showToastMsg(MapActivity.this, "连接中断");
                    connectingPD.dismiss();
                }

            });
        }

    }

    public void getDataForMeterWithHandler(Handler handlerObj, int indexObj)
    {

        final int index = indexObj;
        try {
            final Handler handler = handlerObj;

            final String sn =  m_meters.getString(index);

            if(!listMeters.containsKey(String.valueOf(sn))) {
                Message newmsg = handler.obtainMessage();
                newmsg.what = 1;
                newmsg.arg1 = index + 1;
                newmsg.sendToTarget();
                return;
            }

            MeterProfileModel m = listMeters.get(sn);
            if(m.isCollected)
            {
                Utilities.showToastMsg(MapActivity.this, "表SN为" + sn + "的数据已经采集完毕.");
                Message newmsg = handler.obtainMessage();
                newmsg.what = 1;
                newmsg.arg1 = index + 1;
                newmsg.sendToTarget();

                return;
            }

            // do what you have to do here
            // In your case, an other loop.
            final Meter meter;
            if (chosenMeterType == MeterProfileModel.MeterTypes.WiFi || chosenMeterType == MeterProfileModel.MeterTypes.Electronic )
                meter = new DYWirelessMeter();
            else if (chosenMeterType == MeterProfileModel.MeterTypes.Manual)
                meter = new DYDirectMeter();
            else
                meter = new DYDirectMeter();		//光电直读没有做

            Utilities.showToastMsg(MapActivity.this, String.format("正在采集表SN为" + sn + "的数据"));
            box.getSingleData(Constants.BLEGETSINGLEDATATIMEOUT, MapActivity.this, meter.getQueryBytes(sn), new Box.OnGetSingleDataListener() {
                @Override
                public void onCommSuccess(byte result[]) {
                    JSONObject json = meter.getQueryObject(result);
                    if (json != null) {

                        Utilities.showToastMsg(MapActivity.this, "Data for " + sn + " is " + json.toString());
                        try {
                            int rtcode = json.getInt(Constants.BLE_TAGS.BLERTCODETAG);
                            if (rtcode == Constants.BLE_TAGS.BLERTCODESUCCESSTAG) {

                                double read = json.getDouble(Constants.BLE_TAGS.BLEPOSITIVEPULSESTAG);
                                //int status = json.getInt(Constants.BLESTATUSTAG);
                                String meterSNStr = sn;
                                if (listMeters != null && listMeters.containsKey(meterSNStr)) {

                                    // Change icon for the meter on the ListView

                                    Utilities.showToastMsg(MapActivity.this, "找到SN为" + meterSNStr + "的水表, 采集数据" + read);
                                    MeterProfileModel m = listMeters.get(meterSNStr);
                                    MySQLiteHelper db = new MySQLiteHelper(MapActivity.this);
                                    db.addRawData(new RawData(m.MeterDataID, "MeasureType1", "rateschedule", "readtype", read, 1.4, "status", new Date()));
                                    m.LastJsonReading = json.toString();
                                    m.LastRead = String.valueOf(read);
                                    m.LastCollected = new Date();
                                    m.isCollected = true;
                                    db.updateMeterData(m);
                                    resetOverlay(listMeters);

                                    //db.addRawData(new RawData("9c6d44eb-4b01-e611-80c8-00155de1e22a", "MeasureType1", "rateschedule", "readtype", 1.2, 1.4, "status", new Date()));
                                    Utilities.showToastMsg(MapActivity.this, "Added " + db.getAllRawData().size());

                                } else {
                                    Utilities.showToastMsg(MapActivity.this, "无法找到SN为" + meterSNStr + "的水表");
                                }

                            } else {
                                String desc = json.getString(Constants.BLE_TAGS.BLEDESCTAG);
                                Utilities.showToastMsg(MapActivity.this, "RTCode is not 0 for " + sn + " Desc " + desc);

                            }
                        } catch (JSONException e) {

                        }


                    }

                    Message newmsg = handler.obtainMessage();
                    newmsg.what = 1;
                    newmsg.arg1 = index + 1;
                    newmsg.sendToTarget();

                }

                @Override
                public void onCommTimeOut() {
                    Utilities.showToastMsg(MapActivity.this, "连接超时");

                    Message newmsg = handler.obtainMessage();
                    newmsg.what = 1;
                    newmsg.arg1 = index + 1;
                    newmsg.sendToTarget();
                }

                @Override
                public void onCommFail(int rtcode) {
                    Utilities.showToastMsg(MapActivity.this, "连接异常,错误码");

                    Message newmsg = handler.obtainMessage();
                    newmsg.what = 1;
                    newmsg.arg1 = index + 1;
                    newmsg.sendToTarget();
                }
            });




        } catch (JSONException e) {
            e.printStackTrace();
        }




    }
    protected Handler handler = new Handler()
    {
        @Override
        public void handleMessage(Message msg)
        {
            if (msg.what == 1)
            {
                if (m_meters == null) {
                    connectingPD.dismiss();
                    return;
                }
                final int index = msg.arg1;
                if (index >= m_meters.length())	//超出了
                {
                    connectingPD.dismiss();
                    int collectedCount = 0;
                    for (Map.Entry<String, MeterProfileModel> entry:
                            listMeters.entrySet()) {
                        if(entry.getValue().isCollected)
                        {
                            collectedCount++;
                        }
                    }

                    AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(
                            MapActivity.this);

                    // set title
                    alertDialogBuilder.setTitle("数据采集完毕.");

                    // set dialog message
                    alertDialogBuilder
                            .setMessage(String.format("在%d块水表中采集到%d块水表的数据", listMeters.size(), collectedCount))
                            .setCancelable(false);

                    alertDialogBuilder.setPositiveButton("确定", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int id) {
                            //do things
                        }
                    });

                    // create alert dialog
                    AlertDialog alertDialog = alertDialogBuilder.create();

                    // show it
                    alertDialog.show();

                    return;
                }
                getDataForMeterWithHandler(handler, index);
            }
            else {
                connectingPD.dismiss();
            }
        }
    };

    protected Handler handlerSingleMeterCollection = new Handler()
    {
        @Override
        public void handleMessage(Message msg)
        {
            if (msg.what == 1)
            {
                if (m_meters == null) {
                    connectingPD.dismiss();
                    return;
                }
                final int index = msg.arg1;
                if (index >= m_meters.length())	//All meters have been tried
                {
                    connectingPD.dismiss();

                    int collectedCount = 0;
                    for (Map.Entry<String, MeterProfileModel> entry:
                            listMeters.entrySet()) {
                        if(entry.getValue().isCollected)
                        {
                            collectedCount++;
                        }
                    }

                    //Check if data for all meters is collected
                    if (collectedCount == m_meters.length()) {

                        AlertDialog.Builder builder = new AlertDialog.Builder(MapActivity.this);
                        builder.setMessage("Data for all meters have been collected!")
                                .setCancelable(false)
                                .setPositiveButton("确定", new DialogInterface.OnClickListener() {
                                    public void onClick(DialogInterface dialog, int id) {
                                        //do things
                                    }
                                });
                        AlertDialog alert = builder.create();
                        alert.show();

                        return;
                    }

                    AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(
                            MapActivity.this);
                    // set title
                    alertDialogBuilder.setTitle("点通网抄表");
                    // set dialog message
                    alertDialogBuilder
                            .setMessage(String.format("在%d块水表中采集到%d块水表的数据", listMeters.size(), collectedCount))
                            .setCancelable(false)
                            .setPositiveButton("找表模式", new DialogInterface.OnClickListener() {
                                public void onClick(DialogInterface dialog, int id) {
                                    Utilities.showToastMsg(MapActivity.this, "进入找表模式...");
                                    connectingPD = ProgressDialog.show(MapActivity.this, "请稍候 ...",	"正在读取表数据 ...", true, false);


                                    m_meters = new JSONArray();
                                    final DYWirelessMeter meter = new DYWirelessMeter();
                                    box.getMultiData(Constants.BLEGETMULTIPLEDATATIMEOUT, MapActivity.this, meter.FindMetersBytes(), new Box.OnGetMultiDataListener() {

                                        @Override
                                        public void onCommSuccess(byte[] result) {
                                            JSONObject json = meter.FindMeter(result);
                                            if (json != null) {


                                                int rt;
                                                try {
                                                    rt = json.getInt("rtcode");
                                                    if (rt == -1)    //收到了结束命令，应当把查询停掉
                                                        box.stop();
                                                    else {
                                                        int uid = json.getInt("表号");
                                                        Utilities.showToastMsg(MapActivity.this, "找到表" + uid);

                                                        m_meters.put(String.valueOf(uid));
                                                        Utilities.showToastMsg(MapActivity.this, m_meters.toString());

                                                    }
                                                } catch (JSONException e) {
                                                    e.printStackTrace();
                                                }

                                            }


                                        }

                                        @Override
                                        public void onCommTimeOut() {
                                            Utilities.showToastMsg(MapActivity.this, "查找结束");
                                            connectingPD.dismiss();
                                        }

                                        @Override
                                        public void onCommEnd() {

                                            Utilities.showToastMsg(MapActivity.this, "Found." + m_meters.toString());

                                            if (m_meters == null || m_meters.length() == 0) {
                                                Utilities.showToastMsg(MapActivity.this, "必须先找表");
                                                connectingPD.dismiss();
                                                return;
                                            }

                                            Message msg = handler.obtainMessage();
                                            msg.what = 1;
                                            msg.arg1 = 0;
                                            msg.sendToTarget();
                                        }

                                        @Override
                                        public void onCommFail(int rtcode) {
                                            Utilities.showToastMsg(MapActivity.this, "连接异常,错误码" + rtcode);
                                            connectingPD.dismiss();
                                        }

                                    });


                                }
                            })
                            .setNeutralButton("重新抄表", new DialogInterface.OnClickListener() {
                                public void onClick(DialogInterface dialog, int id) {
                                    //repeat the collection phase
                                    try {

                                        connectingPD = ProgressDialog.show(MapActivity.this, "请稍候 ...", "正在连接中 ...", true, false);
                                        connectToDevice();

                                    } catch (Exception e)
                                    {
                                    }


                                }
                            })
                            .setNegativeButton("结束抄表", new DialogInterface.OnClickListener() {
                                public void onClick(DialogInterface dialog, int id) {
                                    // Exit
                                    dialog.cancel();
                                }
                            });

                    // create alert dialog
                    AlertDialog alertDialog = alertDialogBuilder.create();
                    // show it
                    alertDialog.show();
                    return;
                }
                getDataForMeterWithHandler(handlerSingleMeterCollection, index);

            }
            else {
                connectingPD.dismiss();
            }
        }
    };

    public void hideList() {

        if (isPanelShown()) {

            InputMethodManager inputMethodManager = (InputMethodManager)  this.getSystemService(Activity.INPUT_METHOD_SERVICE);
            inputMethodManager.hideSoftInputFromWindow(this.getCurrentFocus().getWindowToken(), 0);

            FrameLayout.LayoutParams mapFramePar = (FrameLayout.LayoutParams)mapFrame.getLayoutParams();
            DisplayMetrics metrics = new DisplayMetrics();
            getWindowManager().getDefaultDisplay().getMetrics(metrics);
            int height = metrics.heightPixels;

            // Expand the map frame
            mapFramePar.bottomMargin = 0;
            mapFrame.setLayoutParams(mapFramePar);

            // Hide the Panel
            Animation bottomDown = AnimationUtils.loadAnimation(this,
                    R.anim.bottom_down);

            listFrame.startAnimation(bottomDown);
            listFrame.setVisibility(View.GONE);

            ((ImageButton) switchToListBtn).setImageResource(R.drawable.icon_checklist);
        }

    }

    public void switchToList(final View view) {

        InputMethodManager inputMethodManager = (InputMethodManager)  this.getSystemService(Activity.INPUT_METHOD_SERVICE);
        inputMethodManager.hideSoftInputFromWindow(this.getCurrentFocus().getWindowToken(), 0);

        FrameLayout.LayoutParams listFramePar = (FrameLayout.LayoutParams)listFrame.getLayoutParams();
        DisplayMetrics metrics = new DisplayMetrics();
        getWindowManager().getDefaultDisplay().getMetrics(metrics);

        if (!isPanelShown()) {
            // Collapse the map frame
            //mapFramePar.bottomMargin = height - 20;
            //mapFrame.setLayoutParams(mapFramePar);

            // Show the panel
            Animation bottomUp = AnimationUtils.loadAnimation(this,
                    R.anim.bottom_up);

            listFramePar.topMargin = topHeader.getHeight();
            listFrame.setLayoutParams(listFramePar);
            listFrame.startAnimation(bottomUp);
            listFrame.setVisibility(View.VISIBLE);

            ((ImageButton) view).setImageResource(R.drawable.icon_earth);
        }
        else {
            hideList();
        }
    }

    private boolean isPanelShown() {
        return listFrame.getVisibility() == View.VISIBLE;
    }
    /*
    public void switchToMap(View view) {
        //clearOverlay(null);
        //initOverlay();

        runOnUiThread(new Runnable() {
            public void run() {
                Toast.makeText(MapActivity.this, "Switch to Map", Toast.LENGTH_LONG).show();
            }
        });
        listFrame.setVisibility(View.INVISIBLE);
        mapFrame.setVisibility(View.VISIBLE);


    }

    public void switchToList(View view) {
        //clearOverlay(null);
        //initOverlay();

        runOnUiThread(new Runnable() {
            public void run() {
                Toast.makeText(MapActivity.this, "Switch to List", Toast.LENGTH_LONG).show();
            }
        });
        mapFrame.setVisibility(View.INVISIBLE);
        listFrame.setVisibility(View.VISIBLE);

    }*/

    public void goToCurrentLocation(View view)
    {
        centerCurrentLocation();
    }

    public void searchOverlay(View view) {
        //clearOverlay(null);
        //initOverlay();

        /*runOnUiThread(new Runnable() {
            public void run() {
                Toast.makeText(MapActivity.this, "Search", Toast.LENGTH_LONG).show();
            }
        });*/

    }

    public void resetOverlay(Map<String, MeterProfileModel> listMeters) {
        clearOverlay(null);
        initOverlay(listMeters);

    }


    /**
     * 定位SDK监听函数
     */
    public class MyLocationListenner implements BDLocationListener {

        @Override
        public void onReceiveLocation(BDLocation location) {
            // map view 销毁后不在处理新接收的位置

            String deviceId = Settings.Secure.getString(getContentResolver(),
                    Settings.Secure.ANDROID_ID).toUpperCase();


            if(Arrays.asList(Constants.DevicesWithFakeLocation).contains(deviceId)) {

                location.setLatitude(30.494547);
                location.setLongitude(114.4171886);
            }

            if (location == null || mMapView == null) {
                return;
            }
            MyLocationData locData = new MyLocationData.Builder()
                    .accuracy(location.getRadius())
                            // 此处设置开发者获取到的方向信息，顺时针0-360
                    .direction(100).latitude(location.getLatitude())
                    .longitude(location.getLongitude()).build();

            mBaiduMap.setMyLocationData(locData);
            if (isFirstLoc) {
                isFirstLoc = false;
                LatLng ll = new LatLng(location.getLatitude(),
                        location.getLongitude());
                MapStatusUpdate u = MapStatusUpdateFactory.newLatLng(ll);
                mBaiduMap.animateMapStatus(u);
            }
        }

        public void onReceivePoi(BDLocation poiLocation) {
        }
    }


    @Override
    protected void onPause() {
        mMapView.onPause();
        super.onPause();
    }

    @Override
    protected void onResume() {
        mMapView.onResume();
        super.onResume();

        if(Utilities.isAccessCodeExpired()) {
            Intent nextScreen = new Intent(getApplicationContext(), MainActivity.class);
            startActivity(nextScreen);
        }
        else
        {
            MySharedPref.getInstance().setAccessCodeExpDate();
        }

    }

    @Override
    protected void onDestroy() {
        // 回收 bitmap 资源

        bdred.recycle();
        bdgreen.recycle();
        //bdGround.recycle();
        //unregisterReceiver(mReceiver);
        // 退出时销毁定位
        //mLocClient.stop();
        // 关闭定位图层
        mBaiduMap.setMyLocationEnabled(false);
        mMapView.onDestroy();
        mMapView = null;
        super.onDestroy();
    }
    /**
     * 清除所有Overlay
     *
     * @param view
     */
    public void clearOverlay(View view) {

        mBaiduMap.clear();
    }

    public void initOverlay( Map<String, MeterProfileModel> listMeters) {
        // add marker overlay
        /*LatLng llA = new LatLng(39.963175, 116.400244);
        LatLng llB = new LatLng(39.942821, 116.369199);
        LatLng llC = new LatLng(39.939723, 116.425541);
        LatLng llD = new LatLng(39.906965, 116.401394);

        MarkerOptions ooA = new MarkerOptions().position(llA).icon(bdA)
                .zIndex(9).draggable(true);
        ooA.animateType(MarkerOptions.MarkerAnimateType.drop);
        mMarkerA = (Marker) (mBaiduMap.addOverlay(ooA));

        MarkerOptions ooB = new MarkerOptions().position(llB).icon(bdB)
                .zIndex(5);
        mMarkerB = (Marker) (mBaiduMap.addOverlay(ooB));

        MarkerOptions ooC = new MarkerOptions().position(llC).icon(bdC)
                .perspective(false).anchor(0.5f, 0.5f).rotate(30).zIndex(7);
        mMarkerC = (Marker) (mBaiduMap.addOverlay(ooC));

        ArrayList<BitmapDescriptor> giflist = new ArrayList<BitmapDescriptor>();
        giflist.add(bdA);
        giflist.add(bdB);
        giflist.add(bdC);
        MarkerOptions ooD = new MarkerOptions().position(llD).icons(giflist)
                .zIndex(0).period(10);
        mMarkerD = (Marker) (mBaiduMap.addOverlay(ooD));*/

        //listMeters = MeterProfilesDataHolder.getInstance().getListMeters();


        if(listMeters != null)
        {

            Utilities.showToastMsg(MapActivity.this, "Showing " + listMeters.size() + " meters.");
            int mm = 0;
            for (MeterProfileModel meter : listMeters.values()) {
                mm++;
                if (mm>20) break;

                if(meter.Latitude != null && meter.Longitude != null) {
                    LatLng llA = new LatLng(meter.Latitude, meter.Longitude);

                    //Utilities.showToastMsg(MapActivity.this, meter.Latitude + " " + meter.Longitude);

                    if (meter.isCollected) {
                        MarkerOptions ooA = new MarkerOptions().position(llA).icon(bdgreen)
                                .perspective(false).anchor(0.5f, 0.5f).zIndex(7);
                        //ooA.animateType(MarkerOptions.MarkerAnimateType.drop);
                        Marker mMarker = (Marker) mBaiduMap.addOverlay(ooA);
                        mMarker.setTitle(meter.MeterSN);
                        meter.marker = mMarker;
                    } else {
                        MarkerOptions ooA = new MarkerOptions().position(llA).icon(bdred)
                                .perspective(false).anchor(0.5f, 0.5f).zIndex(7);
                        //ooA.animateType(MarkerOptions.MarkerAnimateType.drop);
                        Marker mMarker = (Marker) mBaiduMap.addOverlay(ooA);
                        mMarker.setTitle(meter.MeterSN);
                        meter.marker = mMarker;
                    }
                }
            }
        }

    }


}
