package my.ccs.projectrawdata;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.Toast;

import com.baidu.location.LocationClient;
import com.baidu.location.LocationClientOption;
import com.baidu.mapapi.map.BaiduMap;
import com.baidu.mapapi.map.MapPoi;
import com.baidu.mapapi.map.MapStatusUpdate;
import com.baidu.mapapi.map.MapStatusUpdateFactory;
import com.baidu.mapapi.map.MapView;
import com.baidu.mapapi.map.MyLocationConfiguration;
import com.baidu.mapapi.model.LatLng;

import org.json.JSONObject;

import java.util.Date;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import my.ccs.projectrawdata.model.MeterProfileModel;
import my.ccs.projectrawdata.sqlite.MySQLiteHelper;

public class MetersInventoryActivity extends Activity {

    ListView metersListview;
    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_meters_inventory);

        metersListview = (ListView) findViewById(R.id.metersInvListView);



        Map<String, MeterProfileModel> allMeters = MeterProfilesDataHolder.getInstance(MetersInventoryActivity.this).getListMeters();

        Utilities.showToastMsg(MetersInventoryActivity.this, "收到" + allMeters.size() + "块水表 " + MainActivity.selectedCustomerId);
        List<MeterProfileModel> meters = new LinkedList<>();
        if(allMeters != null) {
            for (MeterProfileModel m : allMeters.values()) {
                    meters.add(m);
            }
        }

        MetersInventoryListAdapter customAdapter = new MetersInventoryListAdapter(this, R.layout.meterinv_listview, meters);
        metersListview.setAdapter(customAdapter);
        metersListview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                MeterProfileModel meter = (MeterProfileModel) metersListview.getItemAtPosition(position);
                String message = meter.LastJsonReading;
                Utilities.showToastMsg(MetersInventoryActivity.this, message);


                try {
                    if(message != null) {
                        String parsedJsonMsg = "";
                        String errorsMsg = "";
                        JSONObject json = new JSONObject(message);
                        Iterator<?> keys = json.keys();

                        while (keys.hasNext()) {
                            try {
                                String key = (String) keys.next();
                                parsedJsonMsg += key + " -> " + json.get(key) + "\n";
                            } catch (Exception e) {
                                errorsMsg += e.getMessage();
                            }
                        }
                        if (errorsMsg.length() != 0)
                            Utilities.showToastMsg(MetersInventoryActivity.this, errorsMsg);

                        AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(
                                MetersInventoryActivity.this);

                        // set title
                        alertDialogBuilder.setTitle("数据采集完毕.");

                        // set dialog message
                        alertDialogBuilder
                                .setMessage(parsedJsonMsg)
                                .setCancelable(false);

                        alertDialogBuilder.setPositiveButton("确定", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int id) {
                                //do things
                            }
                        });

                        // create alert dialog
                        AlertDialog alertDialog = alertDialogBuilder.create();

                        // show it
                        alertDialog.show();
                    }

                }
                catch (Exception e)
                {
                    Utilities.showToastMsg(MetersInventoryActivity.this, e.getMessage());
                }



            }
        });



    }

    @Override
    protected void onResume() {
        super.onResume();

        if(Utilities.isAccessCodeExpired()) {
            Intent nextScreen = new Intent(getApplicationContext(), MainActivity.class);
            startActivity(nextScreen);
        }
        else
        {
            MySharedPref.getInstance().setAccessCodeExpDate();
        }

    }
}
