package my.ccs.projectrawdata;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.PorterDuff;
import android.preference.DialogPreference;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;

public class SettingsActivity extends Activity {

    //EditText priProfileDownloadEditText;
    //EditText priRawDataUploadEditText;
    EditText backupRawDataUploadEditText1;
    EditText backupRawDataUploadEditText2;
    ImageButton imgBtn;

    public static final String MY_PREFS_NAME = "mySharedPref";
    //public static final String Pri_Profile_Download_Uri_Key = "priProfileDownloadUriKey";
    //public static final String Pri_Rawdata_Upload_Uri_Key = "priRawdata_UploadUriKey";
    public static final String Backup_Rawdata_Upload_Uri_Key1 = "backupRawdata_UploadUriKey1";
    public static final String Backup_Rawdata_Upload_Uri_Key2 = "backupRawdata_UploadUriKey2";

    public boolean settingChanged = false;
    String oldPriProfileDownloadUri;
    String oldPriRawDataUploadUri;
    String oldBackupRawDataUploadUri1;
    String oldBackupRawDataUploadUri2;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        Log.e("MyTag", "onCreate called");

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_settings);

        Utilities.versionName = BuildConfig.VERSION_NAME + "." + BuildConfig.VERSION_CODE;//Utilities.getBuildTime(this);
        TextView versionNumberTxt = (TextView) findViewById(R.id.versionNumberTxtSettings);
        versionNumberTxt.setText( Utilities.versionName);

        //setImgButtonEffect();
        addListeneronSaveSettingButton();
        addListeneronEditTextViews();

    }

    @Override
    protected void onResume() {
        Log.e("MyTag", "Resume called");
        super.onResume();

        if(Utilities.isAccessCodeExpired()) {
            Log.i("MyTag", "Expired");
            Intent nextScreen = new Intent(getApplicationContext(), MainActivity.class);
            startActivity(nextScreen);
        }
        else
        {
            MySharedPref.getInstance().setAccessCodeExpDate();
        }

        //priProfileDownloadEditText = (EditText) findViewById(R.id.primaryProfileDownloadUri);
        //priRawDataUploadEditText = (EditText) findViewById(R.id.primaryRawDataUploadUri);
        backupRawDataUploadEditText1 = (EditText) findViewById(R.id.backupRawDataUploadUri1);
        backupRawDataUploadEditText2 = (EditText) findViewById(R.id.backupRawDataUploadUri2);

        final SharedPreferences sharedPreferences = getSharedPreferences(MY_PREFS_NAME, Context.MODE_PRIVATE);

        //String priProfileDownloadUri = sharedPreferences.getString(Pri_Profile_Download_Uri_Key, Constants.ServerURLs.getMeterProfilesUrl);
        //String priRawDataUploadUri = sharedPreferences.getString(Pri_Rawdata_Upload_Uri_Key,  Constants.ServerURLs.uploadDataUrl);
        //String backupRawDataUploadUri1 = sharedPreferences.getString(Backup_Rawdata_Upload_Uri_Key1,  Constants.ServerURLs.uploadDataUrl);
        //String backupRawDataUploadUri2 = sharedPreferences.getString(Backup_Rawdata_Upload_Uri_Key2,  Constants.ServerURLs.uploadDataUrl);

        //priProfileDownloadEditText.setText(priProfileDownloadUri);
        //priRawDataUploadEditText.setText(priRawDataUploadUri);
        //backupRawDataUploadEditText1.setText(backupRawDataUploadUri1);
        //backupRawDataUploadEditText2.setText(backupRawDataUploadUri2);

        settingChanged = false;
    }

    protected void addListeneronSaveSettingButton()
    {
        imgBtn = (ImageButton) findViewById(R.id.saveSettingsButton);
        imgBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view)
            {
                Log.e("MyTag", "onSaveSettings called");

                saveSettings();

                final String responseMsgFinal = Constants.SAVESETTINGSUCCESSFULLY;
                SettingsActivity.this.runOnUiThread(new Runnable() {
                    public void run() {
                        Utilities.showAlertDialog("Response", responseMsgFinal, SettingsActivity.this, getWindow(), false);
                    }
                });

            }
        });
    }

    private void saveSettings() {

        //priProfileDownloadEditText = (EditText) findViewById(R.id.primaryProfileDownloadUri);
        //priRawDataUploadEditText = (EditText) findViewById(R.id.primaryRawDataUploadUri);
        backupRawDataUploadEditText1 = (EditText) findViewById(R.id.backupRawDataUploadUri1);
        backupRawDataUploadEditText2 = (EditText) findViewById(R.id.backupRawDataUploadUri2);

        final SharedPreferences sharedPreferences = getSharedPreferences(MY_PREFS_NAME, Context.MODE_PRIVATE);

        //String priProfileDownloadUri = priProfileDownloadEditText.getText().toString();
        //String priRawDataUploadUri = priRawDataUploadEditText.getText().toString();
        String backupRawDataUploadUri1 = backupRawDataUploadEditText1.getText().toString();
        String backupRawDataUploadUri2 = backupRawDataUploadEditText2.getText().toString();

        SharedPreferences.Editor editor = sharedPreferences.edit();
        //editor.putString(Pri_Profile_Download_Uri_Key, priProfileDownloadUri);
        //editor.putString(Pri_Rawdata_Upload_Uri_Key, priRawDataUploadUri);
        editor.putString(Backup_Rawdata_Upload_Uri_Key1, backupRawDataUploadUri1);
        editor.putString(Backup_Rawdata_Upload_Uri_Key2, backupRawDataUploadUri2);
        editor.commit();

        settingChanged = false;

    }

    private void addListeneronEditTextViews() {
        /*priProfileDownloadEditText = (EditText) findViewById(R.id.primaryProfileDownloadUri);
        priProfileDownloadEditText.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
                oldPriProfileDownloadUri = s.toString();
            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                if (!s.toString().equals(oldPriProfileDownloadUri)) {
                    settingChanged = true;
                }
            }
        });

        priRawDataUploadEditText = (EditText) findViewById(R.id.primaryRawDataUploadUri);
        priRawDataUploadEditText.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
                oldPriRawDataUploadUri = s.toString();
            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                if (!s.toString().equals(oldPriRawDataUploadUri)) {
                    settingChanged = true;
                }
            }
        });*/

        backupRawDataUploadEditText1 = (EditText) findViewById(R.id.backupRawDataUploadUri1);
        backupRawDataUploadEditText1.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
                oldBackupRawDataUploadUri1 = s.toString();
            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                if (!s.toString().equals(oldBackupRawDataUploadUri1)) {
                    settingChanged = true;
                }
            }
        });

        backupRawDataUploadEditText2 = (EditText) findViewById(R.id.backupRawDataUploadUri2);
        backupRawDataUploadEditText2.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
                oldBackupRawDataUploadUri2 = s.toString();
            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                if (!s.toString().equals(oldBackupRawDataUploadUri2)) {
                    settingChanged = true;
                }
            }
        });
    }

    @Override
    protected void onPause() {
        Log.e("MyTag", "onPause called");
        super.onPause();
    }

    private void setImgButtonEffect(){
        imgBtn = (ImageButton) findViewById(R.id.saveSettingsButton);
        imgBtn.setOnTouchListener(new View.OnTouchListener() {

            public boolean onTouch(View v, MotionEvent event) {
                switch (event.getAction()) {
                    case MotionEvent.ACTION_DOWN: {
                        v.getBackground().setColorFilter(0xe0f47521, PorterDuff.Mode.SRC_ATOP);
                        v.invalidate();
                        break;
                    }
                    case MotionEvent.ACTION_UP: {
                        v.getBackground().clearColorFilter();
                        v.invalidate();
                        break;
                    }
                }
                return false;
            }
        });
    }

    @Override
    public void onBackPressed() {
        //we need to override this to prevent back button from access code page

        if (settingChanged) {
            AlertDialog.Builder alertDialogBuiler = new AlertDialog.Builder(this);
            alertDialogBuiler.setTitle("设置");
            alertDialogBuiler.
                    setMessage("设置已被修改但尚未保存。保存设置吗？")
                    .setCancelable(false)
                    .setPositiveButton("是", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            saveSettings();
                            finish();
                        }
                    })
                    .setNegativeButton("否", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.cancel();
                            finish();
                        }
                    });

            AlertDialog alertDialog = alertDialogBuiler.create();
            alertDialog.show();
        }
        else
        {
            finish();
        }

    }


}