package my.ccs.projectrawdata;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.location.Geocoder;
import android.os.AsyncTask;
import android.os.Handler;
import android.os.Message;
import android.provider.Settings;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import android.app.Activity;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.baidu.location.BDLocation;
import com.baidu.location.BDLocationListener;
import com.baidu.location.LocationClient;
import com.baidu.location.LocationClientOption;
import com.baidu.mapapi.SDKInitializer;
import com.baidu.mapapi.map.MapStatusUpdate;
import com.baidu.mapapi.map.MapStatusUpdateFactory;
import com.baidu.mapapi.map.MyLocationData;
import com.baidu.mapapi.model.LatLng;
import com.baidu.mapapi.search.core.SearchResult;
import com.baidu.mapapi.search.geocode.GeoCodeResult;
import com.baidu.mapapi.search.geocode.GeoCoder;
import com.baidu.mapapi.search.geocode.OnGetGeoCoderResultListener;
import com.baidu.mapapi.search.geocode.ReverseGeoCodeOption;
import com.baidu.mapapi.search.geocode.ReverseGeoCodeResult;

import org.json.JSONArray;
import org.json.JSONObject;

import javax.net.ssl.HttpsURLConnection;

import my.ccs.projectrawdata.model.MeterProfileModel;
import my.ccs.projectrawdata.sqlite.MySQLiteHelper;
import my.ccs.projectrawdata.model.tasks.*;
public class UploadMeterInfoActivity extends Activity implements OnGetGeoCoderResultListener {

    // LogCat tag
    public static final String TAG = "MyTag";

    private static boolean isFakeDevice = false;

    // Camera activity request codes
    public static final int CAMERA_CAPTURE_IMAGE_REQUEST_CODE = 100;
    public static final int CAMERA_CAPTURE_VIDEO_REQUEST_CODE = 200;

    public static final int MEDIA_TYPE_IMAGE = 1;
    public static final int MEDIA_TYPE_VIDEO = 2;

    private Uri fileUri; // file url to store image/video
    private Uri fileUri2;
    private Uri fileUri3;
    private Uri fileUri4;
    private ImageButton btnUploadMeterInfo;
    private ImageButton imgPreview1;
    private ImageButton imgPreview2;
    private ImageButton imgPreview3;
    private ImageButton imgPreview4;
    private ImageButton meterSearchImg;
    private ImageButton locImg;

    private MetersListAdapter customAdapter;

    private EditText meterAddressTextField;
    private EditText meterAreaTextField;
    private EditText meterLatTextField;
    private EditText meterLongTextField;

    private static double curLatitude = 0.0;
    private static double curLongitude = 0.0;

    Bitmap bitmapIconFrame;
    Bitmap bitmapIconUpload;

    List<ImageButton> imageButtons = new LinkedList<>();
    private ImageButton currentImageButton;
    int displayWidth;
    int displayHeight;
    ListView listView;
    static List<MeterProfileModel> meters = new LinkedList<>();

    Map<String, MeterProfileModel> listMetersFiltered = new LinkedHashMap<>();
    final Map<String, MeterProfileModel> listMeters = new LinkedHashMap<>();

    // Location service related members
    private GeoCoder mSearch = null;
    LocationClient mLocClient = null;
    public MyLocationListenner myListener = new MyLocationListenner();
    public MyLocationData currentLoc = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        SDKInitializer.initialize(getApplicationContext());

        super.onCreate(savedInstanceState);

        String deviceId = Settings.Secure.getString(getContentResolver(),
                Settings.Secure.ANDROID_ID).toUpperCase();

        //deviceId = "B91937A334ED28ED";

        if(Arrays.asList(Constants.DevicesWithFakeLocation).contains(deviceId)) {
            isFakeDevice = true;
        }

        setContentView(R.layout.activity_upload_meter_info);

        // Changing action bar background color
        // These two lines are not needed

        DisplayMetrics metrics = new DisplayMetrics();
        getWindow().getWindowManager().getDefaultDisplay().getMetrics(metrics);
        //getDialog().getWindow().setBackgroundDrawable(new ColorDrawable(0));
        displayWidth = metrics.widthPixels;
        displayHeight = metrics.heightPixels;

        Map<String, MeterProfileModel> allMeters = MeterProfilesDataHolder.getInstance(UploadMeterInfoActivity.this).getListMeters();

        listView = (ListView) findViewById(R.id.listView);

        // get data from the table by the ListAdapter
        //MetersListAdapter customAdapter = new MetersListAdapter(this, R.layout.meterlistrow, MeterProfilesDataHolder.getInstance().getListMeters());
        meters = new LinkedList<>();
        for(MeterProfileModel m : allMeters.values()) {
            listMeters.put(m.MeterDataID, m);
            meters.add(m);
        }

        // Initialize filteredMeters with full meter list
        MeterProfilesDataHolder.getInstance(UploadMeterInfoActivity.this).setFilteredMeters(meters);

        customAdapter = new MetersListAdapter(this, R.layout.meter_listview, meters);
        listView.setAdapter(customAdapter);

        btnUploadMeterInfo = (ImageButton) findViewById(R.id.btnUploadMeterInfo);
        imgPreview1 = (ImageButton) findViewById(R.id.imgPreview1);
        imgPreview2 = (ImageButton) findViewById(R.id.imgPreview2);
        imgPreview3 = (ImageButton) findViewById(R.id.imgPreview3);
        imgPreview4 = (ImageButton) findViewById(R.id.imgPreview4);
        imageButtons.add(imgPreview1);
        imageButtons.add(imgPreview2);
        imageButtons.add(imgPreview3);
        imageButtons.add(imgPreview4);

        meterSearchImg = (ImageButton) findViewById(R.id.meterSearchImg);
        meterSearchImg.setOnClickListener(new View.OnClickListener() {

            public void onClick(View view) {
                Intent searchDialog = new Intent(getApplicationContext(), MeterSearchDialogActivity.class);
                startActivity(searchDialog);
            }
        });

        locImg = (ImageButton) findViewById(R.id.locImg);
        locImg.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {

                Intent nextScreen = new Intent(getApplicationContext(), MapDialogActivity.class);
                startActivity(nextScreen);

            }
        });


        bitmapIconUpload = BitmapFactory.decodeResource(getResources(), R.drawable.icon_document_save);
        bitmapIconUpload=Bitmap.createScaledBitmap(bitmapIconUpload, displayWidth/6, displayWidth/6, true);
        btnUploadMeterInfo.setImageBitmap(bitmapIconUpload);

        /**
         * Upload meter info button click event
         */
        btnUploadMeterInfo.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {

                EditText sequenceIDEditText = (EditText) findViewById(R.id.sequenceID);
                String sequenceID = sequenceIDEditText.getText().toString();

                if (sequenceID.matches("")) {

                    Toast.makeText(UploadMeterInfoActivity.this, "表编号不能为空", Toast.LENGTH_LONG).show();

                     return;
                }

                Utilities.showToastMsg(UploadMeterInfoActivity.this, "Uploading started!!!");
                List<MeterProfileModel> filteredList = MeterProfilesDataHolder.getInstance(UploadMeterInfoActivity.this).getFilteredMeters();
                new UploadMeterInfoTask(UploadMeterInfoActivity.this, filteredList, curLatitude, curLongitude).run();
            }
        });

        // Checking camera availability
        if (!isDeviceSupportCamera()) {
            Utilities.showToastMsg(UploadMeterInfoActivity.this, "This device doesn't support camera");
            // will close the app if the device does't have camera
            finish();
        }

        bitmapIconFrame = BitmapFactory.decodeResource(getResources(), R.drawable.icon_frame);
        bitmapIconFrame=Bitmap.createScaledBitmap(bitmapIconFrame, displayWidth/5, displayWidth/5, true);

        imgPreview1.setImageBitmap(bitmapIconFrame);
        imgPreview2.setImageBitmap(bitmapIconFrame);
        imgPreview3.setImageBitmap(bitmapIconFrame);
        imgPreview4.setImageBitmap(bitmapIconFrame);

        for(final ImageButton imageButton : imageButtons)
        {
            imageButton.setOnClickListener(new View.OnClickListener() {
                public void onClick(View view) {

                    // custom dialog
                    final Dialog dialog = new Dialog(UploadMeterInfoActivity.this);
                    Window window = dialog.getWindow();
                    window.requestFeature(Window.FEATURE_NO_TITLE);
                    dialog.setContentView(R.layout.choose_picture_action);
                    window.setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
                    dialog.setCancelable(true);

                    ImageButton btnCapturePicture;
                    ImageButton btnRemovePicture;

                    TextView btnCapturePictureTxt;
                    TextView btnRemovePictureTxt;

                    btnCapturePicture = (ImageButton) dialog.findViewById(R.id.btnCapturePicture);
                    btnRemovePicture = (ImageButton) dialog.findViewById(R.id.btnRemovePicture);
                    btnCapturePictureTxt = (TextView) dialog.findViewById(R.id.btnCapturePictureTxt);
                    btnRemovePictureTxt = (TextView) dialog.findViewById(R.id.btnRemovePictureTxt);
                    /**
                     * Capture image button click event
                     */
                    btnCapturePicture.setOnClickListener(new View.OnClickListener() {

                        @Override
                        public void onClick(View v) {
                            // capture picture
                            if(dialog != null)
                            {
                                dialog.dismiss();
                            }
                            currentImageButton = imageButton;
                            captureImage();

                        }
                    });
                    btnCapturePictureTxt.setOnClickListener(new View.OnClickListener() {
                        public void onClick(View view) {
                            // capture picture
                            if(dialog != null)
                            {
                                dialog.dismiss();
                            }
                            currentImageButton = imageButton;
                            captureImage();

                        }
                    });


                    /**
                     * Capture image button click event
                     */
                    btnRemovePicture.setOnClickListener(new View.OnClickListener() {

                        @Override
                        public void onClick(View v) {

                            if(dialog != null)
                            {
                                dialog.dismiss();
                            }
                            imageButton.setImageBitmap(bitmapIconFrame);

                        }
                    });
                    btnRemovePictureTxt.setOnClickListener(new View.OnClickListener() {
                        public void onClick(View view) {
                            if(dialog != null)
                            {
                                dialog.dismiss();
                            }
                            imageButton.setImageBitmap(bitmapIconFrame);

                        }
                    });

                    dialog.show();

                }
            });


        }

        mLocClient = new LocationClient(this);
        mLocClient.registerLocationListener(myListener);
        LocationClientOption option = new LocationClientOption();
        option.setOpenGps(true); // 打开gps
        option.setCoorType("bd09ll"); // 设置坐标类型
        option.setScanSpan(1000);
        mLocClient.setLocOption(option);
        mLocClient.start();

        mSearch = GeoCoder.newInstance();
        mSearch.setOnGetGeoCodeResultListener(this);

    }

    /**
     * 定位SDK监听函数
     */
    public class MyLocationListenner implements BDLocationListener {

        @Override
        public void onReceiveLocation(BDLocation location) {

//            Toast.makeText(UploadMeterInfoActivity.this, "onReceiveLocation is called",
//                    Toast.LENGTH_LONG).show();

            // map view 销毁后不在处理新接收的位置


//            Toast.makeText(UploadMeterInfoActivity.this, "real location is " + location.getLatitude() + " " + location.getLongitude(),
//                    Toast.LENGTH_LONG).show();

            if(isFakeDevice) {
//                int i = (int)Math.floor(Utilities.Locations.length * Math.random());
                int i = 0;
                location.setLatitude(Utilities.Locations[i][0]);
                location.setLongitude(Utilities.Locations[i][1]);

//                Toast.makeText(UploadMeterInfoActivity.this, "Location is fake",
//                        Toast.LENGTH_LONG).show();

            }

            currentLoc = new MyLocationData.Builder()
                    .accuracy(location.getRadius())
                            // 此处设置开发者获取到的方向信息，顺时针0-360
                    .direction(100).latitude(location.getLatitude())
                    .longitude(location.getLongitude()).build();


            if (currentLoc != null) {
                LatLng ptCenter = new LatLng((currentLoc.latitude), (currentLoc.longitude));
                // 反Geo搜索
                mSearch.reverseGeoCode(new ReverseGeoCodeOption()
                        .location(ptCenter));
            }

        }

        public void onReceivePoi(BDLocation poiLocation) {
        }
    }


    /**
     * Displaying captured image/video on the screen
     * */
    private void previewMedia(boolean isImage) {
        // Checking whether captured media is image or video
        if (isImage) {
            if(currentImageButton != null)
            {
                currentImageButton.setVisibility(View.VISIBLE);
                // bimatp factory

                DisplayMetrics metrics = new DisplayMetrics();
                getWindow().getWindowManager().getDefaultDisplay().getMetrics(metrics);
                //getDialog().getWindow().setBackgroundDrawable(new ColorDrawable(0));
                int width = metrics.widthPixels/5;
                int height = width;

                Bitmap bitmap = BitmapFactory.decodeFile( fileUri.getPath());
                bitmap=Bitmap.createScaledBitmap(bitmap, width,height, true);
                currentImageButton.setImageBitmap(bitmap);
            }
        }
    }

    /**
     * Checking device has camera hardware or not
     * */
    private boolean isDeviceSupportCamera() {
        return getApplicationContext().getPackageManager().hasSystemFeature(PackageManager.FEATURE_CAMERA);
    }

    /**
     * Launching camera app to capture image
     */
    private void captureImage() {
        Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);

        fileUri = getOutputMediaFileUri(MEDIA_TYPE_IMAGE);

        intent.putExtra(MediaStore.EXTRA_OUTPUT, fileUri);

        // start the image capture Intent
        startActivityForResult(intent, CAMERA_CAPTURE_IMAGE_REQUEST_CODE);
    }


    /**
     * Here we store the file url as it will be null after returning from camera
     * app
     */
    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);

        // save file url in bundle as it will be null on screen orientation
        // changes
        outState.putParcelable("file_uri", fileUri);
    }

    @Override
    protected void onRestoreInstanceState(Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);

        // get the file url
        fileUri = savedInstanceState.getParcelable("file_uri");
    }

    /**
     * Receiving activity result method will be called after closing the camera
     * */
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        // if the result is capturing Image
        if (requestCode == CAMERA_CAPTURE_IMAGE_REQUEST_CODE) {
            if (resultCode == RESULT_OK) {

                // successfully captured the image
                // launching upload activity
                //launchUploadActivity(true);
                String filePath = fileUri.getPath();
                if (filePath != null) {
                    /*Toast.makeText(getApplicationContext(),
                            "Filepath " + filePath, Toast.LENGTH_LONG).show();*/

                    // Displaying the image or video on the screen
                    previewMedia(true);
                } else {
                    Utilities.showToastMsg(UploadMeterInfoActivity.this, "Sorry, file path is missing!");

                }

            } else if (resultCode == RESULT_CANCELED) {
                // user cancelled Image capture
                Utilities.showToastMsg(UploadMeterInfoActivity.this, "User cancelled image capture");

            } else {
                // failed to capture image
                Utilities.showToastMsg(UploadMeterInfoActivity.this, "Sorry! Failed to capture image");
            }
        }
    }

    /*private void launchUploadActivity(boolean isImage){
        Intent i = new Intent(UploadMeterInfoActivity.this, UploadActivity.class);
        i.putExtra("filePath", fileUri.getPath());
        i.putExtra("isImage", isImage);
        startActivity(i);
    }*/

    /**
     * ------------ Helper Methods ----------------------
     * */

    /**
     * Creating file uri to store image/video
     */
    public Uri getOutputMediaFileUri(int type) {
        return Uri.fromFile(getOutputMediaFile(type));
    }

    /**
     * returning image / video
     */
    private static File getOutputMediaFile(int type) {

        // External sdcard location
        File mediaStorageDir = new File(
                Environment
                        .getExternalStoragePublicDirectory(Environment.DIRECTORY_PICTURES),
                Constants.IMAGE_DIRECTORY_NAME);

        // Create the storage directory if it does not exist
        if (!mediaStorageDir.exists()) {
            if (!mediaStorageDir.mkdirs()) {
                return null;
            }
        }

        // Create a media file name
        String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss",
                Locale.getDefault()).format(new Date());
        File mediaFile;
        if (type == MEDIA_TYPE_IMAGE) {
            mediaFile = new File(mediaStorageDir.getPath() + File.separator
                    + "IMG_" + timeStamp + ".jpg");
        } else if (type == MEDIA_TYPE_VIDEO) {
            mediaFile = new File(mediaStorageDir.getPath() + File.separator
                    + "VID_" + timeStamp + ".mp4");
        } else {
            return null;
        }

        return mediaFile;
    }

    @Override
    public void onResume(){
//      Toast.makeText(UploadMeterInfoActivity.this, "onResume is called", Toast.LENGTH_LONG).show();
        super.onResume();
        Log.e(Constants.MyTag, "Resume called");
        //Starting Home Activity
        if(Utilities.isAccessCodeExpired()) {
            Log.i(Constants.MyTag, "Expired");
            Intent nextScreen = new Intent(getApplicationContext(), MainActivity.class);
            startActivity(nextScreen);
        }
        else
        {
            MySharedPref.getInstance().setAccessCodeExpDate();
        }

        // Populate MeterLists with query results
        List<MeterProfileModel> filteredMeters = MeterProfilesDataHolder.getInstance(UploadMeterInfoActivity.this).getFilteredMeters();
        customAdapter = new MetersListAdapter(this, R.layout.meter_listview, filteredMeters);
        listView.setAdapter(customAdapter);

    }

    @Override
    public void onGetReverseGeoCodeResult(ReverseGeoCodeResult result) {
        if (result == null || result.error != SearchResult.ERRORNO.NO_ERROR) {
            Utilities.showToastMsg(UploadMeterInfoActivity.this, "抱歉，未能找到结果");
            return;
        }
//        Toast.makeText(UploadMeterInfoActivity.this, result.getAddress(),
//                Toast.LENGTH_LONG).show();
        ReverseGeoCodeResult.AddressComponent addressComponent = result.getAddressDetail();
        String detailedAddress =
                "当前地址：" + result.getAddress() + "\n" +
                        "省: " + addressComponent.province + "\n" +
                        "市: " + addressComponent.city + "\n" +
                        "区县: " + addressComponent.district + "\n" +
                        "街道: " + addressComponent.street + "\n" +
                        "门牌号码: " + addressComponent.streetNumber + "\n";

        if (isFakeDevice) {
//            Toast.makeText(UploadMeterInfoActivity.this, detailedAddress,
//                    Toast.LENGTH_LONG).show();
        }

        setLocationCode(result);

    }

    public void setLocationCode(ReverseGeoCodeResult revGeoCode) {

        ReverseGeoCodeResult.AddressComponent addressInfo = revGeoCode.getAddressDetail();

        String province = addressInfo.province;
        String city = addressInfo.city;
        String district = addressInfo.district;

        String provinceCode = "NA";
        String cityCode = "NA";
        String districtCode = "NA";

        if (province.isEmpty() || city.isEmpty() || district.isEmpty()) {
            Utilities.showToastMsg(UploadMeterInfoActivity.this, "无效地址信息");
            return;
        }

        if (Utilities.Provinces.containsKey(province)) {
            provinceCode = Utilities.Provinces.get(province);
        }

        if (Utilities.Cities.containsKey(city)) {
            cityCode = Utilities.Cities.get(city);
        }

        if (Utilities.Districts.containsKey(district)) {
            districtCode = Utilities.Districts.get(district);
        }

        if (provinceCode.equalsIgnoreCase("NA") || cityCode.equalsIgnoreCase("NA") || districtCode.equalsIgnoreCase("NA")) {
            Utilities.showToastMsg(UploadMeterInfoActivity.this, "当前位置编码未定义");
        }

        EditText provinceIDEditText = (EditText) findViewById(R.id.provinceID);
        provinceIDEditText.setText(provinceCode);

        EditText cityIDEditText = (EditText) findViewById(R.id.cityID);
        cityIDEditText.setText(cityCode);

        EditText districtIDEditText = (EditText) findViewById(R.id.districtID);
        districtIDEditText.setText(districtCode);

        EditText longEditText = (EditText) findViewById(R.id.locLongitude);
        curLongitude = revGeoCode.getLocation().longitude;
        longEditText.setText(String.valueOf(new DecimalFormat("#.##").format(revGeoCode.getLocation().longitude)));

        EditText latEditText = (EditText) findViewById(R.id.locLatitude);
        curLatitude = revGeoCode.getLocation().latitude;
        latEditText.setText(String.valueOf(new DecimalFormat("#.##").format(revGeoCode.getLocation().latitude)));

    }

    @Override
    public void onGetGeoCodeResult(GeoCodeResult result) {
        if (result == null || result.error != SearchResult.ERRORNO.NO_ERROR) {
            Utilities.showToastMsg(UploadMeterInfoActivity.this, "抱歉，未能找到结果");
            return;
        }

        String strInfo = String.format("纬度：%f 经度：%f",
                result.getLocation().latitude, result.getLocation().longitude);
        Utilities.showToastMsg(UploadMeterInfoActivity.this, strInfo);
    }
}
