package my.ccs.projectrawdata;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.webkit.GeolocationPermissions;
import android.webkit.ValueCallback;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.ProgressBar;
import android.widget.Toast;

import java.util.LinkedList;

public class WhatIsNewActivity extends Activity {

    WebView webView;
    ProgressBar progressBar;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_what_is_new);

        progressBar = (ProgressBar) findViewById(R.id.progressBar);

        initWebView();
        webView.loadUrl(Constants.ServerURLs.whatIsNewUrl);

    }
    protected void initWebView()
    {
        webView = (WebView) findViewById(R.id.whatIsNewWebView);
        if(webView != null) {
            WebSettings webSettings = webView.getSettings();
            webSettings.setBuiltInZoomControls(true);
            webSettings.setJavaScriptEnabled(true);
            webSettings.setGeolocationEnabled(true);
            webSettings.setAppCacheEnabled(true);
            webSettings.setDatabaseEnabled(true);
            webSettings.setDomStorageEnabled(true);

            webView.getSettings().setUserAgentString(
                    this.webView.getSettings().getUserAgentString()
                            + " "
                            + Constants.userAgentString
            );


            webView.setWebViewClient(new Callback());
        }
    }

    private class Callback extends WebViewClient {

        boolean errorDetected = false;

        @Override
        public void onPageStarted(WebView view, String url, Bitmap favicon) {
            if(progressBar != null) {
                progressBar.setVisibility(View.VISIBLE);

            }
            errorDetected = false;
        }

        @Override
        public boolean shouldOverrideUrlLoading(WebView view, String url) {

            return (false);
        }

        //This is called when page is finished loading
        @Override
        public void onPageFinished(WebView view, String url)
        {

            if(progressBar != null) {
                progressBar.setVisibility(View.GONE);
            }


        }

        @Override
        public void onReceivedError(WebView view, int errorCode, String description, String failingUrl) {
            errorDetected = true;
        }

    }

}
