package my.ccs.projectrawdata.model;

import com.baidu.mapapi.map.Marker;

import java.util.ArrayList;
import java.util.Date;

/**
 * Created by Hayk on 4/24/2016.
 */



public class MeterProfileModel
{
    public String MeterDataID;
    public String MeterSN;
    public String Address;
    public String MeterID;
    public String UserName;
    public Double Latitude;
    public Double Longitude;
    public String PhoneUUID;
    public Marker marker = null;
    public Date LastCollected = null;
    public Date LastUploaded = null;
    public Date UpdateTimeStamp = null;
    public String LastRead = null;
    public String LastJsonReading = null;
    public String CustomerId = null;
    public String LocationCode = null;

    public boolean isCollected = false;
    public boolean isChecked = false;
    public enum MeterTypes {
        WiFi,
        Electronic,
        Bus,
        Manual;

        public static MeterTypes fromInteger(int x) {
            switch(x) {
                case 0:
                    return WiFi;
                case 1:
                    return Electronic;
                case 2:
                    return Bus;
                case 3:
                    return Manual;

            }
            return Manual;
        }

        public static MeterTypes fromString(String x) {
            if(x.equalsIgnoreCase("WiFi"))
                return WiFi;
            if(x.equalsIgnoreCase("Electronic"))
                return Electronic;
            if(x.equalsIgnoreCase("Bus"))
                return Bus;
            if(x.equalsIgnoreCase("Manual"))
                return Manual;

            return Manual;
        }


    };

    public class MeterUploadDataModel {
        public ArrayList<String> MeterList;
        public String LocationCode;
        public Double Latitude;
        public Double Longitude;
        public ArrayList<String> Images;

        public MeterUploadDataModel (ArrayList<String> meters, String locationCode, Double latitude, Double longitue, ArrayList<String> images) {
            this.MeterList = meters;
            this.LocationCode = locationCode;
            this.Latitude = latitude;
            this.Longitude = longitue;
            this.Images = images;
        }
    };

    public MeterTypes MeterType;

    public MeterProfileModel() {

    }
    public MeterProfileModel(String meterDataID, String MeterID, Double Latitude, Double Longitude, String PhoneUUID, String MeterType, String UserName, String Address, String MeterSN, String CustomerId,
                             String LocationCode)
    {
        this.MeterDataID = meterDataID;
        this.MeterID = MeterID;
        this.Latitude = Latitude;
        this.Longitude = Longitude;
        this.PhoneUUID = PhoneUUID;
        this.MeterSN = MeterSN;
        this.MeterType = MeterTypes.fromString(MeterType);
        this.UserName = UserName;
        this.Address = Address;
        this.UpdateTimeStamp = new Date();
        this.CustomerId = CustomerId;
        this.LocationCode = LocationCode;
    }
}
