package my.ccs.projectrawdata.model;

import android.support.annotation.NonNull;

import com.xgg.blesdk.Meter;

import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;

import my.ccs.projectrawdata.model.MeterProfileModel;
/**
 * Created by tafeng on 5/29/2016.
 */
public class MeterQueryModel {

    public MeterProfileModel.MeterTypes MeterType;
    public String MeterSN;
    public String MeterAddress;
    public String MeterBuildingNumber;
    public Boolean MeterPositionedChosen;

    public MeterQueryModel(MeterProfileModel.MeterTypes type, String meterSN, String meterAddr, String buildingNum, Boolean meterPositioned) {
        MeterType = type;
        MeterSN = meterSN;
        MeterAddress = meterAddr;
        MeterBuildingNumber = buildingNum;
        MeterPositionedChosen = meterPositioned;
    }

    public List<MeterProfileModel> queryMeters(Map<String, MeterProfileModel> allMeters) {
        List<MeterProfileModel> result = new LinkedList<>();
        List<MeterProfileModel> meterTypeResult = new LinkedList<>();
        List<MeterProfileModel> meterSNResult = new LinkedList<>();
        List<MeterProfileModel> meterAddrResult = new LinkedList<>();
        List<MeterProfileModel> meterBuildingNumResult = new LinkedList<>();
        List<MeterProfileModel> meterPositionedResult = new LinkedList<>();

        if(allMeters != null) {

            // Check MeterType
            if (MeterType == MeterProfileModel.MeterTypes.WiFi ) {
                for(MeterProfileModel m : allMeters.values())
                {
                    if (m.MeterType == MeterProfileModel.MeterTypes.WiFi) {
                        meterTypeResult.add(m);
                    }
                }
            }
            else if (MeterType == MeterProfileModel.MeterTypes.Electronic) {
                for(MeterProfileModel m : allMeters.values())
                {
                    if (m.MeterType == MeterProfileModel.MeterTypes.Electronic) {
                        meterTypeResult.add(m);
                    }
                }
            }
            else if (MeterType == MeterProfileModel.MeterTypes.Bus) {
                for(MeterProfileModel m : allMeters.values())
                {
                    if (m.MeterType == MeterProfileModel.MeterTypes.Bus) {
                        meterTypeResult.add(m);
                    }
                }
            }
            else {
                for(MeterProfileModel m : allMeters.values()) {
                    if (m.MeterType == MeterProfileModel.MeterTypes.Manual) {
                        meterTypeResult.add(m);
                    }
                }
            }
        }

        // Check MeterSN
        if (MeterSN != null && MeterSN.length() > 0) {
            for (MeterProfileModel m : meterTypeResult) {
                if (m.MeterSN.toUpperCase().contains(MeterSN.toUpperCase())) {
                    meterSNResult.add(m);
                }
            }
        }
        else {
            meterSNResult.addAll(meterTypeResult);
        }

        // Check MeterAddr
        if (MeterAddress != null && MeterAddress.length() > 0) {
            for (MeterProfileModel m : meterSNResult) {
                if (m.Address.toUpperCase().contains(MeterAddress.toUpperCase())) {
                    meterAddrResult.add(m);
                }
            }
        }
        else {
            meterAddrResult.addAll(meterSNResult);
        }

        // TO-DO: Check MeterBuildingNum
        /*
        if (MeterBuildingNumber != null && MeterBuildingNumber.length() > 0) {
            for (MeterProfileModel m : meterAddrResult) {

            }
        }
        */

        if (MeterPositionedChosen) {
            for (MeterProfileModel m : meterAddrResult) {
                if (m.Latitude != null && m.Longitude != null) {
                    meterPositionedResult.add(m);
                }
            }
        }
        else {
            meterPositionedResult.addAll(meterAddrResult);
        }

        result.addAll(meterPositionedResult);

        return result;
    }

}
