package my.ccs.projectrawdata.model.tasks;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.util.Log;
import android.widget.EditText;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import javax.net.ssl.HttpsURLConnection;

import my.ccs.projectrawdata.CShowProgress;
import my.ccs.projectrawdata.Constants;
import my.ccs.projectrawdata.MeterProfilesDataHolder;
import my.ccs.projectrawdata.MySharedPref;
import my.ccs.projectrawdata.R;
import my.ccs.projectrawdata.Utilities;
import my.ccs.projectrawdata.model.MeterProfileModel;
import my.ccs.projectrawdata.sqlite.MySQLiteHelper;

/**
 * Created by Hayk on 6/3/2016.
 */
public class DownloadMetersTask extends BaseTask {


    private Activity activity = null;
    private String deviceId = null;
    public DownloadMetersTask(Activity activity, String deviceId)
    {
        this.activity = activity;
        this.deviceId = deviceId;
    }
    public void run()
    {
        new SendDownloadMeterTask().execute();
    }


    private String sendDownloadMetersPost() {

        //MySQLiteHelper dbHelper  = new MySQLiteHelper(HomeActivity.this);
        //SQLiteDatabase db = dbHelper.getWritableDatabase();
        //int x = db.getVersion();
        //dbHelper.addMeterData(new MeterProfileModel("x","x",1.,1.,"x", "x", "x", "x", "x", "x"));
        String response = null;
        InputStream input = null;
        OutputStream output = null;
        HttpURLConnection conn = null;

        try {
            if (deviceId != null && deviceId.length() != 0) {
                URL url = new URL(Constants.ServerURLs.getMeterProfilesUrl);
                conn = (HttpURLConnection) url.openConnection();
                conn.setRequestMethod("POST");
                conn.setRequestProperty("User-Agent", Constants.userAgentString);
                conn.setRequestProperty("Content-Type", "application/json");

                JSONObject jsonParam = new JSONObject();
                jsonParam.put(Constants.JSONReqDeviceIDTag, deviceId);
                String selectedCustomerId = MySharedPref.getInstance().getCurrentSelectedCustomerID();
                jsonParam.put(Constants.JSONReqCustomerIdTag, selectedCustomerId);

                output = conn.getOutputStream();
                BufferedWriter writer = new BufferedWriter(
                        new OutputStreamWriter(output, "UTF-8"));
                writer.write(jsonParam.toString());
                writer.flush();
                writer.close();
                output.close();

                //read response from the server
                int responseCode = conn.getResponseCode();
                if (responseCode == HttpsURLConnection.HTTP_OK) {

                    //String line;
                    int dataLength = conn.getContentLength();
                    input = conn.getInputStream();
                    //BufferedReader br=new BufferedReader(new InputStreamReader());
                    response = Constants.EMPTYSTRING;
                    /*while ((line=br.readLine()) != null) {
                        response += line;

                    }*/

                    final char[] buffer = new char[4096];
                    final StringBuilder out = new StringBuilder();

                    taskStatusCode = TaskStatusCode.SucceededJSON;

                    long total = 0;
                    Reader in = new InputStreamReader(input);
                    int previousPercentIndex = -1;
                    for (; ; ) {
                        int rsz = in.read(buffer, 0, buffer.length);
                        if (rsz < 0) {
                            //Utilities.showToastMsg(HomeActivity.this, "Downloaded 100%");
                            break;
                        }
                        out.append(buffer, 0, rsz);
                        total += rsz;
                        Log.i(Constants.MyTag, "Total - " + dataLength + " downloaded " + total);
                        int progressInPercent = (int) (total * 100 / dataLength);
                        int currentPercentIndex = (int) (progressInPercent / 50);
                        if (currentPercentIndex != previousPercentIndex) {
                            previousPercentIndex = currentPercentIndex;
                            //Utilities.showToastMsg(HomeActivity.this, "Downloading... " + progressInPercent +"%");
                        }


                    }

                    taskResponse = out.toString();
                    taskStatusCode = TaskStatusCode.SucceededJSON;

                } else {
                    taskStatusMsg = "Failed with response code: " + responseCode;
                    taskStatusCode = TaskStatusCode.Failed;

                }



                JSONObject json = null;


                if (taskStatusCode == TaskStatusCode.SucceededJSON) {

                        json = new JSONObject(taskResponse);
                        final String statusCode = json.getString(Constants.JSONRespStatusCodeTag);
                        final String statusMsg = json.getString(Constants.JSONRespStatusMsgTag);
                        if (statusCode.equals(Constants.StatusCodes.SUCCESS)) {
                            String meterData = json.has(Constants.Json_Meter_Tags.JSONRespMeterDataTag) ? json.getString(Constants.Json_Meter_Tags.JSONRespMeterDataTag) : null;
                            if (meterData != null) {
                                MySQLiteHelper dbHelper = new MySQLiteHelper(activity);
                                JSONArray data = new JSONArray(meterData);

                                final Map<String, MeterProfileModel> listMeters = new LinkedHashMap<>();
                                if (data != null) {
                                    Utilities.showToastMsg(activity, "已下载 " + data.length() + " 块表");
                                    for (int ii = 0; ii < data.length(); ii++) {
                                        Log.i(Constants.MyTag, "Total meters " + data.length() + " index " + ii);
                                        try {
                                            JSONObject jsonItem = data.getJSONObject(ii);
                                            MeterProfileModel meterProfileModel = Utilities.parseJsonToMeterProfileModel(jsonItem);
                                            String meterDataId = meterProfileModel != null ? meterProfileModel.MeterDataID : null;
                                            if (meterProfileModel != null && meterDataId != null) {
                                                listMeters.put(meterDataId, meterProfileModel);

                                            }
                                        } catch (Exception e) {
                                            //ignore if an exception happens
                                        }

                                    }


                                    //Utilities.showToastMsg(HomeActivity.this, "Insert data...");
                                    dbHelper.addMeterDataBulk(listMeters);
                                    //dbHelper.updateMeterDataIsActive(new ArrayList<String>(listMeters.keySet()));
                                    MeterProfilesDataHolder.getInstance(activity).nullifyListMeters();
                                    taskStatusMsg = statusMsg;

                                } else {
                                    taskStatusCode = TaskStatusCode.Failed;
                                    taskStatusMsg = Constants.StatusMessages.JSONFORMATINCORRECTMSG + " " + Constants.Json_Meter_Tags.JSONRespMeterDataTag;

                                }


                            } else {
                                taskStatusCode = TaskStatusCode.Failed;
                                taskStatusMsg = Constants.StatusMessages.JSONFORMATINCORRECTMSG + " " + Constants.Json_Meter_Tags.JSONRespMeterDataTag;

                            }
                        } else {
                            taskStatusCode = TaskStatusCode.Failed;
                            taskStatusMsg = statusMsg;
                        }

                    }

                }
        }
        catch (Exception e)
        {
            taskStatusCode = TaskStatusCode.Failed;
            taskStatusMsg = e.getMessage();
        }

        finally {
            try {
                if (input != null)
                    input.close();
            } catch (IOException ignored) {
            }

            if (conn != null)
                conn.disconnect();
        }
        return null;
    }


    private class SendDownloadMeterTask extends AsyncTask<Void, Void, Void> {

        //ProgressDialog pleaseWaitDialog;
        String result= Constants.EMPTYSTRING;

        @Override
        protected void onPreExecute() {

            CShowProgress.getInstance().showProgress(activity);
        }

        @Override
        protected  void onPostExecute(final Void msg) {

            Log.d(Constants.MyTag, "onPostExecute");
            Log.i("MyTag", "onPostExecute");
            //pleaseWaitDialog.dismiss();
            CShowProgress.getInstance().hideProgress();


            Utilities.showToastMsg(activity, taskStatusMsg);


        }
        @Override
        protected void onCancelled() {
            super.onCancelled();
            //pleaseWaitDialog.dismiss();
            CShowProgress.getInstance().hideProgress();

        }

        @Override
        protected Void  doInBackground(Void... params) {

            sendDownloadMetersPost();
            return null;

        }
    }



}
