package my.ccs.projectrawdata.sqlite;

import android.app.Activity;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

import java.io.File;
import java.io.FileWriter;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Dictionary;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;

import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;


import my.ccs.projectrawdata.Constants;
import my.ccs.projectrawdata.model.MeterProfileModel;
import my.ccs.projectrawdata.model.RawData;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

import com.opencsv.CSVWriter;

import junit.runner.Version;

import my.ccs.projectrawdata.*;
import my.ccs.projectrawdata.sqlite.upgrade.BaseUpgrade;
import my.ccs.projectrawdata.sqlite.upgrade.VersionUpgrade;

public class MySQLiteHelper extends SQLiteOpenHelper {

    // Database Version
    private static final int DATABASE_VERSION = 3;
    // Database Name
    public static final String DATABASE_NAME = "CCSData";

    private static final Map<Integer, BaseUpgrade> dbVersions;
    static
    {
        dbVersions = new HashMap<Integer, BaseUpgrade>();
        dbVersions.put(1, new VersionUpgrade.Version1());
        dbVersions.put(2, new VersionUpgrade.Version_AddCustomerId());
        dbVersions.put(3, new VersionUpgrade.Version_AddMeterLocationCode());
        //dbVersions.put(3, new VersionUpgrade.Version3());
    }

    public static final String ExportCSVName = "RawDataCSV";
    private Context context = null;
    public MySQLiteHelper(Context context) {

        super(context, DATABASE_NAME, null, DATABASE_VERSION);

        for(int  i = 1; i <= DATABASE_VERSION; i++)
        {
            if(!dbVersions.containsKey(i))
            {
                //throw  new SQLException("Failed to upgrade the database because version " + i + " is missing.");
                System.exit(1);

            }
        }




        this.context = context;


    }

    @Override
    public void onCreate(SQLiteDatabase db) {

        // SQL statement to create MeterData table
        String CREATE_METERDATA_TABLE = "CREATE TABLE " + TABLE_METERDATA +  "( " +
                KEY_METERDATAID_METERDATA + " TEXT PRIMARY KEY, "+
                KEY_METERSN_METERDATA + " TEXT, "+
                KEY_ADDRESS_METERDATA + " TEXT, "+
                KEY_METERID_METERDATA + " TEXT, "+
                KEY_USERNAME_METERDATA + " TEXT, "+
                KEY_LATITUDE_METERDATA + " REAL, "+
                KEY_LONGITUDE_METERDATA + " REAL, "+
                KEY_PHONEUUID_METERDATA + " TEXT, "+
                KEY_LASTCOLLECTED_METERDATA + " datetime, "+
                KEY_LASTUPLOADED_METERDATA + " datetime, "+
                KEY_UPDATETIMESTAMP_METERDATA + " datetime, " +
                KEY_METERTYPE_METERDATA + " TEXT, " +
                KEY_LASTREAD_METERDATA + " TEXT, " +
                KEY_LASTJSONREADING_METERDATA + " TEXT, " +
                KEY_ISACTIVE_METERDATA + " INTEGER DEFAULT 0, " +
                KEY_CUSTOMERID_METERDATA + " TEXT, " +
                KEY_LOCATIONCODE_METERDATA + " TEXT );";


        // create MeterData table
        db.execSQL(CREATE_METERDATA_TABLE);

        // SQL statement to create RawData table
        String CREATE_RAWDATA_TABLE = "CREATE TABLE " + TABLE_RAWDATA +  "( " +
                KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT, " +
                KEY_METERDATAID + " TEXT NOT NULL, "+
                KEY_MEASURETYPE + " TEXT NOT NULL, "+
                KEY_RATESCHEDULE + " TEXT, "+
                KEY_READTYPE + " TEXT, "+
                KEY_READ + " REAL NOT NULL, "+
                KEY_CONSUMPTION + " REAL NOT NULL, "+
                KEY_STATUS + " TEXT, "+
                KEY_UPDATETIMESTAMP + " datetime, " +
                "FOREIGN KEY(" + KEY_METERDATAID +") REFERENCES " +  TABLE_METERDATA + "(" + KEY_METERDATAID_METERDATA +"));";


        // create RawData table
        db.execSQL(CREATE_RAWDATA_TABLE);


    }

    @Override
    public void onOpen(SQLiteDatabase db) {
        super.onOpen(db);
        if (!db.isReadOnly()) {
            // Enable foreign key constraints
            db.execSQL("PRAGMA foreign_keys=ON;");
        }
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {


        /*
        // Drop older RawData table if existed
        db.execSQL("DROP TABLE IF EXISTS" +TABLE_RAWDATA);

        // Drop older MeterData table if existed
        db.execSQL("DROP TABLE IF EXISTS" + TABLE_METERDATA);

        // create fresh tables
        this.onCreate(db);*/

        Log.i(Constants.MyTag, "" + oldVersion);
        Log.i(Constants.MyTag, "" + newVersion);


        for(int  i = oldVersion + 1; i <= newVersion; i++)
        {

            BaseUpgrade upgrade = dbVersions.get(i);
            upgrade.execute(db);
        }

    }
    //---------------------------------------------------------------------

    /**
     * CRUD operations (create "add", read "get", update, delete) rawdata + get all rawdata + delete all rawdata
     */

    // Raw data table name
    public static final String TABLE_RAWDATA = "rawdata";
    public static final String TABLE_METERDATA = "meterdata";

    // Raw data Table Columns names
    private static final String KEY_ID = "id";
    private static final String KEY_METERDATAID= "meterdataid";
    private static final String KEY_MEASURETYPE= "measuretype";
    private static final String KEY_RATESCHEDULE = "rateschedule";
    private static final String KEY_READTYPE = "readtype";
    private static final String KEY_READ = "read";
    private static final String KEY_CONSUMPTION = "consumption";
    private static final String KEY_STATUS = "status";
    private static final String KEY_UPDATETIMESTAMP = "updatetimestamp";


    private static final String[] COLUMNS = {KEY_METERDATAID,KEY_MEASURETYPE, KEY_RATESCHEDULE,KEY_READTYPE,KEY_READ,KEY_CONSUMPTION,KEY_STATUS,
            KEY_UPDATETIMESTAMP};

    // Meter data Table Columns names
    private static final String KEY_METERDATAID_METERDATA= "meterdataid";
    private static final String KEY_METERSN_METERDATA= "metersn";
    private static final String KEY_METERTYPE_METERDATA= "metertype";
    private static final String KEY_ADDRESS_METERDATA= "address";
    private static final String KEY_METERID_METERDATA= "meterid";
    private static final String KEY_USERNAME_METERDATA= "username";
    private static final String KEY_LATITUDE_METERDATA= "latitude";
    private static final String KEY_LONGITUDE_METERDATA= "longitude";
    private static final String KEY_PHONEUUID_METERDATA= "phoneuuid";
    private static final String KEY_LASTCOLLECTED_METERDATA= "lastcollected";
    private static final String KEY_LASTUPLOADED_METERDATA= "lastuploaded";
    private static final String KEY_UPDATETIMESTAMP_METERDATA = "updatetimestamp";
    private static final String KEY_LASTREAD_METERDATA= "lastread";
    private static final String KEY_LASTJSONREADING_METERDATA = "lastjsonreading";
    private static final String KEY_ISACTIVE_METERDATA = "isactive";
    public static final String KEY_CUSTOMERID_METERDATA = "customerid";
    public static final String KEY_LOCATIONCODE_METERDATA = "locationcode";

    private static final String[] COLUMNS_METERDATA = {KEY_METERDATAID_METERDATA,KEY_METERSN_METERDATA,
            KEY_ADDRESS_METERDATA,KEY_METERID_METERDATA,KEY_USERNAME_METERDATA,
            KEY_LATITUDE_METERDATA, KEY_LONGITUDE_METERDATA, KEY_PHONEUUID_METERDATA,
            KEY_LASTCOLLECTED_METERDATA, KEY_LASTUPLOADED_METERDATA, KEY_UPDATETIMESTAMP,
            KEY_METERTYPE_METERDATA, KEY_LASTREAD_METERDATA, KEY_LASTJSONREADING_METERDATA,
    KEY_ISACTIVE_METERDATA, KEY_CUSTOMERID_METERDATA, KEY_LOCATIONCODE_METERDATA};

    SimpleDateFormat format = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");

    public void addRawData(RawData rawData){
        // 1. get reference to writable DB
        SQLiteDatabase db = this.getWritableDatabase();

        // 2. create ContentValues to add key "column"/value
        ContentValues values = new ContentValues();
        values.put(KEY_METERDATAID, rawData.MeterDataID);
        values.put(KEY_MEASURETYPE, rawData.MeasureType);
        values.put(KEY_RATESCHEDULE, rawData.RateSchedule);
        values.put(KEY_READTYPE, rawData.ReadType);
        values.put(KEY_READ, rawData.Read);
        values.put(KEY_CONSUMPTION, rawData.Consumption);
        values.put(KEY_STATUS, rawData.Status);

        values.put(KEY_UPDATETIMESTAMP, format.format(rawData.UpdateTimeStamp));

        // 3. insert
        db.insert(TABLE_RAWDATA, // table
                null, //nullColumnHack
                values); // key/value -> keys = column names/ values = column values

        // 4. close
        db.close();
    }



    public void addMeterDataBulk(Map<String, MeterProfileModel> meterDataIdToMeter){

        // 1. get reference to writable DB
        SQLiteDatabase db = this.getWritableDatabase();
        try{
            db.beginTransaction();
            int cCount = 0;
            for (Map.Entry<String, MeterProfileModel> meterProfileDataEntry:
                    meterDataIdToMeter.entrySet()) {

                MeterProfileModel meterProfileData = meterProfileDataEntry.getValue();
                // 2. create ContentValues to add key "column"/value
                ContentValues values = new ContentValues();
                values.put(KEY_METERDATAID_METERDATA, meterProfileData.MeterDataID);
                values.put(KEY_METERSN_METERDATA, meterProfileData.MeterSN);
                String mettype = meterProfileData.MeterType.name();
                String mettype2 = meterProfileData.MeterType.toString();
                values.put(KEY_METERTYPE_METERDATA, meterProfileData.MeterType.toString());
                values.put(KEY_ADDRESS_METERDATA, meterProfileData.Address);
                values.put(KEY_METERID_METERDATA, meterProfileData.MeterID);
                values.put(KEY_USERNAME_METERDATA, meterProfileData.UserName);
                values.put(KEY_LATITUDE_METERDATA, meterProfileData.Latitude);
                values.put(KEY_LONGITUDE_METERDATA, meterProfileData.Longitude);
                values.put(KEY_PHONEUUID_METERDATA, meterProfileData.PhoneUUID);

                //values.put(KEY_LASTCOLLECTED_METERDATA, meterProfileData.LastCollected == null ? null : format.format(meterProfileData.LastCollected));
                //values.put(KEY_LASTUPLOADED_METERDATA, meterProfileData.LastUploaded == null ? null : format.format(meterProfileData.LastUploaded));
                values.put(KEY_UPDATETIMESTAMP_METERDATA, format.format(meterProfileData.UpdateTimeStamp));

                values.put(KEY_LASTREAD_METERDATA, meterProfileData.LastRead);
                values.put(KEY_LASTJSONREADING_METERDATA, meterProfileData.LastJsonReading);
                values.put(KEY_CUSTOMERID_METERDATA, meterProfileData.CustomerId);
                if(meterProfileData.LocationCode == null)
                {
                    Log.i(Constants.MyTag, "null");
                }
                values.put(KEY_LOCATIONCODE_METERDATA, meterProfileData.LocationCode);
                // 3. insert
                db.insertWithOnConflict(TABLE_METERDATA, // table
                        null, //nullColumnHack
                        values,
                        SQLiteDatabase.CONFLICT_REPLACE); // key/value -> keys = column names/ values = column values
                cCount++;
                Log.i(Constants.MyTag, "Added " + cCount + " out of " + meterDataIdToMeter.size());
            }

            db.setTransactionSuccessful();

        }
        finally {
            db.endTransaction();
            db.close();
        }




    }

    public void addMeterData(MeterProfileModel meterProfileData){
        // 1. get reference to writable DB
        SQLiteDatabase db = this.getWritableDatabase();

        // 2. create ContentValues to add key "column"/value
        ContentValues values = new ContentValues();
        values.put(KEY_METERDATAID_METERDATA, meterProfileData.MeterDataID);
        values.put(KEY_METERSN_METERDATA, meterProfileData.MeterSN);
        String mettype = meterProfileData.MeterType.name();
        String mettype2 = meterProfileData.MeterType.toString();
        values.put(KEY_METERTYPE_METERDATA, meterProfileData.MeterType.toString());
        values.put(KEY_ADDRESS_METERDATA, meterProfileData.Address);
        values.put(KEY_METERID_METERDATA, meterProfileData.MeterID);
        values.put(KEY_USERNAME_METERDATA, meterProfileData.UserName);
        values.put(KEY_LATITUDE_METERDATA, meterProfileData.Latitude);
        values.put(KEY_LONGITUDE_METERDATA, meterProfileData.Longitude);
        values.put(KEY_PHONEUUID_METERDATA, meterProfileData.PhoneUUID);

        //values.put(KEY_LASTCOLLECTED_METERDATA, meterProfileData.LastCollected == null ? null : format.format(meterProfileData.LastCollected));
        //values.put(KEY_LASTUPLOADED_METERDATA, meterProfileData.LastUploaded == null ? null : format.format(meterProfileData.LastUploaded));
        values.put(KEY_UPDATETIMESTAMP_METERDATA, format.format(meterProfileData.UpdateTimeStamp));

        values.put(KEY_LASTREAD_METERDATA, meterProfileData.LastRead);
        values.put(KEY_LASTJSONREADING_METERDATA, meterProfileData.LastJsonReading);

        values.put(KEY_CUSTOMERID_METERDATA, meterProfileData.CustomerId);
        values.put(KEY_LOCATIONCODE_METERDATA, meterProfileData.LocationCode);
        // 3. insert
        db.insertWithOnConflict(TABLE_METERDATA, // table
                null, //nullColumnHack
                values,
                SQLiteDatabase.CONFLICT_REPLACE); // key/value -> keys = column names/ values = column values

        // 4. close
        db.close();
    }

    // Get RawData from id
    public RawData getRawData(int id){

        // 1. get reference to readable DB
        SQLiteDatabase db = this.getReadableDatabase();

        // 2. build query
        Cursor cursor =
                db.query(TABLE_RAWDATA, // a. table
                        COLUMNS, // b. column names
                        " id = ?", // c. selections
                        new String[] { String.valueOf(id) }, // d. selections args
                        null, // e. group by
                        null, // f. having
                        null, // g. order by
                        null); // h. limit

        // 3. if we got results get the first one
        if (cursor != null)
            cursor.moveToFirst();

        // 4. build raw data object
        RawData rawdata = new RawData();
        rawdata.id = Integer.parseInt(cursor.getString(0));
        rawdata.MeterDataID = cursor.getString(1);
        rawdata.MeasureType = cursor.getString(2);
        rawdata.RateSchedule = cursor.getString(3);
        rawdata.ReadType = cursor.getString(4);
        try {
            rawdata.Read = Double.parseDouble(cursor.getString(5));

        }
        catch (NumberFormatException ex)
        {
            //pass
        }
        catch (Exception ex)
        {
            //pass
            Log.d(Constants.MyTag, ex.getMessage());
        }

        /*try {
            rawdata.Factor = Double.parseDouble(cursor.getString(11));

        }
        catch (NumberFormatException ex)
        {
            //pass
        }
        catch (Exception ex)
        {
            //pass
        }*/

        try {
            rawdata.Consumption = Double.parseDouble(cursor.getString(6));

        }
        catch (NumberFormatException ex)
        {
            //pass
        }
        catch (Exception ex)
        {
            //pass
            Log.d(Constants.MyTag, ex.getMessage());
        }




        rawdata.Status = cursor.getString(7);
        try {

            rawdata.UpdateTimeStamp = format.parse(cursor.getString(8));

        }
        catch (NumberFormatException ex)
        {
            //pass
            Log.d(Constants.MyTag, ex.getMessage());
        }
        catch (Exception ex)
        {
            //pass
            Log.d(Constants.MyTag, ex.getMessage());
        }



        // 5. return book
        return rawdata;
    }

    // Get RawData from MeterDataId
    public List<RawData> getRawData(String meterDataId, int topN){
        List<RawData> result = null;

        if (topN <= 0) {
            return result;
        }

        // 1. get reference to readable DB
        SQLiteDatabase db = this.getReadableDatabase();

        // 2. build query
        Cursor cursor =
                db.query(TABLE_RAWDATA, // a. table
                        COLUMNS, // b. column names
                        " meterdataid = ?", // c. selections
                        new String[] { String.valueOf(meterDataId) }, // d. selections args
                        null, // e. group by
                        null, // f. having
                        "UpdateTimeStamp DESC", // g. order by
                        Integer.toString(topN)); // h. limit

        // 3. parse cursor
        if (cursor != null && cursor.moveToFirst()) {
            result = new ArrayList<RawData>();

            do {
                RawData rawData = parseRawDataFromCursor(cursor);
                // Add meterdata to meters
                result.add(rawData);
            } while (cursor.moveToNext());

        }

        // 4. return result
        return result;
    }

    public RawData parseRawDataFromCursor(Cursor cursor)
    {
        RawData rawData = new RawData();
        try {
            //rawData.id = Integer.parseInt(cursor.getString(0));
            //rawData.MeterDataID = cursor.getString(1);
            rawData.MeasureType = cursor.getString(1);
            rawData.RateSchedule = cursor.getString(2);
            rawData.ReadType = cursor.getString(3);
            rawData.Read = Double.parseDouble(cursor.getString(4));
            rawData.Consumption = Double.parseDouble(cursor.getString(5));
            rawData.Status = cursor.getString(6);
            rawData.UpdateTimeStamp = format.parse(cursor.getString(7));
        }
        catch (NumberFormatException ex)
        {
            //pass
        }
        catch (Exception ex)
        {
            //pass
            Log.d(Constants.MyTag, ex.getMessage());
        }
        return rawData;
    }


    public MeterProfileModel parseMeterObjectFromCursor(Cursor cursor)
    {
        MeterProfileModel meterdata = new MeterProfileModel();
        meterdata.MeterDataID = cursor.getString(0);
        meterdata.MeterSN = cursor.getString(1);

        meterdata.Address = cursor.getString(2);
        meterdata.MeterID = cursor.getString(3);

        meterdata.UserName = cursor.getString(4);

        try {
            meterdata.Latitude = cursor.getDouble(5);
        }
        catch (NumberFormatException ex)
        {
            //pass
        }
        catch (Exception ex)
        {
            //pass
        }

        try {
            meterdata.Longitude = cursor.getDouble(6);
        }
        catch (NumberFormatException ex)
        {
            //pass
        }
        catch (Exception ex)
        {
            //pass
        }

        meterdata.PhoneUUID = cursor.getString(7);

        try {
            meterdata.LastCollected = format.parse(cursor.getString(8));
        }
        catch (NumberFormatException ex)
        {
            //pass
        }
        catch (Exception ex)
        {
            //pass
        }

        try {
            meterdata.LastUploaded = format.parse(cursor.getString(9));
        }
        catch (NumberFormatException ex)
        {
            //pass
        }
        catch (Exception ex)
        {
            //pass
        }

        try {
            meterdata.UpdateTimeStamp = format.parse(cursor.getString(10));
        }
        catch (NumberFormatException ex)
        {
            //pass
        }
        catch (Exception ex)
        {
            //pass
        }
        meterdata.MeterType = MeterProfileModel.MeterTypes.fromString(cursor.getString(11));
        meterdata.LastRead = cursor.getString(12);
        meterdata.LastJsonReading = cursor.getString(13);
        meterdata.CustomerId = cursor.getString(15);
        meterdata.LocationCode = getNullOrValue(cursor, 16);
        return meterdata;
    }

    public String getNullOrValue(Cursor cursor, int columnIndex)
    {

        if(cursor.isNull(columnIndex))
            return  null;

        return cursor.getString(columnIndex);
    }
    public MeterProfileModel getMeterData(String meterDataId){

        // 1. get reference to readable DB
        SQLiteDatabase db = this.getReadableDatabase();

        // 2. build query
        Cursor cursor =
                db.query(TABLE_METERDATA, // a. table
                        COLUMNS_METERDATA, // b. column names
                        KEY_METERDATAID_METERDATA + "  = ? AND " +
                        KEY_ISACTIVE_METERDATA + " = 1", // c. selections
                        new String[] { meterDataId }, // d. selections args
                        null, // e. group by
                        null, // f. having
                        null, // g. order by
                        null); // h. limit

        // 3. if we got results get the first one
        if (cursor != null)
            cursor.moveToFirst();

        // 4. build meterdata object
        MeterProfileModel meterdata = parseMeterObjectFromCursor(cursor);



        // 5. return meterdata
        return meterdata;
    }

    // Get All RawData
    public List<RawData> getAllRawData() {
        List<RawData> rawdatas = new LinkedList<RawData>();

        // 1. build the query
        String query = "SELECT  * FROM " + TABLE_RAWDATA;

        // 2. get reference to writable DB
        SQLiteDatabase db = this.getWritableDatabase();
        Cursor cursor = db.rawQuery(query, null);

        // 3. go over each row, build book and add it to list
        RawData rawdata = null;
        if (cursor.moveToFirst()) {
            do {
                rawdata = new RawData();
                rawdata.id = Integer.parseInt(cursor.getString(0));
                rawdata.MeterDataID = cursor.getString(1);
                rawdata.MeasureType = cursor.getString(2);
                rawdata.RateSchedule = cursor.getString(3);
                rawdata.ReadType = cursor.getString(4);
                try {
                    rawdata.Read = Double.parseDouble(cursor.getString(5));

                }
                catch (NumberFormatException ex)
                {
                    //pass
                }
                catch (Exception ex)
                {
                    //pass
                }

                try {
                    rawdata.Consumption = Double.parseDouble(cursor.getString(6));

                }
                catch (NumberFormatException ex)
                {
                    //pass
                }
                catch (Exception ex)
                {
                    //pass
                }




                rawdata.Status = cursor.getString(7);
                try {
                    rawdata.UpdateTimeStamp = format.parse(cursor.getString(8));

                }
                catch (NumberFormatException ex)
                {
                    //pass
                }
                catch (Exception ex)
                {
                    //pass
                }
                // Add rawdata to rawdatas
                rawdatas.add(rawdata);
            } while (cursor.moveToNext());
        }


        // return rawdatas
        return rawdatas;
    }

    // Get All MeterData
    public List<MeterProfileModel> getAllMeterData() {
        List<MeterProfileModel> meterdatas = new LinkedList<MeterProfileModel>();
        if(MainActivity.selectedCustomerId == null || MainActivity.selectedCustomerId.isEmpty())
            return  meterdatas;
        // 1. build the query
        String query = "SELECT  * FROM " + TABLE_METERDATA  + " WHERE " + KEY_CUSTOMERID_METERDATA + " = '" + MainActivity.selectedCustomerId + "'";

        // 2. get reference to writable DB
        SQLiteDatabase db = this.getWritableDatabase();
        Cursor cursor = db.rawQuery(query, null);
        // 3. go over each row, build book and add it to list
        if (cursor != null && cursor.moveToFirst()) {
            do {
                MeterProfileModel meterdata = parseMeterObjectFromCursor(cursor);
                // Add meterdata to meters
                meterdatas.add(meterdata);
            } while (cursor.moveToNext());
        }


        // return meterdatas
        return meterdatas;
    }

    // Updating single rawdata
    public int updateRawData(RawData rawData) {

        // 1. get reference to writable DB
        SQLiteDatabase db = this.getWritableDatabase();

        // 2. create ContentValues to add key "column"/value
        ContentValues values = new ContentValues();
        values.put(KEY_METERDATAID, rawData.MeterDataID);
        values.put(KEY_MEASURETYPE, rawData.MeasureType);
        values.put(KEY_RATESCHEDULE, rawData.RateSchedule);
        values.put(KEY_READTYPE, rawData.ReadType);
        values.put(KEY_READ, rawData.Read);
        values.put(KEY_CONSUMPTION, rawData.Consumption);
        values.put(KEY_STATUS, rawData.Status);
        values.put(KEY_UPDATETIMESTAMP, rawData.UpdateTimeStamp.toString());

        // 3. updating row
        int i = db.update(TABLE_RAWDATA, //table
                values, // column/value
                KEY_ID + " = ?", // selections
                new String[] { String.valueOf(rawData.id) }); //selection args

        // 4. close
        db.close();

        return i;

    }

    // Updating single meterdata
    public int updateMeterData(MeterProfileModel meterProfileData) {

        // 1. get reference to writable DB
        SQLiteDatabase db = this.getWritableDatabase();

        // 2. create ContentValues to add key "column"/value
        ContentValues values = new ContentValues();
        values.put(KEY_METERDATAID_METERDATA, meterProfileData.MeterDataID);
        values.put(KEY_METERSN_METERDATA, meterProfileData.MeterSN);
        values.put(KEY_METERTYPE_METERDATA, meterProfileData.MeterType.toString());
        values.put(KEY_ADDRESS_METERDATA, meterProfileData.Address);
        values.put(KEY_METERID_METERDATA, meterProfileData.MeterID);
        values.put(KEY_USERNAME_METERDATA, meterProfileData.UserName);
        values.put(KEY_LATITUDE_METERDATA, meterProfileData.Latitude);
        values.put(KEY_LONGITUDE_METERDATA, meterProfileData.Longitude);
        values.put(KEY_PHONEUUID_METERDATA, meterProfileData.PhoneUUID);

        values.put(KEY_LASTCOLLECTED_METERDATA, meterProfileData.LastCollected == null ? null : format.format(meterProfileData.LastCollected));
        values.put(KEY_LASTUPLOADED_METERDATA, meterProfileData.LastUploaded == null ? null : format.format(meterProfileData.LastUploaded));
        values.put(KEY_UPDATETIMESTAMP_METERDATA, format.format(meterProfileData.UpdateTimeStamp));
        values.put(KEY_LASTREAD_METERDATA, meterProfileData.LastRead);
        values.put(KEY_LASTJSONREADING_METERDATA, meterProfileData.LastJsonReading);

        // 3. updating row
        int i = db.update(TABLE_METERDATA, //table
                values, // column/value
                KEY_METERDATAID_METERDATA + " = ?", // selections
                new String[] { String.valueOf(meterProfileData.MeterDataID) }); //selection args

        // 4. close
        db.close();

        return i;

    }


    // Deleting single rawdata
    public void deleteRawData(RawData rawData) {

        // 1. get reference to writable DB
        SQLiteDatabase db = this.getWritableDatabase();

        // 2. delete
        db.delete(TABLE_RAWDATA,
                KEY_ID + " = ?",
                new String[]{String.valueOf(rawData.id)});

        // 3. close
        db.close();


    }

    public void activateMeterDataForCustomerId(String customerId)
    {
        // 1. get reference to writable DB
        SQLiteDatabase db = this.getWritableDatabase();

        //deactivate all active meters
        String queryDeactivate = "UPDATE " + TABLE_METERDATA + " SET " + KEY_ISACTIVE_METERDATA + " = 0 where " + KEY_ISACTIVE_METERDATA + " = 1";
        db.rawQuery(queryDeactivate, null);

        String queryActivate = "UPDATE " + TABLE_METERDATA + " SET " + KEY_ISACTIVE_METERDATA + " = 1 where " + KEY_CUSTOMERID_METERDATA + " = '" + customerId + "'";
        db.rawQuery(queryActivate, null);


        // 3. close
        db.close();


    }

    public void updateMeterDataIsActive(List<String> meterDataIds)
    {
        // 1. get reference to writable DB
        SQLiteDatabase db = this.getWritableDatabase();

        //deactivate all active meters
        String queryDeactivate = "UPDATE " + TABLE_METERDATA + " SET " + KEY_ISACTIVE_METERDATA + " = 0 where " + KEY_ISACTIVE_METERDATA + " = 1";
        db.rawQuery(queryDeactivate, null);

        for (String meterDataId:
             meterDataIds) {
            String queryActivate = "UPDATE " + TABLE_METERDATA + " SET " + KEY_ISACTIVE_METERDATA + " = 1 where " + KEY_METERDATAID_METERDATA + " = '" + meterDataId + "'";
            // 2. delete
            db.rawQuery(queryActivate, null);
        }


        // 3. close
        db.close();


    }


    public void updateMeterLocations(List<MeterProfileModel> meterDataIds, double latitude, double longitude, String locationcode)
    {
        int chunkMaxSize = 100;
        // 1. get reference to writable DB
        SQLiteDatabase db = this.getWritableDatabase();
        int curIndex = 0;

        if(meterDataIds.size() <= chunkMaxSize)
        {
            int chunkSize = meterDataIds.size();
            String[] meterDataIdsChunk = new String[chunkSize];
            for (int j = 0; j<meterDataIds.size(); j++)
            {
                meterDataIdsChunk[j] = meterDataIds.get(j).MeterDataID;
                meterDataIds.get(j).LocationCode = locationcode;
                meterDataIds.get(j).Latitude = latitude;
                meterDataIds.get(j).Longitude = longitude;
            }
            ContentValues values = new ContentValues();
            values.put(KEY_LATITUDE_METERDATA, latitude);
            values.put(KEY_LONGITUDE_METERDATA, longitude);
            values.put(KEY_LOCATIONCODE_METERDATA, locationcode);
            db.update(TABLE_METERDATA, values, KEY_METERDATAID_METERDATA + " IN " + "(" + makePlaceholders(meterDataIdsChunk.length) + ")",
                    meterDataIdsChunk);



        }
        else {
            int loopCount = meterDataIds.size()/chunkMaxSize;
            for(int i = 0; i < loopCount; i++)
            {
                int chunkSize = chunkMaxSize;
                String[] meterDataIdsChunk = new String[chunkSize];

                for(int j = 0; j < chunkMaxSize; j++)
                {
                    meterDataIdsChunk[j] = meterDataIds.get(i*chunkMaxSize + j).MeterDataID;
                    meterDataIds.get(i*chunkMaxSize + j).LocationCode = locationcode;
                    meterDataIds.get(i*chunkMaxSize + j).Latitude = latitude;
                    meterDataIds.get(i*chunkMaxSize + j).Longitude = longitude;
                }
                ContentValues values = new ContentValues();
                values.put(KEY_LATITUDE_METERDATA, latitude);
                values.put(KEY_LONGITUDE_METERDATA, longitude);
                values.put(KEY_LOCATIONCODE_METERDATA, locationcode);
                db.update(TABLE_METERDATA, values, KEY_METERDATAID_METERDATA + " IN " + "(" + makePlaceholders(meterDataIdsChunk.length) + ")",
                        meterDataIdsChunk);
            }

            int chunkSize = meterDataIds.size() - loopCount * chunkMaxSize;
            String[] meterDataIdsChunk = new String[chunkSize];
            for(int j = 0; j < chunkSize; j++)
            {
                meterDataIdsChunk[j] = meterDataIds.get(loopCount*chunkMaxSize + j).MeterDataID;
                meterDataIds.get(loopCount*chunkMaxSize + j).LocationCode = locationcode;
                meterDataIds.get(loopCount*chunkMaxSize + j).Latitude = latitude;
                meterDataIds.get(loopCount*chunkMaxSize + j).Longitude = longitude;
            }
            ContentValues values = new ContentValues();
            values.put(KEY_LATITUDE_METERDATA, latitude);
            values.put(KEY_LONGITUDE_METERDATA, longitude);
            values.put(KEY_LOCATIONCODE_METERDATA, locationcode);
            db.update(TABLE_METERDATA, values, KEY_METERDATAID_METERDATA + " IN " + "(" + makePlaceholders(meterDataIdsChunk.length) + ")",
                    meterDataIdsChunk);

        }

        // 3. close
        db.close();


    }


    String makePlaceholders(int len) {
        if (len < 1) {
            // It will lead to an invalid query anyway ..
            throw new RuntimeException("No placeholders");
        } else {
            StringBuilder sb = new StringBuilder(len * 2 - 1);
            sb.append("?");
            for (int i = 1; i < len; i++) {
                sb.append(",?");
            }
            return sb.toString();
        }
    }

    // Deleting single meterdata
    public void deleteMeterData(MeterProfileModel meterProfileData) {

        // 1. get reference to writable DB
        SQLiteDatabase db = this.getWritableDatabase();

        // 2. delete
        db.delete(TABLE_RAWDATA,
                KEY_METERDATAID_METERDATA + " = ?",
                new String[]{String.valueOf(meterProfileData.MeterDataID)});

        // 3. close
        db.close();


    }



    public void deleteAllRawData() {
        List<RawData> rawdatas = new LinkedList<RawData>();

        // 1. build the query
        String query = "Delete FROM " + TABLE_RAWDATA;

        // 2. get reference to writable DB
        SQLiteDatabase db = this.getWritableDatabase();
        db.execSQL(query);

        db.close();


    }

    public void deleteAllMeterData() {
        List<MeterProfileModel> meterdatas = new LinkedList<MeterProfileModel>();

        // 1. build the query
        String query = "Delete FROM " + TABLE_METERDATA;

        // 2. get reference to writable DB
        SQLiteDatabase db = this.getWritableDatabase();
        db.execSQL(query);

        db.close();


    }


    public void exportDB() throws Exception{

        if (this.context == null)
        {
            throw new Exception(Constants.StatusMessages.CANNOTPROCEEDWITHACTION);
        }
        File dbFile = context.getDatabasePath(DATABASE_NAME);
        File exportDir = new File(dbFile.getParent());

        File file = new File(exportDir, ExportCSVName);
        try {
            file.createNewFile();
            CSVWriter csvWrite = new CSVWriter(new FileWriter(file));
            SQLiteDatabase db = this.getReadableDatabase();
            Cursor curCSV = db.rawQuery("SELECT * FROM " + TABLE_RAWDATA, null);
            String[] allColumns = curCSV.getColumnNames();
            if(allColumns.length == 0)
            {
                throw new Exception(Constants.StatusMessages.REQUESTFAILEDGENERICMSG);

            }
            String[] firstColumnRemoved = new String[allColumns.length - 1];
            for(int i = 0; i < firstColumnRemoved.length; i++)
            {
                firstColumnRemoved[i] = allColumns[i + 1];
            }
            csvWrite.writeNext(firstColumnRemoved);
            while (curCSV.moveToNext()) {

                /*String arrStr[] = { removeDoubleQuotes(curCSV.getString(1)), removeDoubleQuotes(curCSV.getString(2)), removeDoubleQuotes(curCSV.getString(3)),
                        removeDoubleQuotes(curCSV.getString(4)), removeDoubleQuotes(curCSV.getString(5)), removeDoubleQuotes(curCSV.getString(6)),
                        removeDoubleQuotes(curCSV.getString(7)), removeDoubleQuotes(curCSV.getString(8)), removeDoubleQuotes(curCSV.getString(9)),
                        removeDoubleQuotes(curCSV.getString(10)), removeDoubleQuotes(curCSV.getString(11)), removeDoubleQuotes(curCSV.getString(12)),
                        removeDoubleQuotes(curCSV.getString(13)), removeDoubleQuotes(curCSV.getString(14))};*/

                //Which column you want to exprort
                String arrStr[] = {curCSV.getString(1), curCSV.getString(2), curCSV.getString(3),
                        curCSV.getString(4), curCSV.getString(5), curCSV.getString(6),
                        curCSV.getString(7), curCSV.getString(8)};
                csvWrite.writeNext(arrStr);
            }
            csvWrite.close();
            curCSV.close();
        } catch (Exception sqlEx) {
            throw new Exception(Constants.StatusMessages.REQUESTFAILEDGENERICMSG);
        }
    }


    public String removeDoubleQuotes(String str)
    {
        if(str.startsWith("\""))
            str = str.substring(1);

        if(str.endsWith("\""))
            str = str.substring(0, str.length() - 1);

        return  str;

    }
}
