package my.ccs.projectrawdata.sqlite.upgrade;

import android.database.sqlite.SQLiteDatabase;
import android.util.Log;

import my.ccs.projectrawdata.Constants;
import my.ccs.projectrawdata.sqlite.MySQLiteHelper;

/**
 * Created by Hayk on 5/15/2016.
 */
public class VersionUpgrade {


    public static class Version1 implements BaseUpgrade
    {
        public void execute(SQLiteDatabase db)
        {
            Log.i(Constants.MyTag, "Version1");
        }
    }

    public static class Version_AddCustomerId implements BaseUpgrade
    {
        public void execute(SQLiteDatabase db)
        {

            try {
                Log.i(Constants.MyTag, "Version_AddCustomerId");
                // SQL statement to create MeterData table
                String ADD_CUSTOMERID_METERDATA_TABLE = "ALTER TABLE " + MySQLiteHelper.TABLE_METERDATA + " ADD COLUMN " +
                        MySQLiteHelper.KEY_CUSTOMERID_METERDATA + " TEXT;";
                db.execSQL(ADD_CUSTOMERID_METERDATA_TABLE);
            }
            catch (Exception ex)
            {
                Log.e(Constants.MyTag, ex.getMessage());
            }


        }
    }

    public static class Version_AddMeterLocationCode implements BaseUpgrade
    {
        public void execute(SQLiteDatabase db)
        {

            try {
                Log.i(Constants.MyTag, "Version_AddLocationCode");
                // SQL statement to create MeterData table
                String ADD_LOCATIONCODE_METERDATA_TABLE = "ALTER TABLE " + MySQLiteHelper.TABLE_METERDATA + " ADD COLUMN " +
                        MySQLiteHelper.KEY_LOCATIONCODE_METERDATA + " TEXT;";
                db.execSQL(ADD_LOCATIONCODE_METERDATA_TABLE);
            }
            catch (Exception ex)
            {
                Log.e(Constants.MyTag, ex.getMessage());
            }


        }
    }

    public static class Version3 implements BaseUpgrade
    {
        public void execute(SQLiteDatabase db)
        {
            Log.i(Constants.MyTag, "Version3");
        }
    }

}



