package my.ccs.project.activities;

// Android packages
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothManager;
import android.content.ClipData;
import android.content.Context;
import android.content.Intent;
import android.content.res.Configuration;
import android.hardware.Sensor;
import android.hardware.SensorManager;
import android.net.Uri;
import android.os.Handler;
import android.os.Message;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.webkit.GeolocationPermissions;
import android.webkit.ValueCallback;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.graphics.Bitmap;
import android.util.Xml;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.text.TextUtils;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;
import android.app.ProgressDialog;
import android.os.AsyncTask;
import android.app.AlertDialog.Builder;
import android.content.DialogInterface.OnClickListener;


// Java packages
import java.util.HashMap;
import java.io.*;
import java.util.*;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.Map;
import java.util.Random;

// Baidu packages
import com.baidu.location.BDLocation;
import com.baidu.location.BDLocationListener;
import com.baidu.location.LocationClient;
import com.baidu.location.LocationClientOption;
import com.baidu.mapapi.SDKInitializer;
import com.baidu.mapapi.map.MyLocationData;

// Alipay packages
import com.alipay.sdk.app.PayTask;

// Wechat packages
import com.tencent.mm.sdk.modelpay.PayReq;

// Org packages
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.xmlpull.v1.XmlPullParser;

// CCS packages
import my.ccs.project.BuildConfig;
import my.ccs.project.R;
import my.ccs.project.utils.basic.CCSJavaScriptInterface;
import my.ccs.project.utils.logcatreader.CCSFileLogger;
import my.ccs.project.utils.logcatreader.CCSLogCatReader;
import my.ccs.project.utils.sensoro.CCSSensoroListenerManager;
import my.ccs.project.utils.shake.CCSShakeDetector;
import my.ccs.project.utils.basic.CCSUtilities;
import my.ccs.project.utils.wechat.CCSNetWeChat;
import my.ccs.project.utils.sign.CCSMD5;
import my.ccs.project.utils.alipay.CCSPayResult;
import my.ccs.project.utils.sign.CCSSignUtils;
import my.ccs.project.constants.*;
import my.ccs.project.utils.wechat.CCSWeChatManager;
import com.sensoro.cloud.SensoroManager;

public class CCSReadyForShakeActivity extends Activity
{
    // Main web view
    WebView readyForShakeWebView;

    // Used to control when sensoro service should be stopped or sensoro should be removed
    protected static boolean shouldStopSensoroService = true;
    protected static boolean shouldStopSensoroRemove = true;

    // Location service related variables
    LocationClient mLocClient;
    public MyLocationListenner myListener = new MyLocationListenner();
    MyLocationData locData = null;
    private Double lat = null;
    private Double lng = null;

    // Bluetooth related variables
    BluetoothManager bluetoothManager;
    BluetoothAdapter bluetoothAdapter;

    // Payment related variables
    PayReq req;

    int WeChatPayAmount = 1;
    String WeChatOutTradeNo;
    StringBuffer sb;
    Map<String,String> resultUnifiedOrder;

    // Basic variables
    ProgressBar progressBar;
    TextView versionNumberTxt = null;
    private ValueCallback<Uri> mUploadMessage;
    private String userId = null;

    // Shake detection variables
    private SensorManager mSensorManager;
    private Sensor mAccelerometer;
    private CCSShakeDetector mShakeDetector;

    // Sensoro variables
    private CCSSensoroListenerManager sensoroListenerManager = CCSSensoroListenerManager.sharedSensoroListenerManager;
    private SensoroManager sensoroManager;

    private CCSFileLogger fileLogger = null;
    // WeChat manager
    public CCSWeChatManager weChatManager;
    public void setUserId(String userId)
    {
        this.userId = userId;

    }

    private void requestBlueEnable() {
        bluetoothManager = (BluetoothManager) getSystemService(BLUETOOTH_SERVICE);
        if(bluetoothManager != null) {
            if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.JELLY_BEAN_MR2) {
                bluetoothAdapter = bluetoothManager.getAdapter();
            } else {
                bluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
            }
            if(bluetoothAdapter != null) {
                boolean status = bluetoothAdapter.isEnabled();
                if (!status) {
                    Builder builder = new Builder(CCSReadyForShakeActivity.this);
                    builder.setNegativeButton("Yes", new OnClickListener() {

                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            Intent intent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
                            startActivity(intent);
                        }
                    }).setPositiveButton("No", new OnClickListener() {

                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.dismiss();
                        }
                    }).setTitle("Turn on the bluetooth to be able to detect sensoros.");
                    if(builder != null) builder.show();
                }
            }
        }

    }

    /**
     * Implement location SDK
     */
    public class MyLocationListenner implements BDLocationListener {

        @Override
        public void onReceiveLocation(BDLocation location) {
            /*String deviceId = Settings.Secure.getString(getContentResolver(),
                    Settings.Secure.ANDROID_ID).toUpperCase();*/

            /*if(Arrays.asList(Constants.DevicesWithFakeLocation).contains(deviceId)) {
                location.setLatitude(39.913818);
                location.setLongitude(116.363625);
            }*/
            if (location == null) {
                return;
            }
            locData = new MyLocationData.Builder()
                    .accuracy(location.getRadius())
                            // 此处设置开发者获取到的方向信息，顺时针0-360
                    .direction(100).latitude(location.getLatitude())
                    .longitude(location.getLongitude()).build();

            if(locData != null)
            {
                //CCSUtilities.LatLngModel latLngModel = CCSUtilities.bd2gcj(locData.latitude, locData.longitude);
                lat = locData.latitude;  //String.valueOf(latLngModel.lat);
                lng = locData.longitude; //String.valueOf(latLngModel.lng);
            }
            else {
            }
        }

        public void onReceivePoi(BDLocation poiLocation) {
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode,
                                    Intent intent) {
        if(requestCode==CCSBasicConstants.FILECHOOSER_RESULTCODE)
        {
            if (null == mUploadMessage) return;
            Uri result = intent == null || resultCode != RESULT_OK ? null
                    : intent.getData();
            mUploadMessage.onReceiveValue(result);
            mUploadMessage = null;
        }
    }

    /* Request updates at startup */
    @Override
    protected void onResume() {
        super.onResume();
        mLocClient.start();
        mSensorManager.registerListener(mShakeDetector, mAccelerometer, SensorManager.SENSOR_DELAY_UI);
    }

    @Override
    protected void onPause() {
        super.onPause();
        stopLocClient();
        mSensorManager.unregisterListener(mShakeDetector);
    }

    protected void initWebView()
    {
        readyForShakeWebView = (WebView) findViewById(R.id.CCSWebView);
        if(readyForShakeWebView != null) {
            WebSettings webSettings = readyForShakeWebView.getSettings();
            webSettings.setBuiltInZoomControls(true);
            webSettings.setJavaScriptEnabled(true);
            webSettings.setGeolocationEnabled(true);
            webSettings.setAppCacheEnabled(true);
            webSettings.setDatabaseEnabled(true);
            webSettings.setDomStorageEnabled(true);

            readyForShakeWebView.getSettings().setUserAgentString(
                    this.readyForShakeWebView.getSettings().getUserAgentString()
                            + " "
                            + CCSBasicConstants.userAgentString
            );
            //webView.setWebChromeClient(new WebChromeClient());
            readyForShakeWebView.setWebChromeClient(new WebChromeClient() {
                //The undocumented magic method override
                //Eclipse will swear at you if you try to put @Override here
                // For Android 3.0+
                public void openFileChooser(ValueCallback<Uri> uploadMsg) {

                    mUploadMessage = uploadMsg;
                    Intent i = new Intent(Intent.ACTION_GET_CONTENT);
                    i.addCategory(Intent.CATEGORY_OPENABLE);
                    i.setType("*/*");
                    CCSReadyForShakeActivity.this.startActivityForResult(Intent.createChooser(i, "File Chooser"), CCSBasicConstants.FILECHOOSER_RESULTCODE);

                }

                // For Android 3.0+
                public void openFileChooser(ValueCallback uploadMsg, String acceptType) {
                    mUploadMessage = uploadMsg;
                    Intent i = new Intent(Intent.ACTION_GET_CONTENT);
                    i.addCategory(Intent.CATEGORY_OPENABLE);
                    i.setType("*/*");
                    CCSReadyForShakeActivity.this.startActivityForResult(
                            Intent.createChooser(i, "File Browser"),
                            CCSBasicConstants.FILECHOOSER_RESULTCODE);
                }

                //For Android 4.1
                public void openFileChooser(ValueCallback<Uri> uploadMsg, String acceptType, String capture) {
                    mUploadMessage = uploadMsg;
                    Intent i = new Intent(Intent.ACTION_GET_CONTENT);
                    i.addCategory(Intent.CATEGORY_OPENABLE);
                    i.setType("*/*");
                    CCSReadyForShakeActivity.this.startActivityForResult(Intent.createChooser(i, "File Chooser"), CCSBasicConstants.FILECHOOSER_RESULTCODE);

                }

                public void onGeolocationPermissionsShowPrompt(String origin, GeolocationPermissions.Callback callback) {
                    callback.invoke(origin, true, false);
                }


            });
            readyForShakeWebView.setWebViewClient(new CCSReadyForShakeWebViewCallback());
            final CCSJavaScriptInterface ccsJavaScriptInterface
                    = new CCSJavaScriptInterface(this, CCSReadyForShakeActivity.this);
            readyForShakeWebView.addJavascriptInterface(ccsJavaScriptInterface, CCSBasicConstants.JavascriptInterfaceName);
        }
    }

    //flipscreen not loading again
    @Override
    public void onConfigurationChanged(Configuration newConfig){
        super.onConfigurationChanged(newConfig);
    }

    /*
    protected void initSensoroServiceThread()
    {
        if(shouldStopSensoroService) {
            shouldStopSensoroService = false;
            new Thread(new Runnable() {

                @Override
                public void run() {
                    //while (!shouldStopSensoroService) {
                        try {
                            startSensoroService();

                            Thread.sleep(2000);

                            //stopSensoroService();

                            //Thread.sleep(30000);
                        } catch (Exception e) {

                        }
                    //}
                }
            }).start();
        }

    }

    protected  void stopSensoroServiceThread()
    {
        //sensoroServiceThread.interrupt();
        shouldStopSensoroService = true;

    }*/

    protected  void initSensoroRemoveThread()
    {
        Log.d(CCSBasicConstants.MyTag, "Start sensoro removal thread.");
        new Thread(new Runnable() {

            @Override
            public void run() {

                while(true) {
                    try {
                        if(fileLogger!=null) {
                            final String text = fileLogger.readFromFile();
                            Log.d(CCSBasicConstants.MyTag, "Read from file " + text);
                            runOnUiThread(new Runnable() {
                                public void run() {

                                    if(text != null && text.length() > 0) {
                                        if(android.os.Build.VERSION.SDK_INT < android.os.Build.VERSION_CODES.HONEYCOMB) {
                                            android.text.ClipboardManager clipboardMgr = (android.text.ClipboardManager) getSystemService(Context.CLIPBOARD_SERVICE);
                                            clipboardMgr.setText(text);
                                        } else {
                                            // this api requires SDK version 11 and above, so suppress warning for now
                                            android.content.ClipboardManager clipboardMgr = (android.content.ClipboardManager) getSystemService(Context.CLIPBOARD_SERVICE);
                                            ClipData clip = ClipData.newPlainText(CCSBasicConstants.MyTag, text);
                                            clipboardMgr.setPrimaryClip(clip);

                                        }
                                    }
                                }
                            });


                        }
                        //runOnUiThread(new Runnable() {
                        //    public void run() {

                        //        Toast.makeText(CCSReadyForShakeActivity.this, "Check removal.", Toast.LENGTH_LONG).show();
                        //    }
                        //});
                        HashMap<String, CCSSensoroListenerManager.BeaconExt> serialNumberToBeacon = sensoroListenerManager.getSerialNumberToBeacon();
                        if (serialNumberToBeacon != null) {
                            Log.d(CCSBasicConstants.MyTag, String.format("Number of sensoros in the list %d", serialNumberToBeacon.size()));
                            Collection<CCSSensoroListenerManager.BeaconExt> beaconList = serialNumberToBeacon.values();
                            if (beaconList != null) {
                                for (CCSSensoroListenerManager.BeaconExt beacon : serialNumberToBeacon.values()) {

                                    if (beacon.checkRemove()) {
                                        serialNumberToBeacon.remove(beacon.b.getSerialNumber());
                                        Log.d(CCSBasicConstants.MyTag, String.format("Beacon %s is removed", beacon.b.getSerialNumber()));

                                    }

                                }
                            }

                        }
                        Thread.sleep(10000);

                    } catch (Exception e) {
                        Log.e(CCSBasicConstants.MyTag, e.getMessage());
                    }

                }

            }
        }).start();
        /*
        if(shouldStopSensoroRemove) {
            shouldStopSensoroRemove = false;
            //if(sensoroRemoveThread == null) {
            new Thread(new Runnable() {

                @Override
                public void run() {
                    while (!shouldStopSensoroRemove) {
                        try {
                            //runOnUiThread(new Runnable() {
                            //    public void run() {

                            //        Toast.makeText(CCSReadyForShakeActivity.this, "Check removal.", Toast.LENGTH_LONG).show();
                            //    }
                            //});
                            HashMap<String, CCSSensoroListenerManager.BeaconExt> serialNumberToBeacon = sensoroListenerManager.getSerialNumberToBeacon();
                            if (serialNumberToBeacon != null) {
                                Collection<CCSSensoroListenerManager.BeaconExt> beaconList = serialNumberToBeacon.values();
                                if (beaconList != null) {
                                    for (CCSSensoroListenerManager.BeaconExt beacon : serialNumberToBeacon.values()) {

                                        if (beacon.checkRemove()) {
                                            serialNumberToBeacon.remove(beacon.b.getSerialNumber());
                                            Log.d(CCSBasicConstants.MyTag, String.format("Beacon %s is removed", beacon.b.getSerialNumber()));

                                        }

                                    }
                                }

                            }
                            Thread.sleep(10000);

                        } catch (Exception e) {

                        }
                    }

                }
            }).start();
        }*/
    }

    protected  void stopSensoroRemoveThread()
    {
        shouldStopSensoroRemove = true;

    }



    // Start sensoro service
    public void startSensoroService() {
        if(sensoroManager == null) {
            sensoroManager = SensoroManager.getInstance(getApplicationContext());
        }
        if(sensoroManager != null)
        {
            sensoroManager.setBeaconManagerListener(sensoroListenerManager);
            try {
                //sensoroManager.setCloudServiceEnable(true);
                Log.d(CCSBasicConstants.MyTag, "Start sensoro service.");
                fileLogger.writeToFile("Start sensoro service");
                Log.d(CCSBasicConstants.MyTag, "Read from file " + fileLogger.readFromFile());
                sensoroManager.startService();
            } catch (Exception e) {
                Log.e(CCSBasicConstants.MyTag, e.getMessage());
            }
        }
    }

    public void stopSensoroService() {

        if(sensoroManager != null) {
            try {
                //sensoroManager.setCloudServiceEnable(false);
                Log.d(CCSBasicConstants.MyTag, "Stop sensoro service.");
                fileLogger.writeToFile("Stop sensoro service");
                sensoroManager.stopService();

            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        SDKInitializer.initialize(getApplicationContext());
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        progressBar = (ProgressBar) findViewById(R.id.progressBar1);
        initWebView();
        startLocClient();
        //startSensoroService();
        //initSensoroServiceThread();
        initSensoroRemoveThread();
        readyForShakeWebView.loadUrl(CCSUrlConstants.readyForShakeUrl);
        req = new PayReq();
        sb=new StringBuffer();
        requestBlueEnable();

        CCSUtilities.versionName =  BuildConfig.VERSION_NAME + "." + BuildConfig.VERSION_CODE;
        versionNumberTxt = (TextView) findViewById(R.id.versionNumberTxtMain);
        versionNumberTxt.setText(CCSUtilities.versionName);

        // CCSShakeDetector initialization
        initShake();

        // Init WeChat manager
        weChatManager = new CCSWeChatManager(CCSReadyForShakeActivity.this);
        fileLogger = new CCSFileLogger(this, CCSBasicConstants.LogFileName);
        sensoroListenerManager.updateFileLogger(fileLogger);
    }

    private void initShake()
    {
        // CCSShakeDetector initialization
        mSensorManager = (SensorManager) getSystemService(Context.SENSOR_SERVICE);
        mAccelerometer = mSensorManager
                .getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
        mShakeDetector = new CCSShakeDetector();
        mShakeDetector.setOnShakeListener(new CCSShakeDetector.OnShakeListener() {

            @Override
            public void onShake(int count) {
				/*
				 * The following method, "handleShakeEvent(count):" is a stub //
				 * method you would use to setup whatever you want done once the
				 * device has been shook.
				 */
                final String urlLoaded = readyForShakeWebView.getUrl();

                if (urlLoaded.toLowerCase().contains(CCSUrlConstants.readyForShakeUrl.toLowerCase())) {
                    handleShakeEvent(count);
                }

            }
        });
    }

    private void handleShakeEvent(int count)
    {
        goToVendorList();
    }

    private void startLocClient()
    {
        if(mLocClient == null) {
            mLocClient = new LocationClient(this);
            mLocClient.registerLocationListener(myListener);
            LocationClientOption option = new LocationClientOption();
            option.setOpenGps(true); // 打开gps
            option.setCoorType("bd09ll"); // 设置坐标类型
            option.setScanSpan(1000);
            mLocClient.setLocOption(option);
        }
        mLocClient.start();
    }

    private void stopLocClient()
    {
        if(mLocClient != null) {
            mLocClient.stop();
        }
    }


    private Handler aliPayResponseHandler = new Handler() {
        public void handleMessage(Message msg) {
            if(msg != null) {
                switch (msg.what) {
                    case CCSAliPayConstants.SDK_PAY_FLAG: {

                        String msgStr = (String) msg.obj;
                        //JS method somehow has issues with backslashes so we just remove them
                        msgStr = msgStr == null ? CCSBasicConstants.EMPTYSTRING : msgStr.replaceAll("\"", CCSBasicConstants.EMPTYSTRING);

                        int sepIndex = msgStr.lastIndexOf(";");
                        String orderInfo = msgStr.substring(0, sepIndex);
                        String paymentIdStr = msgStr.substring(sepIndex + 1);

                        CCSPayResult payResult = new CCSPayResult(orderInfo);

                        // 支付宝返回此次支付结果及加签，建议对支付宝签名信息拿签约时支付宝提供的公钥做验签
                        String resultInfo = payResult.getResult();
                        String resultStatus = payResult.getResultStatus();
                        if(resultInfo == null) resultInfo = CCSBasicConstants.EMPTYSTRING;
                        if(resultStatus == null) resultStatus =CCSBasicConstants.EMPTYSTRING;
                        String responseToServer = paymentIdStr + "&" + resultInfo.replaceAll("\"", CCSBasicConstants.EMPTYSTRING);

                        // 判断resultStatus 为“9000”则代表支付成功，具体状态码代表含义可参考接口文档
                        if (TextUtils.equals(resultStatus, "9000")) {
                            //webView.loadUrl("javascript:HandlePaymentResult(\"" + responseToServer + "\");");

                        } else {
                            // 判断resultStatus 为非“9000”则代表可能支付失败
                            // “8000”代表支付结果因为支付渠道原因或者系统原因还在等待支付结果确认，最终交易是否成功以服务端异步通知为准（小概率状态）
                            if (TextUtils.equals(resultStatus, "8000")) {
                                Toast.makeText(CCSReadyForShakeActivity.this, "支付结果确认中",
                                        Toast.LENGTH_SHORT).show();

                            } else {
                                // 其他值就可以判断为支付失败，包括用户主动取消支付，或者系统返回的错误
                                Toast.makeText(CCSReadyForShakeActivity.this, "支付失败",
                                        Toast.LENGTH_SHORT).show();
                            }
                        }
                        break;
                    }
                    /*case ConstantsAliPay.SDK_CHECK_FLAG: {
                        Toast.makeText(CCSReadyForShakeActivity.this, "检查结果为：" + msg.obj,
                             Toast.LENGTH_SHORT).show();
                        break;
                    }*/
                    default:
                        break;
                }
            }
        };
    };


    // Main function to be called for aliPay payment processing
    /**
     * call alipay sdk pay. 调用SDK支付
     *
     */
    public void payBillAliPay(final String paymentId, String amount, String _outTradeNo) {
        if (TextUtils.isEmpty(CCSAliPayConstants.PARTNER) || TextUtils.isEmpty(CCSAliPayConstants.RSA_PRIVATE)
                || TextUtils.isEmpty(CCSAliPayConstants.SELLER)) {
            new AlertDialog.Builder(this)
                    .setTitle("警告")
                    .setMessage("需要配置PARTNER | RSA_PRIVATE| SELLER")
                    .setPositiveButton("确定",
                            new DialogInterface.OnClickListener() {
                                public void onClick(
                                        DialogInterface dialoginterface, int i) {
                                    //
                                    finish();
                                }
                            }).show();
            return;
        }
        String outTradeNo = _outTradeNo;//getOutTradeNo();
        Random r = new Random();
        amount = String.valueOf(0.01 * (r.nextInt(10 - 1) + 1));

        // 订单
        String orderInfo = getOrderInfo("测试的商品", "该测试商品的详细描述", amount, outTradeNo);

        // 对订单做RSA 签名
        String sign = sign(orderInfo);
        try {
            // 仅需对sign 做URL编码
            sign = URLEncoder.encode(sign, "UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        // 完整的符合支付宝参数规范的订单信息
        final String payInfo = orderInfo + "&sign=\"" + sign + "\"&"
                + getSignType();

        Runnable payRunnable = new Runnable() {

            @Override
            public void run() {
                // 构造PayTask 对象
                PayTask alipay = new PayTask(CCSReadyForShakeActivity.this);
                // 调用支付接口，获取支付结果
                String result = alipay.pay(payInfo);

                Message msg = new Message();
                if(msg != null) {
                    msg.what = CCSAliPayConstants.SDK_PAY_FLAG;
                    msg.obj = result + ";paymentId=" + "\"" + paymentId + "\"";
                    if(aliPayResponseHandler != null) {
                        aliPayResponseHandler.sendMessage(msg);
                    }
                }
            }
        };

        // 必须异步调用
        Thread payThread = new Thread(payRunnable);
        payThread.start();
    }



    /**
     * check whether the device has authentication alipay account.
     * 查询终端设备是否存在支付宝认证账户
     *
     */
    /*public void check(View v) {
        Runnable checkRunnable = new Runnable() {

            @Override
            public void run() {
                // 构造PayTask 对象
                PayTask payTask = new PayTask(CCSReadyForShakeActivity.this);
                // 调用查询接口，获取查询结果
                boolean isExist = payTask.checkAccountIfExist();

                Message msg = new Message();
                msg.what = ConstantsAliPay.SDK_CHECK_FLAG;
                msg.obj = isExist;
                aliPayResponseHandler.sendMessage(msg);
            }
        };

        Thread checkThread = new Thread(checkRunnable);
        checkThread.start();

    }*/

    /**
     * get the sdk version. 获取SDK版本号
     *
     */
    /*public void getSDKVersion() {
        PayTask payTask = new PayTask(this);
        String version = payTask.getVersion();
        Toast.makeText(this, version, Toast.LENGTH_SHORT).show();
    }*/

    /**
     * create the order info. 创建订单信息
     *
     */
    public String getOrderInfo(String subject, String body, String price, String outTradeNo) {

        // 签约合作者身份ID
        String orderInfo = "partner=" + "\"" + CCSAliPayConstants.PARTNER + "\"";

        // 签约卖家支付宝账号
        orderInfo += "&seller_id=" + "\"" + CCSAliPayConstants.SELLER + "\"";

        // 商户网站唯一订单号
        orderInfo += "&out_trade_no=" + "\"" + outTradeNo+ "\"";

        // 商品名称
        orderInfo += "&subject=" + "\"" + subject + "\"";

        // 商品详情
        orderInfo += "&body=" + "\"" + body + "\"";

        // 商品金额
        orderInfo += "&total_fee=" + "\"" + price + "\"";

        // 服务器异步通知页面路径
        orderInfo += "&notify_url=" + "\"" + CCSAliPayConstants.CCSNotifyURL
                + "\"";

        // 服务接口名称， 固定值
        orderInfo += "&service=\"mobile.securitypay.pay\"";

        // 支付类型， 固定值
        orderInfo += "&payment_type=\"1\"";

        // 参数编码， 固定值
        orderInfo += "&_input_charset=\"utf-8\"";

        // 设置未付款交易的超时时间
        // 默认30分钟，一旦超时，该笔交易就会自动被关闭。
        // 取值范围：1m～15d。
        // m-分钟，h-小时，d-天，1c-当天（无论交易何时创建，都在0点关闭）。
        // 该参数数值不接受小数点，如1.5h，可转换为90m。
        orderInfo += "&it_b_pay=\"30m\"";

        // extern_token为经过快登授权获取到的alipay_open_id,带上此参数用户将使用授权的账户进行支付
        // orderInfo += "&extern_token=" + "\"" + extern_token + "\"";

        // 支付宝处理完请求后，当前页面跳转到商户指定页面的路径，可空
        orderInfo += "&return_url=\"m.alipay.com\"";

        // 调用银行卡支付，需配置此参数，参与签名， 固定值 （需要签约《无线银行卡快捷支付》才能使用）
        // orderInfo += "&paymethod=\"expressGateway\"";

        return orderInfo;
    }

    /**
     * get the out_trade_no for an order. 生成商户订单号，该值在商户端应保持唯一（可自定义格式规范）
     *
     */
    /*public String getOutTradeNo() {
        SimpleDateFormat format = new SimpleDateFormat("MMddHHmmss",
                Locale.getDefault());
        Date date = new Date();
        String key = format.format(date);

        Random r = new Random();
        key = key + r.nextInt();
        key = key.substring(0, 15);
        return key;
    }*/

    /**
     * sign the order info. 对订单信息进行签名
     *
     * @param content
     *            待签名订单信息
     */
    public String sign(String content) {
        return CCSSignUtils.sign(content, CCSAliPayConstants.RSA_PRIVATE);
    }

    /**
     * get the sign type we use. 获取签名方式
     *
     */
    public String getSignType() {
        return "sign_type=\"RSA\"";
    }


    private class CCSReadyForShakeWebViewCallback extends WebViewClient {

        boolean errorDetected = false;

        @Override
        public void onPageStarted(WebView view, String url, Bitmap favicon) {
            if(progressBar != null) {
                progressBar.setVisibility(View.VISIBLE);

            }
            errorDetected = false;
        }

        @Override
        public boolean shouldOverrideUrlLoading(WebView view, String url) {

            return (false);
        }

        //This is called when page is finished loading
        @Override
        public void onPageFinished(WebView view, final String url)
        {
            if(versionNumberTxt != null) {
                if (url.equalsIgnoreCase(CCSUrlConstants.homeUrl) || url.equalsIgnoreCase(CCSUrlConstants.aboutUsUrl)) {
                    versionNumberTxt.setVisibility(View.VISIBLE);
                }
                else
                {
                    versionNumberTxt.setVisibility(View.INVISIBLE);
                }
            }
            if(url.toLowerCase().contains(CCSUrlConstants.readyForShakeUrl.toLowerCase()))
            {
                startSensoroService();
            }
            else
            {
                stopSensoroService();
            }
            if(progressBar != null) {
                progressBar.setVisibility(View.GONE);
            }

        }

        @Override
        public void onReceivedError(WebView view, int errorCode, String description, String failingUrl) {
            errorDetected = true;
        }

    }
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    // Pay bill via WeChat
    public void payBillWeChat(final String paymentId, String amount, String _outTradeNo)
    {
        Random r = new Random();
        WeChatPayAmount = r.nextInt(10 - 1) + 1;
        WeChatOutTradeNo  = _outTradeNo;

        GetPrepayIdTask getPrepayId = new GetPrepayIdTask();
        if(getPrepayId != null) getPrepayId.execute();
    }

    private String genPackageSign(List<NameValuePair> params) throws Exception{
        StringBuilder sb = new StringBuilder();
        if(params != null) {
            for (int i = 0; i < params.size(); i++) {
                sb.append(params.get(i).getName());
                sb.append('=');
                sb.append(params.get(i).getValue());
                sb.append('&');
            }
            sb.append("key=");
            sb.append(CCSWeChatConstants.API_KEY);
        }

        String packageSign = CCSMD5.getMessageDigest(sb.toString().getBytes()).toUpperCase();
        //Log.e("orion",packageSign);
        return packageSign;
    }

    private String genAppSign(List<NameValuePair> params) throws Exception{
        StringBuilder sb = new StringBuilder();
        if(params != null) {
            for (int i = 0; i < params.size(); i++) {
                sb.append(params.get(i).getName());
                sb.append('=');
                sb.append(params.get(i).getValue());
                sb.append('&');
            }
            sb.append("key=");
            sb.append(CCSWeChatConstants.API_KEY);

            this.sb.append("sign str\n" + sb.toString() + "\n\n");

        }
        String appSign = CCSMD5.getMessageDigest(sb.toString().getBytes()).toUpperCase();
        Log.e("orion", appSign);
        return appSign;
    }

    private String toXml(List<NameValuePair> params) {
        StringBuilder sb = new StringBuilder();
        sb.append("<xml>");
        if(params != null) {
            for (int i = 0; i < params.size(); i++) {
                sb.append("<" + params.get(i).getName() + ">");


                sb.append(params.get(i).getValue());
                sb.append("</" + params.get(i).getName() + ">");
            }
        }
        sb.append("</xml>");

        Log.e("orion",sb.toString());
        return sb.toString();
    }

    private class GetPrepayIdTask extends AsyncTask<Void, Void, Map<String,String>> {

        private ProgressDialog dialog;

        public String errorMsg = null;
        @Override
        protected void onPreExecute() {
            if(dialog != null) {
                dialog.dismiss();
                dialog = null;
            }
            dialog = ProgressDialog.show(CCSReadyForShakeActivity.this, getString(R.string.app_tip), getString(R.string.getting_prepayid));
        }

        @Override
        protected void onPostExecute(final Map<String,String> result) {
            if (dialog != null) {
                dialog.dismiss();
            }

           try {
               if(errorMsg != null)
               {
                   throw new Exception(errorMsg);
               }
               if(result == null)
               {
                   throw  new Exception("failed to get prepay id");
               }
               if (sb != null) sb.append("prepay_id\n" + result.get("prepay_id") + "\n\n");
               resultUnifiedOrder = result;

               // Generate pay request
               genPayReq();
               // Send pay request
               sendPayReq();
           }
           catch (final Exception e)
           {

           }
        }

        @Override
        protected void onCancelled() {
            super.onCancelled();
        }

        @Override
        protected Map<String,String>  doInBackground(Void... params){
            try {
                String url = String.format("https://api.mch.weixin.qq.com/pay/unifiedorder");
                String entity = genProductArgs();
                byte[] buf = CCSNetWeChat.httpPost(url, entity);
                if (buf == null || buf.length == 0) {
                    return null;
                }
                String content = new String(buf);
                Map<String, String> xml = decodeXml(content);
                return xml;
            }
            catch (Exception e)
            {
                errorMsg = e.getMessage();
                return null;
            }
        }
    }

    public Map<String,String> decodeXml(String content) {

        try {
            Map<String, String> xml = new HashMap<String, String>();
            XmlPullParser parser = Xml.newPullParser();
            if(content != null) parser.setInput(new StringReader(content));
            int event = parser.getEventType();
            while (event != XmlPullParser.END_DOCUMENT) {

                String nodeName=parser.getName();
                switch (event) {
                    case XmlPullParser.START_DOCUMENT:

                        break;
                    case XmlPullParser.START_TAG:

                        if("xml".equals(nodeName)==false){
                            //å®žä¾‹åŒ–studentå¯¹è±¡
                            xml.put(nodeName,parser.nextText());
                        }
                        break;
                    case XmlPullParser.END_TAG:
                        break;
                }
                event = parser.next();
            }

            return xml;
        } catch (Exception e) {
            Log.e("orion",e.toString());
        }
        return null;

    }

    private String genNonceStr() throws Exception{
        Random random = new Random();
        return CCSMD5.getMessageDigest(String.valueOf(random.nextInt(10000)).getBytes());
    }

    private long genTimeStamp() {
        return System.currentTimeMillis() / 1000;
    }

    private String genOutTradNo() throws Exception{
        Random random = new Random();
        return CCSMD5.getMessageDigest(String.valueOf(random.nextInt(10000)).getBytes());
    }

    private String genProductArgs() throws Exception{
        StringBuffer xml = new StringBuffer();

        try {
            String	nonceStr = genNonceStr();


            xml.append("</xml>");
            List<NameValuePair> packageParams = new LinkedList<NameValuePair>();
            packageParams.add(new BasicNameValuePair("appid", CCSWeChatConstants.APP_ID));
            packageParams.add(new BasicNameValuePair("body", "weixin"));
            packageParams.add(new BasicNameValuePair("mch_id", CCSWeChatConstants.MCH_ID));
            packageParams.add(new BasicNameValuePair("nonce_str", nonceStr));
            packageParams.add(new BasicNameValuePair("notify_url", "http://cloudcomspace.cloudapp.net/Payments/PaymentNotifyActionWeChat"));
            packageParams.add(new BasicNameValuePair("out_trade_no", WeChatOutTradeNo));//genOutTradNo()));
            packageParams.add(new BasicNameValuePair("spbill_create_ip","127.0.0.1"));
            packageParams.add(new BasicNameValuePair("total_fee", String.valueOf(WeChatPayAmount)));
            packageParams.add(new BasicNameValuePair("trade_type", "APP"));


            String sign = genPackageSign(packageParams);
            packageParams.add(new BasicNameValuePair("sign", sign));


            String xmlstring =toXml(packageParams);

            return xmlstring;

        } catch (Exception e) {
            Log.e(CCSBasicConstants.MyTag, "genProductArgs fail, ex = " + e.getMessage());
            throw e;
        }

    }

    private void genPayReq() throws Exception{
        if(req != null) {
            req.appId = CCSWeChatConstants.APP_ID;
            req.partnerId = CCSWeChatConstants.MCH_ID;
            if (resultUnifiedOrder != null)
                req.prepayId = resultUnifiedOrder.get("prepay_id");
            req.packageValue = "Sign=WXPay";
            req.nonceStr = genNonceStr();
            req.timeStamp = String.valueOf(genTimeStamp());

            List<NameValuePair> signParams = new LinkedList<NameValuePair>();
            signParams.add(new BasicNameValuePair("appid", req.appId));
            signParams.add(new BasicNameValuePair("noncestr", req.nonceStr));
            signParams.add(new BasicNameValuePair("package", req.packageValue));
            signParams.add(new BasicNameValuePair("partnerid", req.partnerId));
            signParams.add(new BasicNameValuePair("prepayid", req.prepayId));
            signParams.add(new BasicNameValuePair("timestamp", req.timeStamp));
            req.sign = genAppSign(signParams);

            sb.append("sign\n" + req.sign + "\n\n");
        }
    }

    private void sendPayReq() {
        if(weChatManager.msgApi != null) {
            String wxappPayEntryClassname = (new com.tencent.mm.sdk.a(this)).getString("_wxapp_pay_entry_classname_", (String) null);
            weChatManager.msgApi.sendReq(req);
        }
    }

    public void goToVendorList()
    {
        /*Bundle b = new Bundle();
        b.putString(CCSBundleConstants.RedirectToUrlKey, "https://www.whistlerblackcomb.com");
        Intent nextScreen = new Intent(getApplicationContext(), CCSVendorCustomViewActivity.class);
        nextScreen.putExtras(b); //Put your id to your next Intent
        startActivity(nextScreen);*/

        String sensoroListStr =   sensoroListenerManager.getCurrentActiveSensorosAsString();

        /*new AlertDialog.Builder(CCSReadyForShakeActivity.this)
                .setTitle("Message")
                .setMessage("Location " + " Sensoros " + sensoroListStr)
                .setPositiveButton("OK",
                        new DialogInterface.OnClickListener() {
                            public void onClick(
                                    DialogInterface dialoginterface, int i) {

                            }
                        }).show();*/


        String urlToLoad = CCSUrlConstants.ShowMapWhenShakeUrl + "?" + "YunziIDs=" + sensoroListStr + "&ShowType=list";
        // during the shake this is most likely not needed
        // remember to comment out
        if(this.userId != null)
        {
            urlToLoad += "&UserId=" + this.userId;
        }
        readyForShakeWebView.loadUrl(urlToLoad);


    }

    public void goToVendorListWithLocation()
    {
        String sensoroListStr = sensoroListenerManager.getCurrentActiveSensorosAsString();
        /*
        new AlertDialog.Builder(CCSReadyForShakeActivity.this)
                .setTitle("Message")
                .setMessage("Location " + " Sensoros " + sensoroListStr)
                .setPositiveButton("OK",
                        new DialogInterface.OnClickListener() {
                            public void onClick(
                                    DialogInterface dialoginterface, int i) {

                            }
                        }).show();
        */

        //CCSUtilities.LatLngModel latLng = CCSUtilities.bd2gcj(lat, lng);
        String urlToLoad = CCSUrlConstants.ShowMapUrl + "?" + "CenterLatitude=" + lat + "&CenterLongitude=" + lng + "&YunziIDs=" + sensoroListStr + "&ShowType=list";
        if(this.userId != null)
        {
            urlToLoad += "&UserId=" + this.userId;
        }
        final String urlToLoadFinal = urlToLoad;
        readyForShakeWebView.loadUrl(urlToLoad);

    }

    public void goToVendorListNoSensoros(final String showType)
    {
        String sensoroListStr = sensoroListenerManager.getCurrentActiveSensorosAsString();
        /*
        new AlertDialog.Builder(CCSReadyForShakeActivity.this)
                .setTitle("Message")
                .setMessage("Location " + " Sensoros " + sensoroListStr)
                .setPositiveButton("OK",
                        new DialogInterface.OnClickListener() {
                            public void onClick(
                                    DialogInterface dialoginterface, int i) {

                            }
                        }).show();
        */
        //CCSUtilities.LatLngModel latLng = CCSUtilities.bd2gcj(lat, lng);

        String urlToLoad = null;
        if(lat != null && lng != null)
        {
            urlToLoad = CCSUrlConstants.ShowMapUrl + "?" + "CenterLatitude=" + lat + "&CenterLongitude=" + lng + "&ShowType=" + showType;
        }
        else
        {
            urlToLoad = CCSUrlConstants.ShowMapUrl + "?" + "ShowType=" + showType;
        }
        if(this.userId != null)
        {
            urlToLoad += "&UserId=" + this.userId;
        }
        readyForShakeWebView.loadUrl(urlToLoad);

    }

    public void redirectToURL(String redirectToUrl)
    {
        Bundle b = new Bundle();
        b.putString(CCSBundleConstants.RedirectToUrlKey, redirectToUrl);
        Intent nextScreen = new Intent(getApplicationContext(), CCSVendorCustomViewActivity.class);
        nextScreen.putExtras(b); //Put your id to your next Intent
        startActivity(nextScreen);
    }

    public void screenTapped(View view) {


    }
}
