package my.ccs.project.activities;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.net.http.SslError;
import android.os.Build;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.webkit.SslErrorHandler;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.ImageButton;
import android.widget.ProgressBar;

import com.tencent.mm.sdk.modelmsg.SendMessageToWX;
import com.tencent.mm.sdk.modelmsg.WXMediaMessage;
import com.tencent.mm.sdk.modelmsg.WXWebpageObject;

import java.io.ByteArrayOutputStream;

import my.ccs.project.R;
import my.ccs.project.constants.CCSBasicConstants;
import my.ccs.project.constants.CCSBundleConstants;
import my.ccs.project.utils.wechat.CCSWeChatManager;

public class CCSVendorCustomViewActivity extends Activity {

    private WebView ccsVendorCustomWebView;
    private String redirectToUrl;
    private ImageButton infOBtn;
    private CCSWeChatManager weChatManager;
    private String pageTitle = null;
    ProgressBar ccsVendorCustomWebViewPbar;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if(Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
            WebView.enableSlowWholeDocumentDraw();
        }

        setContentView(R.layout.activity_ccsvendor_custom_view);
        ccsVendorCustomWebViewPbar = (ProgressBar) findViewById(R.id.CCSVendorCustomWebViewPB1);

        infOBtn = (ImageButton) findViewById(R.id.infoBtn);
        initCCSVendorCustomWebView();
        Bundle b = getIntent().getExtras();
        redirectToUrl = b.getString(CCSBundleConstants.RedirectToUrlKey);

        ccsVendorCustomWebView.loadUrl(redirectToUrl);

        // init WeChat manager
        weChatManager = new CCSWeChatManager(CCSVendorCustomViewActivity.this);
    }

    /**
     * WevView screenshot
     *
     * @param webView
     * @return
     */
    public static Bitmap screenshot(WebView webView) {
        webView.measure(View.MeasureSpec.makeMeasureSpec(
                        View.MeasureSpec.UNSPECIFIED, View.MeasureSpec.UNSPECIFIED),
                View.MeasureSpec.makeMeasureSpec(0, View.MeasureSpec.UNSPECIFIED));
        webView.layout(0, 0, webView.getMeasuredWidth(), webView.getMeasuredHeight());
        webView.setDrawingCacheEnabled(true);
        webView.buildDrawingCache();
        Bitmap bitmap = Bitmap.createBitmap(150,
                150, Bitmap.Config.ARGB_8888);

        Canvas canvas = new Canvas(bitmap);
        Paint paint = new Paint();
        int iHeight = bitmap.getHeight();
        canvas.drawBitmap(bitmap, 0, iHeight, paint);
        webView.draw(canvas);
        return bitmap;
    }

    public void infoBtnOnClick(View v) {

        CharSequence colors[] = new CharSequence[] {"微信联系人", "微信朋友圈"};

        AlertDialog.Builder builder = new AlertDialog.Builder(CCSVendorCustomViewActivity.this);
        builder.setTitle("分享给");
        builder.setItems(colors, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                // the user clicked on colors[which]
                switch (which) {
                    case 0: {
                        /*WXMediaMessage msg = new WXMediaMessage();
                        msg.title = "Some Title";
                        msg.description = "Some Description";
                        Bitmap bmp = BitmapFactory.decodeResource(getResources(), R.drawable.icon_info);
                        //Init a WXImageObject object
                        WXImageObject imgObj = new WXImageObject(bmp);
                        msg.mediaObject = imgObj;
                        //thumbnail of image
                        Bitmap thumbBmp = Bitmap.createScaledBitmap(bmp, 150, 150, true);
                        bmp.recycle();
                        msg.thumbData = bmpToByteArray(thumbBmp, true); //set the thumbnail*/
                        //Init a WXWebpageObject object
                        WXWebpageObject webpage = new WXWebpageObject();
                        webpage.webpageUrl = redirectToUrl;
                        WXMediaMessage msg = new WXMediaMessage(webpage);
                        msg.title = pageTitle;
                        msg.description = CCSVendorCustomViewActivity.this.redirectToUrl;
                        Bitmap thumb = CCSVendorCustomViewActivity.screenshot(ccsVendorCustomWebView);
                        msg.thumbData = bmpToByteArray(thumb, true);
                        SendMessageToWX.Req req = new SendMessageToWX.Req();
                        req.transaction = buildTransaction("webpage");
                        req.message = msg;
                        req.scene = SendMessageToWX.Req.WXSceneSession;
                        weChatManager.msgApi.sendReq(req);
                        break;
                    }
                    case 1: {
                        /*WXMediaMessage msg = new WXMediaMessage();
                        msg.title = "Some Title2";
                        msg.description = "Some Description2";
                        Bitmap bmp = BitmapFactory.decodeResource(getResources(), R.drawable.icon_info);
                        //Init a WXImageObject object
                        WXImageObject imgObj = new WXImageObject(bmp);
                        msg.mediaObject = imgObj;
                        //thumbnail of image
                        Bitmap thumbBmp = Bitmap.createScaledBitmap(bmp, 150, 150, true);
                        bmp.recycle();
                        msg.thumbData = bmpToByteArray(thumbBmp, true); //set the thumbnail*/
                        //Init a WXWebpageObject object
                        WXWebpageObject webpage = new WXWebpageObject();
                        webpage.webpageUrl = redirectToUrl;
                        WXMediaMessage msg = new WXMediaMessage(webpage);
                        msg.title = pageTitle;
                        msg.description = redirectToUrl;
                        Bitmap thumb = CCSVendorCustomViewActivity.screenshot(ccsVendorCustomWebView);
                        msg.thumbData = bmpToByteArray(thumb, true);
                        SendMessageToWX.Req req = new SendMessageToWX.Req();
                        req.transaction = buildTransaction("webpage");
                        req.message = msg;
                        req.scene = SendMessageToWX.Req.WXSceneTimeline;
                        weChatManager.msgApi.sendReq(req);

                        break;
                    }

                }
            }
        });
        builder.show();
    }

    private String buildTransaction(final String type) {
        return (type == null) ? String.valueOf(System.currentTimeMillis()) : type + System.currentTimeMillis();
    }

    public static byte[] bmpToByteArray(final Bitmap bmp, final boolean needRecycle) {
        ByteArrayOutputStream output = new ByteArrayOutputStream();
        bmp.compress(Bitmap.CompressFormat.PNG, 100, output);
        if (needRecycle) {
            bmp.recycle();
        }

        byte[] result = output.toByteArray();
        try {
            output.close();
        } catch (Exception e) {
            e.printStackTrace();
        }

        return result;
    }

    private void initCCSVendorCustomWebView() {
        ccsVendorCustomWebView = (WebView) findViewById(R.id.CCSVendorCustomWebView);
        if (ccsVendorCustomWebView != null) {
            WebSettings webSettings = ccsVendorCustomWebView.getSettings();
            webSettings.setBuiltInZoomControls(true);
            webSettings.setGeolocationEnabled(true);
            webSettings.setAppCacheEnabled(true);
            webSettings.setDatabaseEnabled(true);
            webSettings.setDomStorageEnabled(true);

            webSettings.setUserAgentString(
                    webSettings.getUserAgentString()
                            + " "
                            + CCSBasicConstants.userAgentString
            );
            ccsVendorCustomWebView.setWebChromeClient(new WebChromeClient() {
                public void onProgressChanged(WebView view, int progress) {
                    if(progress < 100 && ccsVendorCustomWebViewPbar.getVisibility() == ProgressBar.GONE){
                        ccsVendorCustomWebViewPbar.setVisibility(ProgressBar.VISIBLE);
                    }

                    ccsVendorCustomWebViewPbar.setProgress(progress);
                    if(progress == 100) {
                        ccsVendorCustomWebViewPbar.setVisibility(ProgressBar.GONE);
                    }
                }
            });
            ccsVendorCustomWebView.setWebViewClient(new CCSVendorCustomWebViewCallback());
        }
    }

    private class CCSVendorCustomWebViewCallback extends WebViewClient {

        @Override
        public void onPageStarted(WebView view, String url, Bitmap favicon) {
            Log.e(CCSBasicConstants.MyTag, "onStarted" + url);


        }

        @Override
        public boolean shouldOverrideUrlLoading(WebView view, String url) {

            return (false);
        }

        //This is called when page is finished loading
        @Override
        public void onPageFinished(WebView view, String url)
        {
            Log.e(CCSBasicConstants.MyTag, "onFinished" + url);
            pageTitle  = view.getTitle();
        }

        @Override
        public void onReceivedError(WebView view, int errorCode, String description, String failingUrl) {
            Log.e(CCSBasicConstants.MyTag, String.valueOf(errorCode));
            Log.e(CCSBasicConstants.MyTag, description);
        }
        @Override
        public void onReceivedSslError(WebView view, SslErrorHandler handler, SslError error) {
            Log.e(CCSBasicConstants.MyTag, error.toString());
            // this is an unsafe code
            handler.proceed();

        }
    }
}
