package my.ccs.project.utils.basic;

import android.app.Activity;
import android.content.Context;
import android.os.Handler;
import android.webkit.JavascriptInterface;
import android.widget.Toast;

import my.ccs.project.activities.CCSReadyForShakeActivity;
import my.ccs.project.constants.CCSBasicConstants;

/**
 * Created by Hayk on 6/19/2016.
 */
//Handle button clicks on WebView
public class CCSJavaScriptInterface {

    final Handler jsHandler = new Handler();
    Context mContext;
    final CCSReadyForShakeActivity callerActivity;

    public CCSJavaScriptInterface(Context c, CCSReadyForShakeActivity callerActivity) {
        this.mContext = c;
        this.callerActivity = callerActivity;
    }
    @JavascriptInterface
    public void performClick(final String  paymentId, final String  amount, final String outTradeNo, final String methodID){

        jsHandler.post(new Runnable() {
            @Override
            public void run() {
                // This gets executed on the UI thread so it can safely modify Views
                //Toast.makeText(mContext, paymentId + " " + amount + " " + methodID, Toast.LENGTH_LONG ).show();
                if(methodID != null && methodID.equals(CCSBasicConstants.PaymentMethodAliPay))
                {
                    callerActivity.payBillAliPay(paymentId, amount, outTradeNo);
                }
                else
                {
                    if(methodID.equals(CCSBasicConstants.PaymentMethodWeChat))
                    {
                        callerActivity.payBillWeChat(paymentId, amount, outTradeNo);
                    }
                }

            }
        });

    }

    @JavascriptInterface
    public void performClickUserId(final String  userIdFromWebView){

        jsHandler.post(new Runnable() {
            @Override
            public void run() {

                callerActivity.setUserId(userIdFromWebView);
            }

        });

    }

    @JavascriptInterface
    public void redirectToURL(final String  redirectToUrl){

        jsHandler.post(new Runnable() {
            @Override
            public void run() {
                callerActivity.redirectToURL(redirectToUrl);
            }
        });

    }

    @JavascriptInterface
    public void showVendorList(){
        jsHandler.post(new Runnable() {
            @Override
            public void run() {
                callerActivity.goToVendorListNoSensoros(CCSBasicConstants.ShowTypeList);
            }
        });
    }

    @JavascriptInterface
    public void shakeImgTap(){
        jsHandler.post(new Runnable() {
            @Override
            public void run() {
                callerActivity.goToVendorList();
            }
        });
    }

    @JavascriptInterface
    public void showVendorListNoSensoros(final String showType){
        jsHandler.post(new Runnable() {
            @Override
            public void run() {
                switch (showType){
                    case CCSBasicConstants.ShowTypeList:
                        callerActivity.goToVendorListNoSensoros(CCSBasicConstants.ShowTypeList);
                        break;
                    case CCSBasicConstants.ShowTypeMap:
                        callerActivity.goToVendorListNoSensoros(CCSBasicConstants.ShowTypeMap);
                        break;
                }

            }
        });
    }



}
