package my.ccs.project.utils.logcatreader;

import android.app.Activity;
import android.content.Context;
import android.util.Log;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.InputStreamReader;

import my.ccs.project.constants.CCSBasicConstants;

/**
 * Created by Hayk on 7/31/2016.
 */
public class CCSFileLogger {

    private String fileName;

    // constructor
    public CCSFileLogger(Activity context, String fileName) {
        if(context == null)
            return;
        File file = new File(context.getFilesDir(), fileName);
        this.fileName = file.getAbsolutePath();
        Log.d(CCSBasicConstants.MyTag, String.format("File should be created under %s",file.getAbsolutePath()));
        try {
            if(file.exists())
                file.delete();
            Log.d(CCSBasicConstants.MyTag, String.format("File  being created under %s",file.getAbsolutePath()));
            file.createNewFile();

        } catch (Exception e) {
            e.printStackTrace();
            Log.e(CCSBasicConstants.MyTag, e.getMessage());
        }


    }

    public void writeToFile(String str)
    {


            try {
                File file = new File(this.fileName);
                FileOutputStream outputStream = new FileOutputStream(file, true);
                outputStream.write(("\r\n" + str).getBytes());

                outputStream.close();
            }
            catch (Exception e) {
                //You'll need to add proper error handling here
                Log.e(CCSBasicConstants.MyTag, e.getMessage());
            }
    }

    public String readFromFile() {

        StringBuilder text = new StringBuilder();
        try {
            File file = new File(this.fileName);
            //Read text from file
            BufferedReader br = new BufferedReader(new FileReader(file));
            String line;

            while ((line = br.readLine()) != null) {
                text.append(line);
                text.append('\n');
            }
            br.close();
        } catch (Exception e) {
            //You'll need to add proper error handling here
            Log.e(CCSBasicConstants.MyTag, e.getMessage());
            text.append(e.getMessage());
        }

        return  text.toString();
    }

}
