//
//  CustomUrlViewController.swift
//  CCSChinaPortalUsers
//
//  Created by CCS China Portal on 5/2/16.
//  Copyright © 2016 CCS China Portal. All rights reserved.
//



class CCSCustomUrlViewController: UIViewController , UIWebViewDelegate, WXApiDelegate{

    // Outlets
    @IBOutlet var webView: UIWebView!
    @IBOutlet var progressView: UIProgressView!
    @IBOutlet var backBtn: UIButton!
    @IBOutlet var infoBtn: UIButton!
    
    var urlToLoad: String? = nil
    var pageTitle: String? = nil
    var pageURL: String? = nil
    var pageThumbImage : UIImageView = UIImageView.init();
    var theBool: Bool = false
    var myTimer: NSTimer =  NSTimer()
    var didFinishTimer: NSTimer =  NSTimer()
    var webViewLoads = 0
    var webViewDidStart:Int = 0
    var webViewDidFinish:Int = 0
    var userId : String? = nil;
    
    let webViewManager : CCSWebViewManager = CCSWebViewManager()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        if(urlToLoad != nil)
        {
            webView.delegate = self;
            webViewManager.loadUrlInWebView(webView, url: urlToLoad!)
        }
    }
    
    override func viewWillAppear(animated: Bool) {
        super.viewWillAppear(animated)
    }
    
    override func viewWillDisappear(animated: Bool) {
        super.viewWillDisappear(animated)
    }

    // MARK: Animating progress bar
    
    func startAnimatingProgressBar() {
        self.theBool = false
        progressView.hidden = false
        //progressView.alpha = 0
       /* UIView.animateWithDuration(0.2, animations: { () -> Void in
            self.progressView.alpha = 0.6
        })*/
        self.progressView.progress = 0.2
        
        //Tweek this number to alter the main speed of the progress bar
        /*let number = drand48() / 80;
                   print("startAnimatingProgressBar|\(number)")
        */
        self.myTimer = NSTimer.scheduledTimerWithTimeInterval(0.016, target: self, selector: "timerCallback", userInfo: nil, repeats: true)
    }
    
    func finishAnimatingProgressBar() {
        self.theBool = true
    }
    
    
    // MARK: Web view methods
    
    func webViewDidStartLoad(webView: UIWebView) {
        webViewDidStart++
        webViewLoads++
        if webViewLoads <= 1 {
            startAnimatingProgressBar()
        }
    }
    
    func webViewDidFinishLoad(webView: UIWebView) {
        webViewLoads--
        webViewDidFinish++
        if webViewLoads == 0 {
            finishAnimatingProgressBar()
            //        println("webViewLoads \(webViewLoads)")
         
            self.pageTitle = webView.stringByEvaluatingJavaScriptFromString("document.title")!;
            self.pageURL = webView.stringByEvaluatingJavaScriptFromString("document.URL")!;
            print(self.pageTitle);
            print(self.pageURL);
            
            self.pageThumbImage = UIImageView.init(frame: webView.frame);
            
            UIGraphicsBeginImageContext(webView.bounds.size);
            webView.layer.renderInContext(UIGraphicsGetCurrentContext()!)
            pageThumbImage.image = UIGraphicsGetImageFromCurrentImageContext()
            UIGraphicsEndImageContext()
        }
    }
    
    
    func webView(webView: UIWebView, didFailLoadWithError error: NSError?)
    {
        theBool = true
        webViewLoads = 0
        
    }
    
    /*
    func webView(webView: UIWebView, shouldStartLoadWithRequest request: NSURLRequest, navigationType: UIWebViewNavigationType) -> Bool{
        print("shouldStartLoadWithRequest")
        return true;
    }
    
    
    func webView(webView: UIWebView, didFailLoadWithError error: NSError?)
    {
        funcToCallCalledWhenUIWebViewFinishesLoading()
    }*/
    
    // MARK: Info, back button
    
    @IBAction func infoBtnPressed(sender: AnyObject) {
        
        var titleToShare :String = ""
        var urlToShare : String = ""
        if(self.pageTitle != nil)
        {
            titleToShare = self.pageTitle!
        }
        else
        {
            if(self.urlToLoad != nil)
            {
                titleToShare = self.urlToLoad!
            }
            
        }
        if(self.urlToLoad != nil)
        {
            urlToShare = self.urlToLoad!
            
        }
        
        /*var img : NSData = NSData()
        if(self.pageThumbImage.image != nil)
        {
        let MAX_IMG_SIZE : CGFloat = 32.0
        let maxFileSize : CGFloat = MAX_IMG_SIZE * 1024
        img =  NSData(data: UIImageJPEGRepresentation(self.pageThumbImage.image!, 1.0)!)
        if(CGFloat(img.length) > maxFileSize)
        {
        img = NSData(data: UIImageJPEGRepresentation(self.pageThumbImage.image!, maxFileSize/CGFloat(img.length))!)
        print(img.length)*/
        /*if(CGFloat(img.length) < maxFileSize)
        {
        mediaMsg.setThumbImage(UIImage.init(data: img))
        }*/
        
        //}
        //mediaMsg.setThumbImage(self.pageThumbImage.image!)
        //}
        
        if let myWebsite = NSURL(string: urlToShare) {
            let objectsToShare : NSMutableArray = NSMutableArray()
            
            objectsToShare.addObject(titleToShare)
            objectsToShare.addObject(myWebsite)
            if(self.pageThumbImage.image != nil)
            {
            objectsToShare.addObject(self.pageThumbImage.image!)
            }
            
            let activityVC = ActivityViewController(activityItems: objectsToShare as [AnyObject], applicationActivities: nil)
            
            //New Excluded Activities Code
            activityVC.excludedActivityTypes = [UIActivityTypeAirDrop, UIActivityTypeAddToReadingList, UIActivityTypePostToFlickr, UIActivityTypeCopyToPasteboard,
            UIActivityTypeSaveToCameraRoll, UIActivityTypeAssignToContact, UIActivityTypeMessage,
            UIActivityTypeMail, UIActivityTypePostToTwitter]
            activityVC.popoverPresentationController?.sourceView = sender as? UIView
            self.presentViewController(activityVC, animated: true, completion: nil)
        }
        
        /*
        
        // 1
        let optionMenu = UIAlertController(title: nil, message: "请选择", preferredStyle: .ActionSheet)
        
        
        //3
        let favoriteAction = UIAlertAction(title: "收藏", style: .Default, handler: {
            (alert: UIAlertAction!) -> Void in
            print("Favorite")
        })
        
        //4
        let shareAction = UIAlertAction(title: "分享", style: .Default, handler: {
            (alert: UIAlertAction!) -> Void in
            print("Share")
            self.shareBtnPressed()
        })
        
        //5
        let cancelAction = UIAlertAction(title: "取消", style: .Cancel, handler: {
            (alert: UIAlertAction!) -> Void in
            print("Cancel")
        })
        
        
        // 6
        optionMenu.addAction(favoriteAction)
        optionMenu.addAction(shareAction)
        optionMenu.addAction(cancelAction)
        
        // 7
        self.presentViewController(optionMenu, animated: true, completion: nil)*/
        
    }
    
    @IBAction func backBtnPressed(sender: AnyObject) {
        let transition: CATransition = CATransition()
        let timeFunc : CAMediaTimingFunction = CAMediaTimingFunction(name: kCAMediaTimingFunctionEaseInEaseOut)
        transition.duration = 0.25
        transition.timingFunction = timeFunc
        transition.type = kCATransitionPush
        transition.subtype = kCATransitionFromLeft
        self.navigationController?.view.layer.addAnimation(transition, forKey: kCATransition)
        
        self.navigationController?.popViewControllerAnimated(true)
        
    }
    
    /*func shareBtnPressed()
    {
        // 1
        let optionMenu = UIAlertController(title: nil, message: "请选择", preferredStyle: .ActionSheet)
        
        // 2
        let wechatContactsAction = UIAlertAction(title: "微信好友", style: .Default, handler: {
            (alert: UIAlertAction!) -> Void in
            print("WeChat contacts.")
            
            let mediaMsg : WXMediaMessage =  WXMediaMessage.init()
            self.initWxMediaMsg(mediaMsg)
            self.shareWxMediaMsg(mediaMsg)
            
            
        })
        let wechatMomentsAction = UIAlertAction(title: "微信朋友圈", style: .Default, handler: {
            (alert: UIAlertAction!) -> Void in
            print("WeChat moments.")
            let mediaMsg : WXMediaMessage =  WXMediaMessage.init()
            self.initWxMediaMsg(mediaMsg)
            self.shareWxMediaMsg(mediaMsg)
        })
        
        //3
        let cancelAction = UIAlertAction(title: "取消", style: .Cancel, handler: {
            (alert: UIAlertAction!) -> Void in
            print("Cancel")
        })
        
        
        //4
        optionMenu.addAction(wechatContactsAction)
        optionMenu.addAction(wechatMomentsAction)
        optionMenu.addAction(cancelAction)
        
        //5
        self.presentViewController(optionMenu, animated: true, completion: nil)
    }*/
    
    // MARK: Progress bar
    
    func timerCallback() {
        if self.theBool {
            if self.progressView.progress >= 1 {
                UIView.animateWithDuration(0.2, animations: { () -> Void in
                    self.progressView.hidden=true
                    
                    //                    }, completion: { (success:Bool) -> Void in
                    //                        self.myProgressView.hidden = true
                })
                self.myTimer.invalidate()
            } else {
                //Loaded and zoom to finish
                let number = drand48() / 40
                //  print("finished:\(number)")
                
                self.progressView.progress += Float(number)
            }
            
        } else {
            //Start slow
            if self.progressView.progress >= 0.00 && self.progressView.progress <= 0.10 {
                let number = drand48() / 8000;
                //  print("Start:\(number)")
                
                self.progressView.progress += Float(number)
                //Middle speed up a bit
            } else if self.progressView.progress >= 0.10 && self.progressView.progress <= 0.42 {
                let smallerNumber = drand48() / 2000;
                self.progressView.progress += Float(smallerNumber)
                //  print("Middle:\(smallerNumber)")
                
                //slow it down again
            } else if progressView.progress >= 0.42 && self.progressView.progress <= 0.80 {
                let superSmallNumber = drand48() / 8000;
                self.progressView.progress += Float(superSmallNumber)
                //  print("slow it down:\(superSmallNumber)")
                
                //Stop it
            } else if progressView.progress == 0.80 {
                print("Stop:\(progressView.progress)")
                self.progressView.progress = 0.80
            }
        }
    }
    
    // MARK: Share on WeChat
    
    
    func shareWxMediaMsg(mediaMsg :WXMediaMessage)
    {
        let wxWebPageObj : WXWebpageObject = WXWebpageObject.init()
        wxWebPageObj.webpageUrl = self.urlToLoad
        mediaMsg.mediaObject = wxWebPageObj
        
        let req : SendMessageToWXReq = SendMessageToWXReq.init()
        req.bText = false
        req.message = mediaMsg
        req.scene = (Int32)(WXSceneSession.rawValue)
        
        
        if(!WXApi.sendReq(req))
        {
            let alertController = UIAlertController(title: "Share on WeChat", message:
                "Sharing was NOT successful!", preferredStyle: UIAlertControllerStyle.Alert)
            alertController.addAction(UIAlertAction(title: "Dismiss", style: UIAlertActionStyle.Default,handler: nil))
            
            self.presentViewController(alertController, animated: true, completion: nil)
        }
        else
        {
            
            /*let alertController = UIAlertController(title: "Share on WeChat", message:
            "Sharing was successful!", preferredStyle: UIAlertControllerStyle.Alert)
            alertController.addAction(UIAlertAction(title: "Dismiss", style: UIAlertActionStyle.Default,handler: nil))
            
            self.presentViewController(alertController, animated: true, completion: nil)*/
        }
    }
    
    func initWxMediaMsg(mediaMsg :WXMediaMessage)
    {
        if(self.pageTitle != nil)
        {
            mediaMsg.title = self.pageTitle
        }
        else
        {
            if(self.urlToLoad != nil)
            {
                mediaMsg.title = self.urlToLoad!
            }
            else
            {
                mediaMsg.title = "Title"
            }
            
        }
        if(self.urlToLoad != nil)
        {
            mediaMsg.description = self.urlToLoad!
            
        }
        else
        {
            mediaMsg.description = "Link"
        }
        /*
        if(self.pageThumbImage.image != nil)
        {
        let MAX_IMG_SIZE : CGFloat = 32.0
        let maxFileSize : CGFloat = MAX_IMG_SIZE * 1024
        var img : NSData = NSData(data: UIImageJPEGRepresentation(self.pageThumbImage.image!, 1.0)!)
        if(CGFloat(img.length) > maxFileSize)
        {
            img = NSData(data: UIImageJPEGRepresentation(self.pageThumbImage.image!, maxFileSize/CGFloat(img.length))!)
            print(img.length)
            if(CGFloat(img.length) < maxFileSize)
            {
                mediaMsg.setThumbImage(UIImage.init(data: img))
            }
        
        }
        //mediaMsg.setThumbImage(self.pageThumbImage.image!)
        }*/
        
        // Data object to fetch weather data
        /*do {
        let data = try NSData(contentsOfURL:  NSURL(string: "http://bellevuecollection.com/app/uploads/2015/09/TBC-Web-Home-SOL-Spring-1_FINAL.jpg")!, options: NSDataReadingOptions())
        mediaMsg.thumbData = data
        
        
        } catch {
        print(error)
        }*/
        print(mediaMsg.title)
        print(mediaMsg.description)
        print(self.urlToLoad)
    }
    
    func onResp(resp: BaseResp!) {
        if(resp.isKindOfClass(SendMessageToWXResp))
        {
            let alertController = UIAlertController(title: "Share on WeChat", message:
                "Result " + String(resp.errCode) + " " + resp.errStr, preferredStyle: UIAlertControllerStyle.Alert)
            alertController.addAction(UIAlertAction(title: "Dismiss", style: UIAlertActionStyle.Default,handler: nil))
            
            self.presentViewController(alertController, animated: true, completion: nil)
        }
        
    }
    
    class ActivityViewController: UIActivityViewController {
        
        func _shouldExcludeActivityType(activity: UIActivity) -> Bool {
            let activityTypesToExclude = [
                "com.apple.reminders.RemindersEditorExtension",
                "com.apple.mobilenotes.SharingExtension",
                UIActivityTypePrint,
                UIActivityTypeAssignToContact,
                "com.google.Drive.ShareExtension"
            ]
            
            if let actType = activity.activityType() {
                if activityTypesToExclude.contains(actType) {
                    return true
                }
                else if super.excludedActivityTypes != nil {
                    return super.excludedActivityTypes!.contains(actType)
                }
            }
            return false
        }
        
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
}
