//
//  AppDelegate.swift
//  CCS China Portal
//
//  Created by CCS China Portal on 10/10/15.
//  Copyright © 2015 CCS China Portal. All rights reserved.
//

import UIKit

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {

    var window: UIWindow?


    func application(application: UIApplication, didFinishLaunchingWithOptions launchOptions: [NSObject: AnyObject]?) -> Bool {
        // Override point for customization after application launch.
        self.initBeaconBroadCast()
        return true
    }
    
    func initBeaconBroadCast()
    {
        // the code is taken from the demo code
        let beaconID : SBKBeaconID  = SBKBeaconID(proximityUUID: SBKSensoroDefaultProximityUUID);
        SBKBeaconManager.sharedInstance().startRangingBeaconsWithID(beaconID, wakeUpApplication: true);
        SBKBeaconManager.sharedInstance().requestAlwaysAuthorization();
        SBKBeaconManager.sharedInstance().addBroadcastKey(CCSSensoroConstants.broadcastKey);
    }
    
    func applicationWillResignActive(application: UIApplication) {
        // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
        // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
    }

    func applicationDidEnterBackground(application: UIApplication) {
        // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
        // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
        
        //let navigationController:UINavigationController = self.window?.rootViewController as! UINavigationController
        //let viewController:ViewController = navigationController.viewControllers.first as! ViewController
        let viewController:CCSViewController = self.window?.rootViewController as! CCSViewController
        viewController.stopLocation();
        
    }

    func applicationWillEnterForeground(application: UIApplication) {
        // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
        let viewController:CCSViewController = self.window?.rootViewController as! CCSViewController
        viewController.startLocation();
    }

    func applicationDidBecomeActive(application: UIApplication) {
        // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    }

    func applicationWillTerminate(application: UIApplication) {
        // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    }

    
       
    
}

