//
//  ViewController.swift
//  CCS China Portal
//
//  Created by CCS China Portal on 10/10/15.
//  Copyright © 2015 CCS China Portal. All rights reserved.
//

import UIKit


class CCSViewController: UIViewController , SBKBeaconManagerDelegate, CBCentralManagerDelegate, UIWebViewDelegate, WXApiDelegate, BMKMapViewDelegate, BMKLocationServiceDelegate {
    
   
    var locationService: BMKLocationService!
    @IBOutlet var versionLbl: UILabel!
    @IBOutlet var easyJsWebView: EasyJSWebView!
    
    @IBOutlet var detectedBeaconsLbl: UILabel!
    @IBOutlet var loadingView: UIView!
    @IBOutlet var activityIndicator : UIActivityIndicatorView!
    

    //var  locationManager =  CLLocationManager();
    var CM :  CBCentralManager? = nil;
    var serialNumberToBeacon: [String:SBKBeacon] = [String:SBKBeacon]();
    var orderedList = [SBKBeacon]()
    var lat : Double? = nil;
    var lng : Double? = nil;
    
    
    var latBefore : String? = nil;
    var lngBefore : String? = nil;
    let webViewManager : CCSWebViewManager = CCSWebViewManager()
    let activityIndicatorManager : CCSActivityIndicatorManager = CCSActivityIndicatorManager()
    let sensoroManager :  CCSSensoroManager = CCSSensoroManager.sharedInstance
    func initLoadingView()
    {
        loadingView.frame = CGRectMake(0, 0, 80, 80)
        loadingView.center = self.view.center
        loadingView.backgroundColor = UIColor.blackColor()
        loadingView.alpha = 0.7
        loadingView.clipsToBounds = true
        loadingView.layer.cornerRadius = 10
        loadingView.hidden = true
        activityIndicator.transform = CGAffineTransformMakeScale(2.0, 2.0);
        activityIndicator.hidesWhenStopped = true
    }
    
    required init?(coder aDecoder: NSCoder) {
        print("one");
        super.init(coder: aDecoder);
        UIView.setAnimationsEnabled(false);
    }
    
    override init(nibName nibNameOrNil: String!, bundle nibBundleOrNil: NSBundle!) {
        print("two");
        super.init(nibName:nil, bundle:nil);
        UIView.setAnimationsEnabled(false);
    }
    
    /*
    
    func locationManager(manager: CLLocationManager, didUpdateLocations locations: [CLLocation]) {
        let crnLoc = locations.last;
        print(crnLoc?.coordinate.latitude)
        print(crnLoc?.coordinate.longitude)
        
        lat = NSString(format:"%f", (crnLoc?.coordinate.latitude)!) as String;
        lng = NSString(format:"%f", (crnLoc?.coordinate.longitude)!) as String;
        print(lat)
        print(lng)
        
    }
    
    func locationManager(manager: CLLocationManager, didFailWithError error: NSError) {
        
        
        
        /*let alertView = UIAlertController(title: "Error", message: "Please enable location services from the settings.", preferredStyle: .Alert)
        alertView.addAction(UIAlertAction(title: "Got it!", style: .Default, handler: nil))
        presentViewController(alertView, animated: true, completion: nil)*/
        print("Error: " + error.description);
        
    }
    */
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        //向微信注册
        WXApi.registerApp(WECHAT_APP_ID, withDescription: CCSWeChatConstants.appDescription);
      
        if(SBKBeaconManager.sharedInstance() != nil)
        {
            SBKBeaconManager.sharedInstance().delegate  = CCSSensoroManager.sharedInstance;
        }
        initLoadingView()
        initLocService()
        initWebView()
        webViewManager.loadUrlInWebView(easyJsWebView, url: CCSUrlConstants.homeUrl)
        
    }
    
    func setVendorLocation()
    {
        
        print("setvendorlocation")
        
        if(lat != nil && lng != nil)
        {
            objc_sync_enter(self);
            print(lat!);
            print(lng!);
            easyJsWebView.stringByEvaluatingJavaScriptFromString(NSString(format: "SetVendorLocationWithCoordinates(\"%f\", \"%f\");", lat!, lng!) as String);
            objc_sync_exit(self);
        }
    }
    func initWebView()
    {
        let userAgent = UIWebView().stringByEvaluatingJavaScriptFromString("navigator.userAgent")! + " " + CCSBasicConstants.userAgent
        NSUserDefaults.standardUserDefaults().registerDefaults(["UserAgent" : userAgent])
        easyJsWebView.proxyDelegate.realDelegate = self;
        let interface =  MyJSInterface.init(viewController: self);
        easyJsWebView.addJavascriptInterfaces(interface, withName: CCSBasicConstants.easyJsInterfaceName);
        easyJsWebView.backgroundColor  = UIColor.clearColor()
    }
    
    func initLocService()
    {
        locationService = BMKLocationService()
        locationService.allowsBackgroundLocationUpdates = true
        startLocation();
    }
    
    override func viewWillAppear(animated: Bool) {
        super.viewWillAppear(animated)
        locationService.delegate = self
    }
    
    override func viewWillDisappear(animated: Bool) {
        super.viewWillDisappear(animated)
        locationService.delegate = self
    }
    
    func webViewDidFinishLoad(webView: UIWebView) {
        activityIndicatorManager.stopActivityIndicator(activityIndicator, loadingView: loadingView)
        
        let urlLoaded : String? = webView.request?.URL?.absoluteString;
        
        print("WebViewFinishedLoading for ", urlLoaded);
        
    }
    func webViewDidStartLoad(webView: UIWebView) {
        activityIndicatorManager.startActivityIndicator(activityIndicator, loadingView: loadingView)
    }
    
    
    func webView(webView: UIWebView, shouldStartLoadWithRequest request: NSURLRequest, navigationType: UIWebViewNavigationType) -> Bool {
        return true;
    }
    func webView(webView: UIWebView, didFailLoadWithError error: NSError?)
    {
        activityIndicatorManager.stopActivityIndicator(activityIndicator, loadingView: loadingView);
    }
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func displayLocationInfo(placemark: CLPlacemark) {
        
        //stop updating location to save battery life
        //locationManager.stopUpdatingLocation()
        print(placemark.locality != nil ? placemark.locality : "")
        print(placemark.postalCode != nil ? placemark.postalCode : "")
        print(placemark.administrativeArea != nil ? placemark.administrativeArea : "")
        print(placemark.country != nil ? placemark.country : "")
        
    }
    
    func checkBluetoothServices() -> Bool
    {
        if (self.CM == nil) {
            self.CM =  CBCentralManager(delegate: self, queue: nil);
        }
        if (self.CM!.state == CBCentralManagerState.PoweredOff) {
            return false;
        }
        else if(self.CM!.state == CBCentralManagerState.PoweredOn){
            return true;
        }
        return true;
    }
    
    func centralManagerDidUpdateState(central: CBCentralManager) {
        
    }
    
    // MARK: - BMKMapViewDelegate
    // MARK: - BMKLocationServiceDelegate
    
    /**
    *在地图View将要启动定位时，会调用此函数
    *@param mapView 地图View
    */
    func willStartLocatingUser() {
        print("willStartLocatingUser");
    }
    
    /**
     *用户方向更新后，会调用此函数
     *@param userLocation 新的用户位置
     */
    func didUpdateUserHeading(userLocation: BMKUserLocation!) {
        //print("heading is \(userLocation.heading)")
    }
    
    /**
     *用户位置更新后，会调用此函数
     *@param userLocation 新的用户位置
     */
    func didUpdateBMKUserLocation(userLocation: BMKUserLocation!) {
        
        
        let detectedLat : Double  = userLocation.location.coordinate.latitude;
        let detectedLng : Double = userLocation.location.coordinate.longitude;
        
        latBefore = String(detectedLat) ;
        lngBefore = String(detectedLng);
        
        //print("didUpdateUserLocationBefore lat:\(latBefore) lon:\(lngBefore)")
        
        //let latLngModel : CCSUtilities.LatLngModel =  CCSUtilities.bd2gcj(detectedLat, bdLng: detectedLng)
        
        lat = detectedLat//String(latLngModel.lat)
        lng = detectedLng//String(latLngModel.lng)
        
    }
    
    /**
     *在地图View停止定位后，会调用此函数
     *@param mapView 地图View
     */
    func didStopLocatingUser() {
        print("didStopLocatingUser")
    }
    
    func startLocation() {
        print("进入普通定位态");
        locationService.startUserLocationService()
        
    }
    
    func stopLocation() {
        locationService.stopUserLocationService()
    }


}

